#include <hush/source.h>
#include "transform.h"



transform::transform() {		
	
	_translation[0] = 0; _translation[1] = 0; _translation[2] = 0;	
	_scale[0] = 1; _scale[1] = 1; _scale[2] = 1;
	_rotation[0] = 0; _rotation[1] = 0; _rotation[2] = 0; _rotation[3] = 0;
}
	
	transform::~transform() {}
	
	
	void transform::translation(float x, float y, float z) {
	_translation[0] = x; _translation[1] = y; _translation[2] = z;	
	}
	

	void transform::scale(float x, float y, float z){
    _scale[0] = x; _scale[1] = y; _scale[2] = z;
	}
	
	
	void transform::rotation(float x, float y, float z, float r){
    _rotation[0] = x; _rotation[1] = y; _rotation[2] = z; _rotation[3] = r;
	}
	
/*	
	float[3] transform::translation(){
		return _translation;
	}
	
	
	float[3] transform::scale(){
		return _scale;
	}
	
	float[4] transform::rotation(){
		returm _rotation;
	}
*/	


	void  transform::get(IDirect3DDevice9* device, D3DXMATRIX* mat) {
		device->GetTransform( D3DTS_WORLD, mat );
	}

	
	void  transform::set(IDirect3DDevice9* device, D3DXMATRIX* mat) {
		device->SetTransform( D3DTS_WORLD, mat );
	}



	void  transform::get(D3DXMATRIX* mat) {
		D3DXMatrixIdentity(mat);

	
	D3DXMATRIXA16 w; // = *world();
	D3DXMatrixIdentity( &w );
    
	    
		D3DXMatrixRotationX( &w, _rotation[0] * _rotation[3]);
		*mat = *mat * w;
		D3DXMatrixRotationY( &w, _rotation[1] * _rotation[3]);
		*mat = *mat * w;
		D3DXMatrixRotationZ( &w, _rotation[2] * _rotation[3]);
        *mat = *mat * w;
		(*mat)._11 = _scale[0]; //(*mat)._12 = 0.00f; (*mat)._13 = 0.00f; (*mat)._14 = 0.00f;
        /*(*mat)._21 = 0.00f;*/ (*mat)._22 =_scale[1]; // (*mat)._23 = 0.00f; (*mat)._24 = 0.00f;
        /* (*mat)._31 = 0.00f; (*mat)._32 = 0.00f; */ (*mat)._33 = _scale[2];// (*mat)._34 = 0.00f;
        (*mat)._41 = _translation[0]; (*mat)._42 = _translation[1]; (*mat)._43 = _translation[2];
		//(*mat)._44 = 1;

		//D3DXMatrixRotationX( mat, _rotation[0] * _rotation[3]);
		//D3DXMatrixRotationY( mat, _rotation[1] * _rotation[3]);
		//D3DXMatrixRotationZ( mat, _rotation[2] * _rotation[3]);
	}

	void  transform::set(IDirect3DDevice9* device, int t) {

		D3DXMATRIX mat;
		//D3DXMatrixIdentity( mat);
		get(&mat);
		if (t == 0) device->SetTransform( D3DTS_WORLD, &mat );
		else device->MultiplyTransform( D3DTS_WORLD, &mat );
	}
