

#include "scene-0.h"

// sub scenes

#include "objects/cylinder-scene.h"
#include "objects/plane-scene.h"
#include "objects/background-scene.h"
#include "objects/image-scene.h"
#include "objects/sub-scene.h"



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


scene_0::scene_0() 
{


scale(0.9f,0.9f,0.9f);
translation(0,0,1);


count = 6;
_exclude[0] = 0;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 0; 
_exclude[4] = 0;
_exclude[5] = 0;


scenes[0] = new cylinder_scene();
//scenes[3] = new cylinder_scene(1);
//scenes[2] = new cylinder_scene(2);
scenes[1] = new plane_scene();
//scenes[2] = new background_scene(_T("C:/AE/media/soutine.jpg"));
scenes[2] = new background_scene();

scenes[3] = new sub_scene();
scenes[3]->scale(1.2f,1.2f,1.2f);
//scenes[4] = new image_scene(_T("C:/AE/media/soutine.jpg"));
scenes[4] = new image_scene();
scenes[4]->scale(0.9f,0.9f,0.9f);
scenes[4]->translation(-3.0f,0.0f,3.0f);
//scenes[4]->rotation(0.0f,0.5f,0.5f,1); // this is naive rotation
//scenes[4]->mode(0); // 0 = absolute


//scenes[5] = new image_scene(_T("C:/AE/media/soutine.jpg"));
scenes[5] = new image_scene();
scenes[5]->scale(1.0f,1.0f,1.0f);
scenes[5]->translation(0.0f,0.0f,-1.0f);
//scenes[5]->rotation(0.0f,0.5f,0.5f,1); // this is naive rotation

_shader = "scene";
opt("nofx","1");
iopt("overlay",1);

}

scene_0::~scene_0()
{
//delete scenes[];
}

HRESULT 
scene_0::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	// anything else ?

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
scene_0::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	

    return hr;
}


HRESULT 
scene_0::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

if (opt("tx")) _texture = tx(opt("tx"));
if (_texture) texture = _texture;




static icount = 0;

static float distance = 1.0f;

distance += 0.008f;

scenes[4]->scale(distance,distance,distance);


	//Restore(device);

	render_begin(device);

	

    // begin the scene_0


	hr = scene::render(device,texture); // calls compose, restore,  render

    
	render_end(device);

 

    return hr;
}

