
#ifndef dossier_h
#define dossier_h

#include <hush/export.h>
#include "scene/scene.h"
#include <direct/drumpad.h>


class HUSH_API dossier : public scene  
{
public:

    dossier(char* opts = 0);

	int operator()();
    virtual ~dossier();
    virtual int _load();
	virtual int _restore();
    virtual int _render();

	int ch(char* x=0);
	int exec(char* x=0);

	void toggle_ds(char* k);
	void toggle_opt(char* k);
	void toggle_lst(char* k);
	void toggle_text(char* k);
	void toggle_game(char* k);
	void toggle_slides(char* k);
	void toggle_lecture(char* k);

	int handle(char* type, char* ev);

char _command[64];
int _pcm;
int _inexec;
char _cmode;
char _metac;
char _lastc;
char moved[10];
int moving;

scene* _lecture;
scene* _game;
DrumPad* _drumpad;
DrumPad* _drumpads[10];
int _drumidx;

private:
float txdur;
int alternate;
};
#endif 
