
#ifndef image_h
#define image_h
#include <hush/export.h>

#include "scene/scene.h"
//#include <atlbase.h>

//#undef _UNICODE
//#include <atlbase.h>
//#include <atlcomcli.h>
//#define _UNICODE

//#include <commdlg.h>

//#define NUM_VERTICES1 4

class HUSH_API image : public scene  
{
public:

    image(char* = 0); // capture or image(string)
	image(TCHAR* path, TCHAR* name, int from, int to, TCHAR* ext = _T("jpg"));

	scene* create(char* opts = 0);


    virtual ~image();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );

    virtual void rectangle( float fTU, float fTV );


public:
	//void index(int i);
	//int index();
	int next(int t =0);
private:
 //   int state;  // 0 image, 1 capture
	TCHAR* _image;

	void init();

#define MAXTEXTURES 256

	LPDIRECT3DTEXTURE9				_imgtexture;
	LPDIRECT3DTEXTURE9				_textures[MAXTEXTURES];

	struct CUSTOMVERTEX
    {
        struct Position {
            Position() : 
                x(0.0f),y(0.0f),z(0.0f) {            
            };
            Position(float x_, float y_, float z_) :
                x(x_),y(y_),z(z_) {
            };
            float x,y,z;
        };

        Position    position; // The position
        D3DCOLOR    color;    // The color
        FLOAT       tu, tv;   // The texture coordinates
    };

    CUSTOMVERTEX                    m_vertices[4];
    //CComPtr<IDirect3DVertexBuffer9> m_vertexBuffer;
	IDirect3DVertexBuffer9* m_vertexBuffer;
	

    DWORD  m_time;
	int initialized;

	TCHAR* _path;
	TCHAR* _name;
	TCHAR* _ext;
	int _from;
	int _to;

	//int _cnt;
	//int _idx;

	//double _rate;
	//double _xtime;

};
#endif 
