#include <hush/source.h>
#include "sim.h"
//#include <atlbase.h>
#include <streams.h>

//#define _UNICODE
//#include <tchar.h>
//#include <comutil.h>

#include <hush/sim/sim.h>

#define BUFFERSIZE 20
static int g_inc = 0;
static int g_outc = 0;
//static int g_ev = 0;

// enum {NOLEFT,QUIT,END,COUNT,REALTIME};

enum {ARRIVAL,DEPARTURE};

static simulation* x_sim;


generator* g1,*g2;
resource* servicepoint;
queue* q;

class customer : public entity
{ 
  public :
    customer(int ph);
    virtual int operator()();
};

static customer* g_c;

class server : public entity
{
  public :
    server();
    virtual int operator()();
};


customer::customer(int ph) : entity(ph)
{

}


// actions of the customer.
int customer::operator()()
{
  customer *c;
  //queuingpriority(2);        // adjust queuing priority
 //schedulingpriority(2);    
  x_sim->passivate(this);
  x_sim -> schedule(this,4); //(g1 -> exponential(20.0)));
  g_inc++;
  return 0;
  switch (phase())
  {
    case ARRIVAL :
      // schedule next customer
      c = new customer(ARRIVAL);
      x_sim -> schedule(c,(g1 -> exponential(20.0)));
      g_inc++;
      //
      q -> append(this);
      return OK;
    case DEPARTURE :
      // release servicepoint and leave it
      servicepoint -> release();
      x_sim -> terminate(this);
	  //dvscene::_log("departure");
      g_outc++;
	  return OK;
  }
  return false;
}


server::server() : entity()
{
}

// the server takes customers, if possible and serves them.
int server::operator()()
{
	x_sim->passivate(this);
  x_sim -> schedule(this,2); //(g1 -> exponential(20.0)));
  g_outc++;
  return 0;
  while ( (!(q -> empty())) && (servicepoint -> available()) )
  {
    entity* c = (entity *)q -> removefront();

    // acquire servicepoint and schedule departure
    servicepoint -> acquire();
    c -> phase(DEPARTURE);
    x_sim -> schedule(c,(g2 -> exponential(21.2)));
	//dvscene::_log("server");
  }
  return OK;
}
    



static char* _help = "sim";
//static msg_array msg;
static char* msg[12][12];
static char _hold[12][512];





int vip_sim::operator()()
{
  //customer *c;
	check_cs();
    CAutoLock lock(_cs);
	static int toggle = 0;
	//if (!toggle) { toggle = 1; return OK; }
	//toggle = 0;

	//_sim->factor(1);
	if (0 && g_ev == 10) {
		static char buf[512];
		_tk->source(loc("/vip/bin/scene.pl"));
		
	  _help = _tk->strvalue("X:title(X)");
	  strcpy(buf,_help);
	  _help = (char*) buf;
	}
	  if (1) {
	  toggle++;
	  if (toggle == 2) toggle = 0;
  g_ev++;;
  //_sim->withdraw(this);
  _sim->passivate(this);
  _sim->schedule(this,1.0);
  }
  // _sim ->wait(1.0);
 // _help = (char*) _hold[0];
//	strcpy(_hold[0],  _tk->strvalue("X:scene(X)"));
  return 1;
  
}

vip_sim::vip_sim(int size) 
{
_size = 20; //size;
wsprintf(_type,"vip_sim");
_letterset = "Times New Roman";
_display = _type;


//_letterset = "Monotype Corsiva";
//_letterset = "MS Mincho";
clear(&msg);

g_ev = 0;

if (1) {
_tk->source(loc("/vip/bin/scene.pl"));
_tk->evaluate("_:s(1)");
_tk->evaluate("_:s(2)");
//_help = _tk->strvalue("X:run(X)");
if (1) {
_tk->eval("X:run(X)");
char* p = 0;
int i = 0;
while (p = _tk->result()) {
  wsprintf(_hold[i],p);
  msg[0][i++] = (char*) _hold[i];
}
}
}


_help = _tk->strvalue("X:title(X)");

_msg = &msg;

//x_sim = new simulation();
 x_sim = _sim;
 //_sim->factor(2.0);
 //_sim->speed(2.0);
  //phase(ARRIVAL);
  //_sim->speed(1);

  g1 = new generator(255,89,1009);
  g2 = new generator(1000,8,77);
 
  histogram* h1 = new histogram(".h1","-columnwidth 3 -type weighted -title size");
  histogram* h2 = new histogram(".h2","-title waitingtimes");
  //tk -> pack(h1) -> pack(h2);
  toplevel* t = new toplevel(".moving_average");
  histogram* h3 = new histogram(t,".h1","-columnwidth 20 -columns 24 -type series -title moving_average_size");
  histogram* h4 = new histogram(t,".h2","-columnwidth 20 -columns 24 -type series -title moving_average_waitingtimes");
  //tk -> pack(h3);
  //tk -> pack(h4);

  /*
  q = new queue();
  q -> reportsize(h1);
  q -> reportwaiting(h2);

  analysis* a1 = new analysis(h1);
  a1 -> behavior(h3,BUFFERSIZE);
  analysis* a2 = new analysis(h2);
  a2 -> behavior(h4,BUFFERSIZE);
  */
  servicepoint = new resource(1);
  _sim->factor(1);
  _sim->speed(1);
  //_sim->realtime(1.0);
  _sim->passivate(this);
  _sim -> schedule(this,0.0); //1000.0/5.0); //(g1 -> exponential(100.00)));

  // initially a customer arrives and the server is conditional
 customer* c = new customer(ARRIVAL);
 g_c = c;
 
 // phase(ARRIVAL);
 _sim -> schedule(c,0.0);
 // _sim->realtime(10.0);

  server* sr = new server();
  //_sim -> hold(sr);
  _sim -> schedule(sr,0.0);
  
  
  //_sim->realtime(1.0);

 //queuingpriority(1);        // adjust queuing priority
 schedulingpriority(10);     // adjust scheduling priority



  // run for 8 hours
 //_sim -> run(60.0);

  
}



vip_sim::~vip_sim()
{
//delete scenes[];
}

HRESULT 
vip_sim::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    
	//if (is("menu")) { index(_selection+1); }
	
	
	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
vip_sim::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
vip_sim::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

    state = 1;

    //_sim->run2(0.01,0,false);
   //_sim->realtime(2.0);
	//_sim->speed(10);
	//_sim->factor(0.5);


	//_sim->speed(10.0);
	//_sim->run(0.05);
	//_sim->run(0.01,0,false);
	//_sim->passivate(this);

	//_sim -> schedule(this,(g1 -> exponential(10.0)));//0.1); //1000.0/5.0); //(g1 -> exponential(100.00)));
	//_sim -> schedule(this,1.0);//0.1); //1000.0/5.0); //(g1 -> exponential(100.00)));
	//_sim -> schedule(this,1.0);
	//_sim->passivate(this);

    //_sim->wait(1.0);

	render_begin(device);

    
    _cmi = 0; // state;//state+1;
    

	if(_idx >= _max) _idx = 0;
	

	hr = scene::render(device,texture); // calls compose, restore,  render


    
    //_selection = 0;

	if (1) for (int i=1; i <= 12; i++) { 
		if ((*_msg)[_cmi][i-1]) {
			if (i == _idx) {
				message(_x,_y + (i-1)*_inc,_alt,(*_msg)[_cmi][i-1]);
				if (_enabled) _selection = i-1;
			}
			else 
				message(_x,_y + (i-1)*_inc,_color,(*_msg)[_cmi][i-1]);
		}

	}
    //TCHAR
	if (1) {

		int nn = 0;
		char* p = _display;
		
		if (1) {
		char x[256];
	
		message(100,_y-100-nn*20,argb(180,133,197,235),fm("[%3.2f] %s:: %s [%d] (%d,%d) -- %3.2f [%3.2f,%3.2f]",_sim->realtime(),_help,
			p,g_ev, g_inc,g_outc,
			_sim->clock(),((entity*)this)->entity::time(),g_c->time()));  //dvscene::_log()));
		}

	display(_display);
	
	}
	
    
	render_end(device);

 

    return hr;
}

