#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "sebas.h"


int text_sebas::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_sebas::create(char* opts) { return new text_sebas(opts); }

text_sebas::text_sebas(char* opts) 
{
  
	clear(&msg);

	_color = argb(80,70,70,120);

	//opt("style","plain");
	opt("display","party   S & K");
	opt("text(title)","party S & K ");
	opt("text(sub)","      digital                          party");
	opt("space","vip/morph");

	//opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","party");
	opt("logo(3ds)","S & K");
	opt("logo(vip)","party");

	sc("slides",new slides("..\\present\\sebas","img0",1,3,"jpg"));

	// --------------------------------------------------------

	msg[5][11] = "http://www.ketelhuis.nl";

   	msg[0][1] = "the party";
	msg[0][3] = "focusses";
	msg[0][5] = "on personal interaction";
	msg[0][7] = "and contains";
	msg[0][9] = "no relevant information";
	msg[0][11] = "so enjoy";
	


	msg[2][0] = "the beauty of";
	msg[2][1] = " mathematics";
	msg[2][2] = "although";
	msg[2][3] = " biology ";
	msg[2][4] = "deals with life";
	msg[2][5] = " psychology";
	msg[2][6] = "with mind ";
	msg[2][7] = " art";
	msg[2][8] = "with existence ";
	msg[2][9] = " is universal";
	msg[2][10] = "but movies tell all";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "dance first";
	msg[3][3] = "                        think later";
	//msg[3][4] = "it's";
	msg[3][7] = "it's the natural order ";
	//msg[3][8] = "watch";
	//msg[3][9] = "                        survive";
	//msg[3][11] = "listen ";

	/*msg[3][0] = "in this party ";
	msg[3][3] = "you may dance ";
	msg[3][4] = "you may chat";
	msg[3][7] = "you may flirt";
	msg[3][8] = "you may watch";
	msg[3][9] = "you may drink";
	msg[3][11] = "you may even ....";
*/
	
	msg[4][1] = "      THERE OUGHT";
	msg[4][3] = "      TO BE";	
	msg[4][5] = "      MORE DANCING";
	msg[4][9] = "      Ketelhuis Amsterdam";



}

text_sebas::~text_sebas()
{
//delete scenes[];
}

int 
text_sebas::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_sebas::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_sebas::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

