#include <hush/source.h>

#include "sm.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
#include "sm.h"

#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>

//#include <ch/extern/embedch.h>
//#include "sampclass.h"

//#include "shader.h"




static char* _help = "sm";
static scene* dolphin;


int vip_sm::ch() {



    char *argvv[]={"script.ch", NULL};
    int status = 0;

	/*
    class Class1 c1;

    printf("Begin output from prog.exe:\n");  
    c1.memfun1(10);
    printf("End output from prog.exe:\n");  

    Ch_Initialize(NULL,NULL);

   
    status = Ch_RunScript(NULL, argvv);
    if(status)
      printf("Error: execution of script.cpp failed\n");
    Ch_End(NULL);
*/
	return status;

}


int vip_sm::handle(char* type, char* ev) {
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","0")) {
		int s = 0;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","1")) {
		int s = 1;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","2")) {
		int s = 2;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_sm::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_sm::vip_sm(char* opts) 
{
	
	count = 12;

_size = 20; //size;
wsprintf(_type,"vip_sm");
_display = _type;

_sim->passivate(this);
_sim -> schedule(this,0.0);


end(20);
loop = 1;



//scenes[1] = new satelite();
scenes[0] = new shader(new background(),"fx=blue");
//scenes[0]->opt("shaders","material");
scene* sc = new mesh("scene");
sc->_shader = "red";
scenes[1] = sc;
//scenes[1] = new shader(sc,"fx=red"); 
scenes[1]->rotation(0.1,-0.1,0,1.0);
scenes[1]->scale(0.2,0.2,0.2);
//scenes[2] = new shaderx(sc,"fx=bg"); 


//scenes[2] = new mesh("yt");
scenes[2] = new shader(new mesh("raven"),"fx=blue");
scenes[2]->translation(2.5,-2,-2);
scenes[2]->rotation(0,-2.57,0.2,1);
scenes[2]->scale(0.9,0.9,0.9);


//scenes[2]->scale(0.3,0.3,0.3);




scale(0.8,0.8,0.8);



 

 
  
}




vip_sm::~vip_sm()
{
//delete scenes[];
}

int 
vip_sm::_load()
{
    int hr = S_OK;

	dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];
	//scenes[0] -> load_effect("bg");
	//scenes[1] -> load_effect("material");
    
	

	
	//load_effect("bg");
	//scenes[0]->load_effect("material");


	hr = scene::init(_device); // loops through scenes

	//scenes[0]->effect("material",effect("material"));
	//scenes[1]->effect("bg");
    return hr;
}

int
vip_sm::_restore()
{
    HRESULT hr = S_OK;

	//_device->SetRenderState( D3DRS_ZENABLE,  D3DZB_TRUE );
    //_device->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
    //_device->SetRenderState( D3DRS_ALPHATESTENABLE,  FALSE );

	//scenes[0]->load_effect("material");

	//scenes[0]->_effect = effect("material");
	//scenes[1]->_effect = effect("bg");
	//scenes[0]->effect("bg");
	//scenes[1]->effect("bg");
	//_exclude[1]=0;
	//_exclude[2]=1;
	if (0) {
	if (state == 0) { 
		scenes[0]->opt("fx","bg");
		scenes[1]->opt("fx","material");
	} else
	if (0 && state == 1) { 
		scenes[0]->opt("fx","material");
		scenes[1]->opt("fx","bg");
	}
	}
	


    return hr;
}


int
vip_sm::_render( ) 
{
HRESULT hr = S_OK;
    //_exclude[0] = 0;
    //_exclude[1] = 0;
	//_exclude[2] = 1;
   
    dolphin->state = 1;
	//scenes[1]->opt("fx","bg");
	if (0) {
	if (state == 0) { 
		_exclude[1]=0;
		//scenes[0]->opt("fx","bg");
		//scenes[1]->opt("fx","material");
	} else
	if (state == 1) { 
		_exclude[2] = 0;
		//scenes[0]->opt("fx","material");
		//scenes[1]->opt("fx","bg");
	}
	}
	
	
   

	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
       //int i = 0;

 
	

	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		message(100,_y-200,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	display(_display);
    //dolphin->state = hold;
	render_end(_device);

 

    return hr;
}

