//@ A typical (active) kit

#include <hush/hush.h>
#include <hush/dv/active/kit.h>
#include <hush/dv/active/active.h>

#include <hush/export.h>

dictionary<handler>* active_kit::_handlers = 0;

#define HANDLERS ((dictionary<handler>*)_handlers)

//@ initialize

int active_kit::initialized = 0;

int active_kit::initialize() {
	cerr << "active_kit::initialize" << endl;
        if ( active_kit::initialized ) return 1;
        if ( kit::lookup("active") ) return 1;
        kit* tk = new active_kit;
        session* s = session::_default;
        if (s) s->_register(tk);
        tk->rename("active");
        kit::declare("active",tk);
        if (!kit::_default) kit::_default = tk;
        return active_kit::initialized = 1;
        }


extern int active_main(int argc, char* argv[]);

static int argc = 0;
static char* argv[] = { 0, 0 };

//@ construct

active_kit::active_kit() {
        active_main(argc,argv);
	}

active_kit::~active_kit() { }

int active_kit::source(const char* s ) {
	return 0;// active_open_file(s);
	}

long active_kit::eval(const char* s ) {
	return 0; // active_eval_command(s); 
	}

char* active_kit::result(long) {
	return 0; // active_result();
	}

//</>
