#include <hush/dv/gl/ogl/handler.h>
#include <hush/dv/gl/ogl/glob.h>
#include <hush/event.h>
#include <hush/gl/GL.h>

#include <GL/gl.h>

glob_handler::glob_handler(glob* w) {
	dragging = 0; but = 0;
	_image = w;
	}

glob* glob_handler::_glob() {
	return _image?_image:(GL::_glob);
	}

void glob_handler::press( event& e ) {
          but = e.button();
          x = e.x(); y = e.y();
          dragging = 1;
	  _ev = _event;
	  _glob()->change(but);
	  _glob()->_resize(0,0);
          }

 
void glob_handler::motion( event& e ) {  
  if (dragging) {
	cerr << "moving" << endl;
	float acc = 10;
	float dx = x - e.x();
	float dy = y - e.y();
	float dz = - (dx - dy);
        _glob()->change(but);
	glRotatef(2.5, 1.0, 0.0, 0.0);
	if (but==1) {
		cerr << "Rotate:" << but << endl;
		glScalef (0.99, 0.99, 0.99);
		//_glob->move( -dx/acc, dy/acc , dz );
	} else if (but==2) {
		glScalef (1.01, 1.01, 1.01);
		cerr << "Zooming:" << but << endl;
	} else {
		cerr << "????:" << but << endl;
        }
	_glob()->_paint();
        x = e.x(); y = e.y();
  }
}
 
void glob_handler::release( event&  ) { dragging = 0; }
