#include <hush/hush.h>
#include <hush/dv/js/kit.h>
#include <hush/dv/js/js.h>

#include <hush/export.h>


void* js_kit::_handlers = 0;

#define HANDLERS ((dictionary<handler>*)_handlers)


int js_kit::initialized = 0;

int js_kit::initialize() {
        if ( js_kit::initialized ) return 1;
        if ( kit::lookup("js") ) return 1;
        kit* tk = new js_kit;
        session* s = session::_default;
        if (s) s->_register(tk);
        tk->rename("js");
        kit::declare("js",tk);
        kit::declare("javascript",tk);
        if (!kit::_default) kit::_default = tk;
        return js_kit::initialized = 1;
        }


extern int js_main(int argc, char* argv[]);

static int argc = 0;
static char* argv[] = { 0, 0 };

js_kit::js_kit() {
        js_main(argc,argv);
	}

js_kit::~js_kit() { }

int js_kit::source(const char* s ) { return js_open_file(s); }
long js_kit::eval(const char* s ) { return js_eval_command(s); }
char* js_kit::result(long) { return js_result(); }
