#ifndef _PLUGIN_KIT_H
#define _PLUGIN_KIT_H

#include <hush/kit.h>
#include <hush/sys/bind.h>


class plugin_kit : public kit {

public:
plugin_kit();
plugin_kit(void*);

~plugin_kit();

int source(const char* file);

long eval(const char* cmd);
char* result(long id = 0);

void after(int msecs, handler* h = 0); //AE ?? doesn t work

dvbinding* bind(const char* name, handler* h);
dvbinding* bind(int fd, handler* h, int mask);

void* tkwin() const { return _root; }
void* display() const { return _display; }

void setroot(void* x) { _root = x; }
void setdisplay(void* x) { _display = x; }

private:
void* _root;
void* _display;
void* _interp;
};
#endif
