////////////////////////////////////////////////////////////////////////
//                                                                    //
// conversion.h                                                       //
//                                                                    //
// header for the real conversion from private model "md" to          //
// a C++ simulation program. 	                                      //
//                                                                    //
// (c) 1995 A.R. van der Valk, A. Eliens                              //
//                                                                    //
////////////////////////////////////////////////////////////////////////


#ifndef CONVERSION_H
#define CONVERSION_H

#include <hush/dv/sigma/model.h>

class convert 
{
private:
    model *md;
    char* _filename;

public:
    convert(char* fname = 0);
    ~convert();
    int do_conversion(char *input_file, int mode = 0); // the real conversion function
    int max_nr_edge_cond(model *m); // count max. nr of edge conditions
public:
static int mode;
};

#endif
