#include <hush/source.h>
#include <hush/dv/sp/term.h>
#include <hush/dv/sp/sp.h>


sp_term::sp_term(void* goal, void* ans) {
	_buf = 0;
	_val = 0;
	_goal = goal;
	_ans  = ans;
	_val = (char*) _goal?dvsp::next(_goal,_ans):0;
	}

sp_term::~sp_term() {
	if (_goal) dvsp::destroy(_goal);
	}


char* sp_term::operator()() {
	if (!_buf) _buf = new char[1024];
	char* result = _val?_buf:0;
	if (result) strcpy(_buf,_val);
	_val = (char*) _goal?dvsp::next(_goal,_ans):0;
	if (!_val) _goal = 0;
	return (char*) result;
	}

char* sp_term::next() {
	return (char*) (*this)();
	}

char* sp_term::aval() {
	return (char*) _val;
	}
