#include <hush/dv/tk/tcl/event.h>
#ifndef PLUGIN
#endif

#include <iostream.h>


//// event

tk_tcl_event::tk_tcl_event() : event(this) {
	tk = 0; __argc = 0; __argv = 0;
	}

tk_tcl_event::tk_tcl_event(class kit* _tk, int _argc, char* _argv[]) 
				    : event(this) {
	tk = _tk;
	__argc = _argc;
	__argv = _argv;
	}

event* tk_tcl_event::create(kit* k,int argc, char** argv) {
	event* e = new tk_tcl_event(k,argc,argv);
	return e; // AE?
	}


tk_tcl_event::~tk_tcl_event() { }
int tk_tcl_event::eventclass() const { return event::tcl; }
int tk_tcl_event::argc() const { return __argc; }
char* tk_tcl_event::arg(int i  ) const { 
	return  argv()[i];
	}
char** tk_tcl_event::argv(int i ) const { return  __argv+i; } 

event* tk_tcl_event::get() const { return (event*) this; }

//// Callback structs

tk_tcl_callback::tk_tcl_callback() {
	tk = 0; proc = 0; data = 0;
	}

tk_tcl_callback::tk_tcl_callback(kit* _tk, void* _proc, void* _data ) {
	tk = _tk; proc = _proc; data = _data;
	}

//// Callback funs

void tk_tcl_event::timer( void* data ) {
	tk_tcl_callback* x = (tk_tcl_callback*) data;
	tk_tcl_event* ev = new tk_tcl_event(x->tk,0,0);
	handler* h = (handler*) x->data;
        h->dispatch(ev);
	delete ev;
	}


int tk_tcl_event::callback(void* data , kit* tk, int argc , char** argv) {
	 event* ev = new tk_tcl_event(tk,argc,argv);
	 handler* h = (handler*) data;
	 h->dispatch(ev);
	 delete ev;
	 return 0;
}
