#ifndef _hush_dv_vrml_kit_h
#define _hush_dv_vrml_kit_h

#include <hush/kit.h>
#include <hush/dictionary.h>

class vrml_kit : public kit {
public:

char* category() const { return "vrml"; }
char* info() const { return "vrml_kit"; }

vrml_kit();
~vrml_kit();

public:
static int initialized;
static int initialize();

static dictionary<handler>* _handlers;

int source(const char* cmd);
long eval(const char* cmd);
dvbinding* bind(const char* name, handler*);
char* result(long id=0);

protected:
char* buf;
};



#endif
