#include <hush/dv/midi/kit.h>
#include <hush/query.h>
#include <hush/agent.h>

#include <string.h>
#include <stdlib.h>

midi_kit::midi_kit() {
	_query = new query("kit=pl");
	agent::_default->lookin(LIBRARY);
	_query->eval(":use(library(midi:[midi,lily,music,process]))");
	_register(_query);
	}

int midi_kit::source(const char* f) {
	return _query->source(f);
	}


long midi_kit::eval(const char* cmd) {
	return _query->eval(cmd);
	}

char* midi_kit::result(long id) {
	return _query->result(id);
	}

