#include <hush/dv/objects/kit.h>
#include <hush/event.h>
#include <hush/vm.h>

int kit_object::operator()() {
	event* e = _event;
	//cerr << category() << "::(" << e->argc() << ") " << _event->ask() << endl;

	vm<kit> self(e); 
	string method = e->_method();
	cerr << "kit_object::" << (char*) method << endl; 

	if (method == "kit") {
		//cerr << "new: " << e->arg(1) << " " << e->arg(2) << endl;
		kit* q = new kit(e->arg(1));
		_register(q);
		result( reference((void*)q) );
	} else if (method == "eval") {

		cerr << "(1)kit::eval -> " << e->arg(1) << endl;
		long res = self->eval(e->arg(1));
		cerr << "(2)kit::eval -> res: " << endl;
		result( itoa(res) );
	} else if (method == "result") {
		//cerr << "kit::result " << atoi(e->arg(1)) << endl;
		char* res = self->result( atoi(e->arg(1)) );
		result(res);
	} else if (method == "evaluate") {
		char* res = self->evaluate(e->arg(1));
		result( res );
	} else {
		return handler_object::operator()();
	}

	return 0;
	}
