#include <hush/dv/objects/scene.h>
#include <hush/scene.h>
#include <hush/event.h>
#include <hush/vm.h>

int scene_object::operator()() {
	event* e = _event;
	//cerr << "scene_object: " << category() << "::(" << e->argc() << ") " << _event->ask() << endl;

	//dvscene::_log("scene_object");
	vm<dvscene> self(e); 
	int argc = e->argc();
	string method = e->_method();
	//cerr << "scene_object::" << (char*) method << endl; 
	char buf[256];
	sprintf(buf,"scene: %s", (char*) method);
	


	if (method == "scene") {
	    cerr << "new: " << e->ask() << endl;
		dvscene* q = new dvscene();
		_register(q);
		//sprintf(buf,"'%s'",reference((void*)q));
		//result(buf);
		result( reference((void*)q) );
		//result("ascene");
		sprintf(buf,"scene: %s (%s)", (char*) method, reference((void*) q));
	} else if (method == "read") {
		//cerr << "read: " << e->arg(1) << endl;//,e->arg(2));

		sprintf(buf,"scene: %s (%s)", (char*) method, e->arg(1));
	} else if (method == "talk") {
		//cerr << "read: " << e->arg(1) << endl;//,e->arg(2));

		sprintf(buf,"scene: %s (%s)", (char*) method, e->arg(1));
		dvscene* q = new dvscene();
		_register(q);
		sprintf(buf,"hi(%s)",reference((void*)q));
		result(buf);
		//result("hi");
	} else {
		return handler_object::operator()();
	}
    //dvscene::_log(buf);
	return 0;
	}
