#include <hush/source.h>
#include <hush/dv/pl/term.h>
#include <hush/dv/pl/pl.h>


pl_term::pl_term(void* goal, void* ans) {
	_buf = 0;
	_val = 0;
	_goal = goal;
	_ans  = ans;
	_val = (char*) _goal?dvpl::next(_goal,_ans):0;
	}

pl_term::~pl_term() {
	if (_goal) dvpl::destroy(_goal);
	}


char* pl_term::operator()() {
	if (!_buf) _buf = new char[1024];
	char* result = _val?_buf:0;
	if (result) strcpy(_buf,_val);
	_val = (char*) _goal?dvpl::next(_goal,_ans):0;
	if (!_val) _goal = 0;
	return (char*) result;
	}

char* pl_term::next() {
	return (char*) (*this)();
	}

char* pl_term::aval() {
	return (char*) _val;
	}
