%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;
static int nol = 0;

#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <iostream.h>



void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	cout << "## DEPRECATED " << s << endl; 
	}

%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@
prim ("Anchor"|"Appearance"|"Box"|"Cone"|"Cylinder"|"FontStyle"|"Material"|"Shape"|"Sphere"|"Text"|"Transform")
skip ("<red>")
suffix ("es"|"s")
%%@ rules
{prim}{suffix} { cout << yytext; }
"<object"{atts}">" { nol++; cout << yytext; }
"</object>" { nol--; cout << yytext; }
"##nol--" { nol--; }
"##nol++" { nol++; }
"<a "{atts}">"{skip}*{prim}* { cout << yytext; }
"<"[A-Za-z0-9\?]+{atts}">" { cout << yytext; }
{prim} { if (!nol)  cout << "<a ref=@tm-" << yytext << ">" << yytext << "</a>"; else cout << yytext; }
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
//align = "BEGIN";
int _argc = 0;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
	argc--; argv++;
	}

l.paths(_argc, _argv);
pr = 1;
if ( argc == 1 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
cout << endl;
return 0;
}
//</>
