// inetaddr.h

#include <hush/net/cs/inetaddr.h>

#include <string.h>


//---------------------------- inet_address implementation ------------------

inet_address::inet_address(const char* name, int port)
{
    if (name != NULL)
        strcpy(_hostname, name);
    else
        _hostname [0] = '\0';
    _portnr = port;
}


inet_address::~inet_address()
{
    _hostname[0] = '\0';
    _portnr = 0;
}


const char* inet_address::hostname() const
{
    return _hostname;
}


int inet_address::portnr() const
{
    return _portnr;
}
