#include <hush/source.h>
#include <hush/api/factory.h>
#include <hush/widgets.h>

#include <hush/api/io.h>
#include <stdio.h>

factory::factory(const char* kind) {
	if (kind); //Wall
	}

::kit* factory::kit(const char* kind) {
	return new ::kit(kind); 
	}


#ifndef CIAO
#define fac(button) \
::button* factory::button(widget* r, const char* p, const char* opts ) { \
	char buf[1024]; \
	::button* b = 0; \
	char* root = r->path(); \
	if (p[0] == '.' && strlen(root)==1) \
		sprintf(buf,"%s",(char*)p); \
	if (p[0] != '.' && strlen(root)==1) \
		sprintf(buf,".%s",(char*)p); \
	else if (p[0]=='.') \
		sprintf(buf,"%s%s",root,(char*)p); \
	else \
                sprintf(buf,"%s.%s",root,(char*)p); \
	b = button::lookup(buf); \
	if (b) { \
		cerr << "Warning (factory): " << buf << " does already exist" << endl; \
		} \
	else { \
		b = new ::button(r,p,(char*)opts); \
		button::declare(b->path(),b); \
		} \
	return b; \
	}


fac(button)
fac(checkbutton)
fac(radiobutton)

fac(dvmenu)
fac(menubutton)
fac(menubar)

fac(message)
fac(entry)
fac(listbox)

fac(frame)
fac(toplevel)

fac(scrollbar)
fac(label)

fac(canvas)
fac(dvtext)

fac(filechooser)
fac(browser)

#endif
