#include <hush/source.h>

#include <hush/sys/stats.h>

#include <hush/hush.h>
#include <hush/iter.h>
#include <hush/string.h>
#include <hush/term.h>
#include <hush/dictionary.h>
#include <hush/garbage.h>

#include <hush/api/srv.h>
#include <hush/api/clt.h>

#include <hush/api/vm.h>

#include <hush/sys/bind.h>
#include <hush/sys/cell.h>

#include <hush/sys/io.h>

#ifndef NOLIST
#include <hush/list.h>
#endif

#include "hush/sys/local.i"

#include <hush/iostream.h>
//#include <hush/io.h>

void statistics::report(char* s) {

//#define output  session::_default->err()
#define output  cerr




output << endl;
output << "Statistics: "  << "  created - deleted = ? " << endl;

output << "session:: \t"
  << session::created << " - " << session::deleted << " = "
  << session::created - session::deleted << endl;

output << "kit::    \t"
  << kit::created << " - " << kit::deleted << " = "
  << kit::created - kit::deleted << endl;

output << "handler:: \t"
  << handler::created << " - " << handler::deleted << " = "
  << handler::created - handler::deleted << endl;

output << "event:: \t"
  << event::created << " - " << event::deleted << " = "
  << event::created - event::deleted << endl;

output << "widget:: \t"
  << widget::created << " - " << widget::deleted << " = "
  << widget::created - widget::deleted << endl;

output << "item::    \t"
  << item::created << " - " << item::deleted << " = "
  << item::created - item::deleted << endl;

output << "binding:: \t"
  << binding::created << " - " << binding::deleted << " = "
  << binding::created - binding::deleted << endl;

output << "string:: \t"
  << string::created << " - " << string::deleted << " = "
  << string::created - string::deleted << endl;

output << "term::   \t"
  << term::created << " - " << term::deleted << " = "
  << term::created - term::deleted << endl;

output << "iter<T>::    \t" 
  << iter_type::created << " - " << iter_type::deleted << " = "
  << iter_type::created - iter_type::deleted << endl;

#ifndef NOLIST
output << "list<T>::    \t"
  << dvlist_type::created << " - " << dvlist_type::deleted << " = "
  << dvlist_type::created - dvlist_type::deleted << endl;
/*
output << "listelem<T>::\t"
  << dvlistelement_type::created << " - " << dvlistelement_type::deleted << " = "
  << dvlistelement_type::created - dvlistelement_type::deleted << endl;
output << "sublist<T>:: \t"
  << dvsublist_type::created << " - " << dvsublist_type::deleted << " = "
  << dvsublist_type::created - dvsublist_type::deleted << endl;

output << "node::        \t"
  << dvbasenode::created << " - " << dvbasenode::deleted << " = "
  << dvbasenode::created - dvbasenode::deleted << endl;
  */
#endif

output << "dictionary<T>::\t"
  << dictionary_type::created << " - " << dictionary_type::deleted << " = "
  << dictionary_type::created - dictionary_type::deleted << endl;

output << "garbage<T>::\t"
  << garbage_type::created << " - " << garbage_type::deleted << " = "
  << garbage_type::created - garbage_type::deleted << endl;


output << "vm<T>:: \t"
  << vm_type::created << " - " << vm_type::deleted << " = "
  << vm_type::created - vm_type::deleted << endl;

output << "srv<T>::\t"
  << srv_type::created << " - " << srv_type::deleted << " = "
  << srv_type::created - srv_type::deleted << endl;

output << "clt<T>::\t"
  << clt_type::created << " - " << clt_type::deleted << " = "
  << clt_type::created - clt_type::deleted << endl;

if (!s) {

#ifndef NOLIST
/*
output << "baselist::\t"
  << baselist::created << " - " << baselist::deleted << " = "
  << baselist::created - baselist::deleted << endl;
*/
#endif

output << "cell::    \t"
  << cell::created << " - " << cell::deleted << " = "
  << cell::created - cell::deleted << endl;
  }
/*
output << "substring:: \t"
  << substringrep::created << " - " << substringrep::deleted << " = "
  << substringrep::created - substringrep::deleted << endl;
  */

}
