#include <widgets/source.h>

#include <hush/widgets/button.h>
#include <hush/sys/bind.h>

#undef text

char* button::type() const { return "button"; }

#define TYPE button
#include "hush/widgets/create.i"

void button::text(const char* s) { 
	if (_exists()) _this()->text(s); 
	else _error("text");
	}

void button::bitmap(const char* s) { 
	if (_exists()) _this()->bitmap(s);
	else _error("bitmap");
	} 

void button::image(const char* s) {
	if (_exists()) _this()->image(s); 
	else _error("image");
	}

void button::state(const char *s) {
	if (_exists()) _this()->state(s); 
	else _error("state");
	}

void button::flash() { 
	if (_exists()) _this()->flash(); 
	else _error("flash");
	}

char* button::invoke() {
	return _exists()?_this()->invoke():0;
	}

void button::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac, args);
	}
