#include <widgets/source.h>

#include <hush/widgets/label.h>

char* label::type() const { return "label"; }

#define TYPE label
#include "hush/widgets/create.i"

#undef text



void label::text(const char* s) { 
	if (_exists()) _this()->text(s);
	else _error("text");
	}

void label::text(int value) {
	if (_exists()) _this()->text(value);
	else _error("text");
	}
 
void label::text(double value, int precision) {
	if (_exists()) _this()->text(value,precision);
	else _error("text");
        }


void label::bitmap(const char* s) {
	if (_exists()) _this()->bitmap(s);
	else _error("bitmap");
	}


void label::image(const char* s) {
	if (_exists()) _this()->image(s);
	else _error("image");
	}
