#include <widgets/source.h>

#include <hush/widgets/scale.h>
#include <hush/sys/bind.h>

char* scale::type() const { return "scale"; }

#define TYPE scale
#include "hush/widgets/create.i"



void scale::text(const char* s) {
	if (_exists()) _this()->text(s);
	else _error("text");
	}

void scale::from(int n) {
	if (_exists()) _this()->from(n);
	else _error("from");
	}

void scale::to(int n) {
	if (_exists()) _this()->to(n);
	else _error("to");
	}

int scale::get() {
	if (_exists()) return _this()->get();
	else return (int) _error("get");
	}

void scale::set(int v) {
	if (_exists()) _this()->set(v);
	else _error("set");
	}

void scale::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac,args);
	else _error("install");
	}
