#include <widgets/source.h>

#include <hush/widgets/scroll.h>

char* scrollbar::type() const { return "scrollbar"; }

#define TYPE scrollbar
#include "hush/widgets/create.i"



void scrollbar::xview(widget* w) {   /// to do *handler*  
	if (_exists()) _this()->xview(w);
	else _error("xview");
	}

void scrollbar::yview(widget* w) {
	if (_exists()) _this()->yview(w);
	else _error("yview");
	}

void scrollbar::command(widget* w, const char* option) {
	if (_exists()) _this()->command(w,option);
	else _error("command");
	}

void scrollbar::command(const char* w, const char* option) {
	if (_exists()) _this()->command(w,option);
	else _error("command");
	}

void scrollbar::orient(const char* option) {
	if (_exists()) _this()->orient(option);
	else _error("orient");
	}

void scrollbar::width(int n) {
	if (_exists()) _this()->width(n);
	else _error("width");
	}

void scrollbar::get(double* r) const { // pointer to double[4]
	if (_exists()) _this()->get(r);
	else _error("get");
	}
