#include <widgets/source.h>

#include <hush/widgets/toplevel.h>

char* toplevel::type() const { return "toplevel"; }

#define TYPE toplevel
#define ANCESTOR frame
#define OPTS "*"
#include "hush/widgets/create.i"


void toplevel::transient(const char* w) {
	if (_exists()) _this()->transient(w);
	else _error("transient");
	}

void toplevel::position(int x, int y) {
	if (_exists()) _this()->position(x,y);
	else _error("position");
	}

void toplevel::resize(int x, int y) {
	if (_exists()) _this()->resize(x,y);
	else _error("resize");
	}
