#include <hush/java.h>
#include <hush/session.h>
#include <hush/query.h>

#include <hush/io.h>

#undef string

#include <native/hush_dv_api_query.h>

#define method(X) Java_hush_dv_api_query_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, jstring s)
{
  if (env && obj); // Wall
  cerr << "query::init (java)" << endl;
  java_vm<query> vm(env,obj);
  const char *str = vm.get(s);
  query* q = new query(str);
  session::_default->_register(q);
  jint result = (jint) q; // ...
  if (!result) {
	cerr << "ERROR: query::query " << str << endl;
	}
  return result;
}
