#include <hush/java.h>
#include <hush/session.h>


class java_session : public session {  
public:
public:
java_session( int argc = 0, char* argv[] = 0, char* name = 0 ) : session(argc,argv,name) {
	//init_tk();
	session::_java = 1;
	}
void prelude( ) {
    //cerr << "application::prelude from C++" << endl;
    ((java_vm<session>*)the_vm())->callV("prelude");
    }

int main( ) {
    //cerr << "application::main from C++" << endl;
    return ((java_vm<session>*)the_vm())->call("main");
    }
};


#include <native/hush_dv_api_session.h>

static char* args[] = { "hush" }; // AE

#define method(X) Java_hush_dv_api_session_##X


JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj,jint i)
{
	java_vm<session>* vmp = new java_vm<session>(env,obj,"Session");
	char* flags = "hush (native)";
	int fl = (int)i;
	//if (flags) cerr << "Flags: " << fl << " " << flags << endl; 
	if (!fl) flags = 0;
	//if (flags) cerr << flags << endl; 
  	session* result = new java_session(0,args,flags);
	result->_register(vmp);
	//if (session::_default) session::_default->_register(result);
	session::_depends = "hush"; // "hush:dv:widgets"; // "hush:widgets:dv";
	result->_vmp = vmp;
	return (jint) result;
}

JNIEXPORT void JNICALL method(depends)(JNIEnv *env, jobject obj,
	  jstring jlib)
{
  java_vm<session> vm(env,obj);
  char* lib = vm.get(jlib);
  vm->depends(lib);
  vm.release(jlib);
}

JNIEXPORT jint JNICALL method(load)(JNIEnv *env, jobject obj,
	  jstring jlib)
{
  java_vm<session> vm(env,obj);
  char* lib = vm.get(jlib);
  int r = vm->load(lib);
  vm.release(jlib);
  return (jint) r;
}

JNIEXPORT void JNICALL method(nrun)(JNIEnv *env, jobject obj)
{
  java_vm<session> vm(env,obj);
  vm->run();
}

JNIEXPORT void JNICALL method(destroy)(JNIEnv *env, jobject obj)
{
  java_vm<session> vm(env,obj);
  cerr << "Deleting session" << endl;
  session* x = vm.self();
  //delete x;
  if (session::_default) delete session::_default;
}

JNIEXPORT void JNICALL method(statistics)(JNIEnv *env, jobject obj)
{
  if (env && obj); // Wall
  //java_vm<session> vm(env,obj);
  //vm->run();
  session::statistics();
}
