#include <hush/source.h>

#include <hush/widgets/tk/label.h>
#include <hush/hush.h>

#define TYPE label
#define CLASS tk_label
#include <hush/widgets/tk/create.i>


#include <stdio.h>


void CLASS::text(const char* s) { 
	sprintf(buf,"%s configure -text \"%s\"",thepath(),s);
	tk->eval(buf);
	}


void CLASS::text(int value) {
        sprintf(buf,"%s configure -text %d", thepath(), value);
        tk->eval(buf);
        }
 
void CLASS::text(double value, int precision) {
        sprintf(buf,"%s configure -text %-.*f", thepath(), precision, value);
        tk->eval(buf);
        }


void CLASS::bitmap(const char* s) {
  if (s[0] != '@')
    sprintf(buf,"%s configure -image @%s",self()->name(),s);
  else {
    sprintf(buf,"image create bitmap -file %s",s+1);
    char* r = tk->evaluate(buf);
    sprintf(buf,"%s configure -image %s",self()->name(),r);
  }
  tk->eval(buf);
}
 
void CLASS::image(const char* s) {
  if (s[0] != '@')             
    sprintf(buf,"%s configure -image %s",self()->name(),s);
  else {
    sprintf(buf,"image create photo -file %s",s+1);
    char* r = tk->evaluate(buf);
    sprintf(buf,"%s configure -image %s",self()->name(),r);
  }
  tk->eval(buf);
}


