#include <hush/source.h>
#include <hush/widgets/tk/scroll.h>


#define TYPE scrollbar
#define CLASS tk_scrollbar
#include <hush/widgets/tk/create.i>


#include <string.h>
#include <stdio.h>




void CLASS::xview(widget* w) {   /// to do *handler*  
	sprintf(buf,"%s configure -command {%s xview}",name(),w->self()->name());
	tk->eval( buf );
	}

void CLASS::yview(widget* w) {
	sprintf(buf,"%s configure -command {%s yview}",name(),w->self()->name());
	tk->eval( buf );
	}

void CLASS::command(widget* w, const char* option) {
	sprintf(buf,"%s configure -command \"%s %s\"",name(),w->self()->name(),option);
	tk->eval( buf );
	}

void CLASS::command(const char* w, const char* option) {
	sprintf(buf,"%s configure -command \"%s %s\"",self()->name(),w ,option);
	tk->eval( buf );
	}

void CLASS::orient(const char* option) {
	sprintf(buf,"%s configure -orient %s",self()->name(),option);
	tk = kit::lookup("tk");
	tk->eval( buf );
	}

void CLASS::width(int n) {
	sprintf(buf,"%s configure -width %d",self()->name(),n);
	tk->eval( buf );
	}


void CLASS::get(double* r) const { // pointer to double[4]
        sprintf(buf, "%s get", self()->name() );
        char* region = tk->evaluate( buf );
	//cerr << region << endl;
        sscanf(region, "%lf %lf %lf %lf", &r[0], &r[1], &r[2], &r[3]); 
        }
