#!/bin/sh
H=@SRC/cfg
T=`@BIN/suffix $1`
B=`basename $T`
tmp=@tmp-$B-$$-1
contents=@tmp-$B-$$-2
file=$1
C=`ls *.c *.cc *.cpp"`
H=`ls *.h *.i .idl`
M=`ls Makefile *.mk`
I=`ls`

echo "" > $tmp;
echo "<h3><i>File</i>: <tt>$file</tt> <i>--`@HTML/source`</i></h3>" >> $tmp;

echo "<hr>" >> $tmp

echo "<a href=idx-x.html>Index</a>" >> $tmp;
echo "<a href=idx-mk.html>Make</a>" >> $tmp;
echo "<a href=idx-h.html>Includes</a>" >> $tmp;
echo "<a href=idx-cc.html>Source</a>" >> $tmp;
##@HTML/menu Index $I >> $tmp 
##@HTML/menu Make $M >> $tmp 
##@HTML/menu Includes $H >> $tmp 
##@HTML/menu Source $C >> $tmp

echo "<hr>" >> $tmp;
#echo "<program>    " >> $tmp;

cat $* >> $contents

echo "</program>" >> $tmp;

INC=" -I. -I.. -I../.. -I../../.. -I../../../.. -I../../../../.." -I$H
@HTML/header
cat $tmp
cat $contents | @FLT/cc-t.flt | @FLT/ht-ml.flt $INC
@HTML/footer
rm -f $tmp $contents

