%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;

#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <iostream.h>

#define out if (pr) cout

static char name[64];
static int slino = 0;

void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	cout << "## DEPRECATED " << s << endl; 
	}

%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@
%%@ rules
^":"[A-Za-z0-9\/\(\)\,\.\-\<\>\=\:\;\<\>\@\ ]+ {
	if (slino !=0 ) out << "</slide>" << endl;
	out << "<slide id=tm-" << name << "-" << slino << " mode=hide>";
	out << "<h4 color=\"0 1 1\"><a href=@slide-tm-" << name << "-" << slino << ".html>";
	out << yytext+1 << "</a></h4><p>" << endl;
	slino++;
	}
\n { out << endl; }
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
//align = "BEGIN";
strcpy(name,"temp");
int _argc = 0;
cerr << "ARGC " << argc << endl;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N' ) {
	strcpy(name,argv[0]+2);
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
        cerr << "ARGC " << argc << endl;
	argc--; argv++;
	}

cerr << "ARGC " << argc << endl;
l.paths(_argc, _argv);
pr = 1;
out << "<document>" << endl;
//out << "/// <box>" << "<a href=@talk-" << name << ".html target=_top>";
//out << "<gold>" << name << "</gold></box>" << endl;
out << "<p align=right>";
out << "<a href=@talk-" << name << ".html target=_top>";
out << "<img src=@base/eye.gif width=25 height=25></a></p>" << endl;
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
out << "</slide>" << endl;
out << "</document>" << endl;
return 0;
}
//</>
