%{
//@auto=0
//@class ht-vr
%}
%class lex
%p 10000
%e 1500
%{
#include <hush/grammar/lex.h>
#define out if (pr) cout
int pr = 1;
char endline[1024];
int dp = 0;
%}
%%@ rules
"<a href="[^\>]*">" {}
"</a>"  { }
"<em>"|"</em>"|"<i>"|"</i>"|"<br>"|"</font>"|"<font"[^\>]*">"|"<hr>" { }
"&lt;" { out << "<"; }
"&gt;" { out << ">"; }
"&euml;"  { out << "e"; }
"<control>" { }
"<c>"  { }
"</c>" { }
"<latex>" { pr=0; }
"</latex>" { pr=1; }
. { out << yytext[0]; }
%%
//@ main
int main() {
lex l; l();
return 0;
}

char firstchar(char* s) {
while ( *s != 0 && ( *s == ' ' || *s == '\t' || *s == '\n' ) ) s++;
return *s;
}
//</>
