#ifndef _hush_grammar_ml_dlp_yacc_h
#define _hush_grammar_ml_dlp_yacc_h

#include <hush/grammar/parser.h>
#include <iostream.h>

class scanner;

class dlp_yacc : public yacc_parser {
public:

	dlp_yacc(iter<term>* sc) : yacc_parser((iter<term>*)sc) { 
		_scanner = (parser*) sc;
		yydebug = 1;
		//cerr << "dlp_yacc::init" << endl;
		}
	term* operator()();

        //void yyerror(char* s) { cerr << "syntax error " << error() << endl; }
        char* error(); // generated -- requires yacc.error.o
};

#endif
