#!/bin/sh
##@ selector

level="4";
mode=ls
menu="Index"
nomenu=false
bar=false
flat=""
loc=""
subject=""
notitle=false
nodir=true
noslide=true
category=dv

##@ options

while [ $# -ge 1 ]; do case $1 in
	-level) level=$2; shift;;
	-menu) menu=$2; shift;;
	-mode) mode=$2; shift;;
	-category) category=$2; shift;;
	-bar) bar=true;;
	-flat) flat=$1;;
	-loc) loc=$1;;
	-subject) subject=$1;;
	-dir) nodir=false;;
	-nodir)   nodir=true;;
	-noslide) noslide=true;;
	-notitle) notitle=true;;
	-)  break;;
	*)  break;;
	esac;
	shift;
done;

##@ create document

echo "<document>"
if [ "$noslide" = "false" ]; then
	echo "<slide style=silver id=\"@index-$menu\" cap=\"$menu\">";
fi;
if [ "$bar" = "true" ]; then
      @BIN/bar -menu $menu $flat $loc $subject
else
  heading=""
  if [ "$nomenu" = "false" ]; then heading="<h${level}><i>$menu</i>:"; fi;
  if [ "$nodir" = "false" ]; then
	heading="$heading  <a href=\"index.html\"><i>";
	heading="$heading `@BIN/source`</i></a>";
  fi;
  if [ "$nomenu" = "false" ]; then echo "$heading </h${level}><p>"; fi
fi;
@BIN/select-$mode $*
if [ "$noslide" = "false" ]; then
	echo "</slide>";
	fi
echo "</document>"

##</>
