#!/bin/sh
sed \
   -e "s:Objects:objects:g" \
   -e "s:Object:object:g" \
   -e "s:History:history:g" \
   -e "s:Law of Demeter:law of Demeter:g" \
   -e "s:ObjectSpace:ObjectSpace:g" \
   -e "s:objectSpace:ObjectSpace:g" \
   -e "s:ObjectWeb:ObjectWeb:g" \
   -e "s:objectWeb:ObjectWeb:g" \
   -e "s:Boolean:boolean:g" \
   -e "s:Refinement:refinement:g" \
   -e "s:Block:block:g" \
   -e "s:Runtime:runtime:g" \
   -e "s:Persistent:persistent:g" \
   -e "s:Keyword:keyword:g" \
   -e "s:Query:query:g" \
   -e "s:Generators:generators:g" \
   -e "s:Extension:extension:g" \
   -e "s:Management:management:g" \
   -e "s:Manipulation:manipulation:g" \
   -e "s:Architecture:architecture:g" \
   -e "s:Interface:interface:g" \
   -e "s:Definition:definition:g" \
   -e "s:Unification:unification:g" \
   -e "s:Business:business:g" \
   -e "s:Collaborative:collaborative:g" \
   -e "s:Display:display:g" \
   -e "s:Implementation:implementation:g" \
   -e "s:Joint:joint:g" \
   -e "s:Method:method:g" \
   -e "s:Multiparty:multiparty:g" \
   -e "s:Program:program:g" \
   -e "s:Representation:representation:g" \
   -e "s:Safety:safety:g" \
   -e "s:Scripts:scripts:g" \
   -e "s:Specifying:specifying:g" \
   -e "s:State:state:g" \
   -e "s:Subtype:subtype:g" \
   -e "s:Transition:transition:g" \
   -e "s:Consequence:consequence:g" \
   -e "s:Contracts:contracts:g" \
   -e "s:Correctness:correctness:g" \
   -e "s:Correspondence:correspondence:g" \
   -e "s:Correspondence :correspondence:g" \
   -e "s:correspondence :correspondence:g" \
   -e "s:Decomposition:decomposition:g" \
   -e "s:Castagna {\\\\it et al.} :Castagna {\\\\em et al.} :g" \
   -e "s:Equation:equation:g" \
   -e "s:Bounded:bounded:g" \
   -e "s:Contravariance:contravariance:g" \
   -e "s:Existential:existential:g" \
   -e "s:Field:field:g" \
   -e "s:Flavors:flavors:g" \
   -e "s:Function:function:g" \
   -e "s:Ideals:ideals:g" \
   -e "s:Information:information:g" \
   -e "s:Intersection:intersection:g" \
   -e "s:Lambda:lambda:g" \
   -e "s:Records:records:g" \
   -e "s:Substitution:substitution:g" \
   -e "s:Subtyping:subtyping:g" \
   -e "s:Taxonomic:taxonomic:g" \
   -e "s:Unrolling:unrolling:g" \
   -e "s:Variants:variants:g" \
   -e "s:Sub-range:sub-range:g" \
   -e "s:Self-reference:self-reference:g" \
   -e "s:Overloaded:overloaded:g" \
   -e "s:Non-monotonic:non-monotonic:g" \
   -e "s:Equivalence:equivalence:g" \
   -e "s:Formal:formal:g" \
   -e "s:Initial:initial:g" \
   -e "s:Interpretation:interpretation:g" \
   -e "s:Mathematical:mathematical:g" \
   -e "s:Multiple:multiple:g" \
   -e "s:Name:name:g" \
   -e "s:Natural:natural:g" \
   -e "s:Principle:principle:g" \
   -e "s:Sequences:sequences:g" \
   -e "s:Sets:sets:g" \
   -e "s:Signature:signature:g" \
   -e "s:Read-only:read-only:g" \
   -e "s:Interfaces:interfaces:g" \
   -e "s:Abstract Data Types:abstract data types:g" \
   -e "s:Abstract:abstract:g" \
   -e "s:abstract Factory:Abstract Factory:g" \
   -e "s:Service:service:g" \
   -e "s:Component:component:g" \
   -e "s:Standard:standard:g" \
   -e "s:standard Template:Standard Template:g" \
   -e "s:Active:active:g" \
   -e "s:Concurrent:concurrent:g" \
   -e "s:Efficiency:efficiency:g" \
   -e "s:Delegation:delegation:g" \
   -e "s:Documentation:documentation:g" \
   -e "s:Dynamic:dynamic:g" \
   -e "s:Frame:frame:g" \
   -e "s:Hybrid:hybrid:g" \
   -e "s:Improving:improving:g" \
   -e "s:Language:language:g" \
   -e "s:Open:open:g" \
   -e "s:Meta:meta:g" \
   -e "s:Orthogonal:orthogonal:g" \
   -e "s:Process:process:g" \
   -e "s:Programming:programming:g" \
   -e "s:Prototype:prototype:g" \
   -e "s:Reflection:reflection:g" \
   -e "s:Reliability:reliability:g" \
   -e "s:Type:type:g" \
   -e "s:Uniform:uniform:g" \
   -e "s:Asynchronous:asynchronous:g" \
   -e "s:Acquaint:acquaint:g" \
   -e "s:Client:client:g" \
   -e "s:Class:class:g" \
   -e "s:Design:design:g" \
   -e "s:Development:development:g" \
   -e "s:Event:event:g" \
   -e "s:Semantic:semantic:g" \
   -e "s:Supplier:supplier:g" \
   -e "s:Application:application:g" \
   -e "s:Application:application:g" \
   -e "s:Contractual:contractual:g" \
   -e "s:Global:global:g" \
   -e "s:Identifying:identifying:g" \
   -e "s:Dimensions:dimensions:g" \
   -e "s:Coherent:coherent:g" \
   -e "s:Eliminating:eliminating:g" \
   -e "s:Layers:layers:g" \
   -e "s:Methods:methods:g" \
   -e "s:Model:model:g" \
   -e "s:Refining:refining:g" \
   -e "s:Structured:structured:g" \
   -e "s:System:system:g" \
   -e "s:Validation:validation:g" \
   -e "s:Verification:verification:g" \
   -e "s:Actor Pattern:actor pattern:g" \
   -e "s:Algebra:algebra:g" \
   -e "s:Creation:creation:g" \
   -e "s:Structural:structural:g" \
   -e "s:Poly:poly:g" \
   -e "s:San Francisco:SanFrancisco:g" \
   -e "s:Analysis:analysis:g" \
   -e "s:Assertions:assertions:g" \
   -e "s:Axioms:axioms:g" \
   -e "s:Compute:compute:g" \
   -e "s:Concrete:concrete:g" \
   -e "s:Cause:cause:g" \
   -e "s:Encapsulating:encapsulating:g" \
   -e "s:Invocation:invocation:g" \
   -e "s:Computability:computability:g" \
   -e "s:Nested:nested:g" \
   -e "s:Observer:observer:g" \
   -e "s:patterns!observer:patterns!Observer:g" \
   -e "s:patterns!prototype:patterns!Prototype:g" \
   -e "s:Overloading:overloading:g" \
   -e "s:Actor:actor:g" \
   -e "s:Canonical:canonical:g" \
   -e "s:Conformance:conformance:g" \
   -e "s:Behavioral:behavioral:g" \
   -e "s:Frameworks:frameworks:g" \
   -e "s:Components:components:g" \
   -e "s:Computing:computing:g" \
   -e "s:Modeling:modeling:g" \
   -e "s:Data:data:g" \
   -e "s:Encapsulation:encapsulation:g" \
   -e "s:Inheritance:inheritance:g" \
   -e "s:Message:message:g" \
   -e "s:Modules:module:g" \
   -e "s:Procedural:procedural:g" \
   -e "s:Object-Oriented Modeling:object-oriented modeling:g" \
   -e "s:Support:support:g" \
   -e "s:Protocol:protocol:g" \
   -e "s:Requirements:requirements:g" \
   -e "s:Style:style:g" \
   -e "s:Software Development Models:software development models:g" \
   -e "s:Software:software:g" \
   -e "s:Technology:technology:g" \
   -e "s:components:component:g" \
   -e "s:component\::components\::g" \
   -e "s:Downloadable:downloadable:g" \
   -e "s:Distributed Object Patterns:distributed object patterns:g" \
   -e "s:Distributed:distributed:g" \
   -e "s:Mobile:mobile:g" \
   -e "s:concurrent Prolog:Concurrent Prolog:g" \
   -e "s:object }:object}:g" \
   -e "s:em  et al:em et al:g" \
   -e "s:abstract data types {\\\\em  -- representation function}:abstract data types!representation function:g" \
   -e "s:abstract data types {\\\\em  -- foundational perspective}:abstract data types!foundational perspective:g" \
   -e "s:abstract data types {\\\\em  -- packages}:abstract data types!packages:g" \
   -e "s:Bass {\\em  et al.}:Bass {\\em et al.}:g" \
   $1.idx > @tmp-$1.idx;
   cp @tmp-$1.idx $1.idx
