#include <hush/source.h>

#include "vip-anim.h"
//#include <scene/mesh.h>
//#include <scene/shader.h>
#include <scene/background.h>
//#include "mesh.h"
//#include "vip-tiny.h"


//#include <streams.h>
//#include <scene/satelite.h>
//#include <hush/scanner.h>

#include <hush/sim/sim.h>

//#include <ch/extern/embedch.h>
//#include "sampclass.h"

//#include "shader.h"

//#include "Character.h"

//static CCharacter* _tiny = 0;

#include "MultiAnimation.h"
#include "Tiny.h"
#include "dxutil.h"


#define TXFILE_FLOOR _T("Floor.jpg")
#define FLOOR_TILECOUNT 2

static char* _help = "anim";
static scene* dolphin;



int vip_anim::handle(char* type, char* ev) {
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","0")) {
		int s = 0;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","1")) {
		int s = 1;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","2")) {
		int s = 2;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_anim::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_anim::vip_anim(char* opts) 
{


	_stack = 1;

	m_pMeshFloor = NULL;
    m_pTxFloor = NULL;

    m_pFont = NULL;

    m_dwFollow = 0xffffffff;
    m_bDrawReflection = true;
    m_bDisplayText = true;
    m_bDisplayHelp = true;

    m_fLastAnimTime = 0.0;

   // m_dwCreationWidth = 640;
    //m_dwCreationHeight = 480;

    m_bPlaySounds = true;
	
	count = 12;



_size = 20; //size;
wsprintf(_type,"vip_anim");
_display = _type;

//_sim->passivate(this);
//_sim -> schedule(this,0.0);


end(20);
loop = 1;



 

 
  
}




vip_anim::~vip_anim()
{
//delete scenes[];
}

int 
vip_anim::_load()
{
    int hr = S_OK;

	m_pd3dDevice = _device;

	 srand( GetTickCount() );

    // Setup the camera with view matrix
   // D3DXVECTOR3 vEye( .5f, .55f, -.2f );
   // D3DXVECTOR3 vAt( .5f,  .125f, .5f );

	D3DXVECTOR3 vEye( 0.5f, 0.2f,-2.0f );
    D3DXVECTOR3 vAt( 0.0f, 0.0f, 0.0f );

	//  D3DXVECTOR3 vEye(0.5, 0.5, -2.5 );
    //D3DXVECTOR3 vAt( 0.5,  0.2, 0.5 );


    m_Camera.SetViewParams( &vEye, &vAt );

    m_Camera.SetScalers( 0.01f, 1.0f );  // Camera movement parameters

    // set up dsound
    m_DSound.Initialize( NULL, DSSCL_PRIORITY ); // window

	//// etc

	  // font stuff
    HDC hDC = GetDC( NULL );
    int nHeight = -MulDiv( 10, GetDeviceCaps(hDC, LOGPIXELSY), 72 );
    ReleaseDC( NULL, hDC );
    if( FAILED( hr = D3DXCreateFont( m_pd3dDevice, nHeight, 0, FW_BOLD, 0, FALSE, DEFAULT_CHARSET, 
                         OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, 
                         TEXT("Arial"), &m_pFont ) ) )
        return hr;

    // Initialize floor textures
/*   
	TCHAR tszPath[ MAX_PATH ];
    hr = DXUtil_FindMediaFileCch( tszPath, MAX_PATH, TXFILE_FLOOR );
    if( FAILED( hr ) )
        return hr;
*/
    hr = D3DXCreateTextureFromFile( m_pd3dDevice, "floor.jpg", &m_pTxFloor );
    if( FAILED( hr ) )
        return hr;

    D3DXMATRIX mx;
    // floor geometry transform
    D3DXMatrixRotationX( & m_mxFloor, -D3DX_PI / 2.0f );
    D3DXMatrixRotationY( & mx, D3DX_PI / 4.0f );
    D3DXMatrixMultiply( & m_mxFloor, & m_mxFloor, & mx );
    D3DXMatrixTranslation( & mx, 0.5f, 0.0f, 0.5f );
    D3DXMatrixMultiply( & m_mxFloor, & m_mxFloor, & mx );

    // set material for floor
    m_MatFloor.Diffuse = D3DXCOLOR( 1.f, 1.f, 1.f, .75f );
    m_MatFloor.Ambient = D3DXCOLOR( 1.f, 1.f, 1.f, 1.f );
    m_MatFloor.Specular = D3DXCOLOR( 0.f, 0.f, 0.f, 1.f );
    m_MatFloor.Emissive = D3DXCOLOR( .0f, 0.f, 0.f, 0.f );
    m_MatFloor.Power = 0.f;

    SetMenuStates();

    // set up MultiAnim
    TCHAR sXFile[ MAX_PATH ];
    TCHAR sFXFile[ MAX_PATH ];

	hr = DXUtil_FindMediaFileCb( sXFile, MAX_PATH, _T("d:\\vip\\data\\tiny_4anim.x") );
    if( FAILED( hr ) )
        return hr;
	hr = DXUtil_FindMediaFileCch( sFXFile, MAX_PATH, _T("d:\\vip\\data\\MultiAnimation.fx") );
    if( FAILED( hr ) )
        return hr;

    CMultiAnimAllocateHierarchy AH;
    AH.SetMA( & m_MultiAnim );

    hr = m_MultiAnim.Setup( m_pd3dDevice, sXFile, sFXFile, & AH );
    if( FAILED( hr ) )
        return hr;

    // get device caps
    D3DCAPS9 caps;
    m_pd3dDevice->GetDeviceCaps( & caps );

    // Select the technique that fits the shader version.
    // We could have used ValidateTechnique()/GetNextValidTechniqe() to find the
    // best one, but this is convenient for our purposes.
    if( caps.VertexShaderVersion <= D3DVS_VERSION( 1, 1 ) )
    {
        if( caps.VertexShaderVersion < D3DVS_VERSION( 1, 1 ) )
        {
            m_MultiAnim.SetTechnique( "t2" );
            m_MultiAnim.SetSWVP( true );
        }
        else
        {
            m_MultiAnim.SetTechnique( "t1" );
            m_MultiAnim.SetSWVP( false );
        }
    }
    else
    {
        m_MultiAnim.SetTechnique( "t0" );
        m_MultiAnim.SetSWVP( false );
    }

    // Restore steps for tiny instances
    vector< CTiny* >::iterator itCurCP, itEndCP = m_v_pCharacters.end();
    for( itCurCP = m_v_pCharacters.begin(); itCurCP != itEndCP; ++ itCurCP )
    {
        ( * itCurCP )->RestoreDeviceObjects( m_pd3dDevice );
    }

    // If there is no instance, make sure we have at least one.
    if( m_v_pCharacters.size() == 0 )
    {
        CTiny * pTiny = new CTiny;
        if( pTiny == NULL )
            return E_OUTOFMEMORY;

        hr = pTiny->Setup( & m_MultiAnim, & m_v_pCharacters, & m_DSound, 0.f );
    }


	
    return hr;
}

int
vip_anim::_restore()
{
    HRESULT hr = S_OK;

	m_fTime = dxtime();

	// set lighting
    //m_pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );
    //m_pd3dDevice->SetRenderState( D3DRS_AMBIENT, D3DCOLOR_ARGB( 255, 255, 255, 255 ) );
    //m_pd3dDevice->LightEnable( 0, TRUE );
    //m_pd3dDevice->SetRenderState( D3DRS_NORMALIZENORMALS, TRUE );

    // Set up the camera's projection matrix
    m_fAspectRatio = 0.75; //m_d3dsdBackBuffer.Width / (FLOAT)m_d3dsdBackBuffer.Height;
    m_Camera.SetProjParams( D3DXToRadian(60.0f), m_fAspectRatio, 0.001f, 100.0f );

    // create the floor geometry
    LPD3DXMESH pMesh;
    hr = D3DXCreatePolygon( m_pd3dDevice, 1.2f, 4, & pMesh, NULL );
    if( FAILED( hr ) )
        return hr;

    hr = pMesh->CloneMeshFVF( D3DXMESH_WRITEONLY, D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1, m_pd3dDevice, & m_pMeshFloor );
    pMesh->Release();
    if( FAILED( hr ) )
        return hr;

    DWORD dwNumVx = m_pMeshFloor->GetNumVertices();

    struct Vx
    {
        D3DXVECTOR3 vPos;
        D3DXVECTOR3 vNorm;
        float fTex[ 2 ];
    };

    // Initialize its texture coordinates
    Vx * pVx;
    hr = m_pMeshFloor->LockVertexBuffer( 0, (VOID **) & pVx );
    if( FAILED( hr ) )
        return hr;

    for( DWORD i = 0; i < dwNumVx; ++ i )
    {
        if( fabs( pVx->vPos.x ) < 0.01 )
        {
            if( pVx->vPos.y > 0 )
            {
                pVx->fTex[ 0 ] = 0.0f;
                pVx->fTex[ 1 ] = 0.0f;
            } else
            if( pVx->vPos.y < 0.0f )
            {
                pVx->fTex[ 0 ] = _tu; //1.0f * FLOOR_TILECOUNT;
                pVx->fTex[ 1 ] = _tv; //1.0f * FLOOR_TILECOUNT;
            } else
            {
                pVx->fTex[ 0 ] = 0.5f * _tu; // * FLOOR_TILECOUNT;
                pVx->fTex[ 1 ] = 0.5f * _tv; //FLOOR_TILECOUNT;
            }
        } else
        if( pVx->vPos.x > 0.0f )
        {
            pVx->fTex[ 0 ] = 1.0f * _tu; // FLOOR_TILECOUNT;
            pVx->fTex[ 1 ] = 0.0f;
        } else
        {
            pVx->fTex[ 0 ] = 0.0f;
            pVx->fTex[ 1 ] = 1.0f * _tv; // FLOOR_TILECOUNT;
        }

        ++ pVx;
    }

    m_pMeshFloor->UnlockVertexBuffer();

    // Restore font
    if( m_pFont )
        m_pFont->OnResetDevice();

    // reset the timer
    m_fLastAnimTime = m_fTime; //m_fTime;



    return hr;
}


int
vip_anim::_render( ) 
{
HRESULT hr = S_OK;
   
  
     if( m_fTime - m_fLastAnimTime > ( 1.0f / 60.f ) )
    {
        vector< CTiny* >::iterator itCur, itEnd = m_v_pCharacters.end();
        for( itCur = m_v_pCharacters.begin(); itCur != itEnd; ++ itCur )
            ( * itCur )->Animate( m_fTime - m_fLastAnimTime );

        m_fLastAnimTime = m_fTime;
    }

    // Update the camera 
    m_Camera.FrameMove( delta() ); //m_fElapsedTime );


	render_begin(_device);
	
	_device->SetTexture( 0, _texture );




	       // set up the camera
        D3DXMATRIX mx, mxView, mxProj;
        D3DXVECTOR3 vEye;
        D3DXVECTOR3 vLightDir;

        // are we following a tiny, or an independent arcball camera?
        if(1 && m_dwFollow == 0xffffffff )
        {
            // Light direction is same as camera front (reversed)
            vLightDir = -m_Camera.GetWorldAhead();
            
            // set static transforms
            mxView = *m_Camera.GetViewMatrix();
            mxProj = *m_Camera.GetProjMatrix();
            m_pd3dDevice->SetTransform( D3DTS_VIEW, & mxView );
            m_pd3dDevice->SetTransform( D3DTS_PROJECTION, & mxProj );
            vEye = m_Camera.GetEyePt();
        }
        else
        {
            // set follow transforms
            CTiny * pChar = m_v_pCharacters[ m_dwFollow ];

            D3DXVECTOR3 vCharPos;
            D3DXVECTOR3 vCharFacing;
            pChar->GetPosition( & vCharPos );
            pChar->GetFacing( & vCharFacing );
            vEye = D3DXVECTOR3  ( vCharPos.x, 0.25f, vCharPos.z );
            D3DXVECTOR3 vAt     ( vCharPos.x, 0.0125f, vCharPos.z ),
                        vUp     ( 0.0f, 1.0f, 0.0f );
            vCharFacing.x *= .25; vCharFacing.y = 0.f; vCharFacing.z *= .25;
            vEye -= vCharFacing;
            vAt += vCharFacing;

            D3DXMatrixLookAtLH( & mxView, & vEye, & vAt, & vUp );
            m_pd3dDevice->SetTransform( D3DTS_VIEW, & mxView );

            D3DXMatrixPerspectiveFovLH( &mxProj, D3DXToRadian(60.0f), m_fAspectRatio, 0.1f, 100.0f );
            m_pd3dDevice->SetTransform( D3DTS_PROJECTION, & mxProj );

            // Set the light direction and normalize
            D3DXVec3Subtract( &vLightDir, &vEye, &vAt );
            D3DXVec3Normalize( &vLightDir, &vLightDir );
        }

        LPD3DXEFFECT pEffect = m_MultiAnim.GetEffect();
        if( pEffect )
        {
            // set view-proj
            D3DXMatrixMultiply( & mx, & mxView, & mxProj );
            pEffect->SetMatrix( "mViewProj", & mx );

            // Set the light direction so that the
            // visible side is lit.
            D3DXVECTOR4 v( vLightDir.x, vLightDir.y, vLightDir.z, 1.0f );
            pEffect->SetVector( "lhtDir", &v );

            pEffect->Release();
        }

        // set the fixed function shader for drawing the floor
        m_pd3dDevice->SetVertexShader( NULL );
        m_pd3dDevice->SetFVF( m_pMeshFloor->GetFVF() );

        // draw the floor
        m_pd3dDevice->SetTexture( 0, _texture); //m_pTxFloor );
        m_pd3dDevice->SetMaterial( & m_MatFloor );
        //m_pd3dDevice->SetTransform( D3DTS_WORLD, & m_mxFloor );
        m_pMeshFloor->DrawSubset( 0 );

        // draw each tiny
        vector< CTiny* >::iterator itCur, itEnd = m_v_pCharacters.end();
        for( itCur = m_v_pCharacters.begin(); itCur != itEnd; ++ itCur )
        {
            // set the time to update the hierarchy
            ( * itCur )->AdvanceTime( delta() /*m_fElapsedTime*/, & vEye );
            // draw the mesh
            ( * itCur )->Draw();
        }

        //
        // Output text information
        //
        if(1 && m_pFont )
        {
            RECT rc;
            TCHAR sDesc[ 256 ];

            // Dump out the FPS and device stats
            SetRect( &rc, 2, 0, 0, 0 );
           // m_pFont->DrawText( NULL, m_strFrameStats, -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 0.0f, 1.0f ));
            rc.top += 16;
           // m_pFont->DrawText( NULL, m_strDeviceStats, -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 0.0f, 1.0f ));
            rc.top += 16;
            _stprintf( sDesc, _T("  Time: %2.3f"), m_fTime );
            m_pFont->DrawText( NULL, sDesc, -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
            rc.top += 16;
            _stprintf( sDesc, _T("  Number of models: %d"), m_v_pCharacters.size() );
            m_pFont->DrawText( NULL, sDesc, -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));

            // We can only display either the behavior text or help text,
            // with the help text having priority.
            if( m_bDisplayHelp )
            {
                rc.top += 16;
                if( m_dwFollow == 0xFFFFFFFF )
                    m_pFont->DrawText( NULL, _T("Press F1 to hide help"), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
                else
                    // Following an instance. Let user know F1 shows animation info
                    m_pFont->DrawText( NULL, _T("Press F1 to show animation info"), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));

                rc.left = 20;
				rc.top = 756 - 165;
                m_pFont->DrawText( NULL,
                                   _T("Global Controls:\n")
                                   _T("Add instance\n")
                                   _T("Next view\n")
                                   _T("Previous view\n")
                                   _T("Reset camera\n")
                                   _T("Reset time\n")
                                   _T("Toggle behavior text\n")
                                   _T("Change device\n")
                                   _T("Quit\n")
                                   _T("Relinquish control for all instances"),
                                   -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
                rc.left = 250;
                m_pFont->DrawText( NULL,
                                   _T("\n")
                                   _T("Z\n")
                                   _T("N\n")
                                   _T("P\n")
                                   _T("R\n")
                                   _T("I\n")
                                   _T("T\n")
                                   _T("F2\n")
                                   _T("Esc\n")
                                   _T("V"),
                                   -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
                rc.top = 756 - 85;
                rc.left = 370;
                m_pFont->DrawText( NULL,
                                   _T("For a specific instance:\n")
                                   _T("Take control\n")
                                   _T("Move forward\n")
                                   _T("Turn\n")
                                   _T("Enable run mode\n"),
                                   -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
                rc.left = 520;
                m_pFont->DrawText( NULL,
                                   _T("\n")
                                   _T("C\n")
                                   _T("W\n")
                                   _T("A,D\n")
                                   _T("Shift\n"),
                                   -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));

            } else
            if( m_bDisplayText )
            {
                rc.top += 16;
                m_pFont->DrawText( NULL, _T("Press F1 for help."), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));

                // output data for T[m_dwFollow]
                if( m_dwFollow != 0xffffffff )
                {
                    int i;
                    CTiny * pChar = m_v_pCharacters[ m_dwFollow ];
                    vector < String > v_sReport;
                    pChar->Report( v_sReport );
                    rc.left = 5;
                    rc.top = 756 - 115;
                    for( i = 0; i < 6; ++i )
                    {
                        m_pFont->DrawText( NULL, v_sReport[i].c_str(), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
                        rc.top += 16;
                    }
                    m_pFont->DrawText( NULL, v_sReport[16].c_str(), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));

                    rc.left = 220;
                    rc.top = 756 - 85;
                    for( i = 6; i < 11; ++i )
                    {
                        m_pFont->DrawText( NULL, v_sReport[i].c_str(), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
                        rc.top += 16;
                    }

                    rc.left = 390;
					rc.top = scene::height() - 85;
                    for( i = 11; i < 16; ++i )
                    {
                        m_pFont->DrawText( NULL, v_sReport[i].c_str(), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
                        rc.top += 16;
                    }
                }
            }
        }
   

	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		message(100,_y-200,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	display(_display);
	render_end(_device);

 

    return hr;
}

void vip_anim::SetMenuStates()
{
  //  HMENU hMenu = GetMenu( NULL);
/*
    CheckMenuItem( hMenu, ID_OPTIONS_REFLECTION,
                    m_bDrawReflection ? MF_CHECKED : MF_UNCHECKED );
    EnableMenuItem( hMenu, ID_OPTIONS_TAKECONTROL,
                    m_dwFollow != 0xffffffff ? MF_ENABLED : MF_GRAYED );
*/
					}
