#ifndef transform_h
#define transform_h

#include <hush/export.h>
#include <hush/hush.h>

struct IDirect3DDevice9;
struct D3DXMATRIX;


#include <d3d9.h>
#include <d3dx9.h>



class transform { 
	// : public handler {
	// : public event {
public:
	transform();
	~transform();
	void translation(float x, float y, float z);
	void scale(float x, float y, float z);
	void rotation(float x, float y, float z, float r);
	//float[3] translation();
	//float[3] scale();
	//float[4] rotation();
	void set(IDirect3DDevice9* device, int t = 0); // 0 absolute, 1 relative

	void  get(IDirect3DDevice9* device, D3DXMATRIX* mat);
	void  set(IDirect3DDevice9* device, D3DXMATRIX* mat);
    
	void  get(D3DXMATRIX* mat);
   

private:
	float _translation[3];
	float _scale[3];
	float _rotation[4];


};

#endif

