
#ifndef object_vsh_h
#define object_vsh_h

#include "scene/scene.h"
#include "common90/d3d-util.h"

class object_vsh : public scene  
{
public:

    object_vsh();
	
    virtual ~object_vsh();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
	virtual HRESULT compose(IDirect3DDevice9* device, DWORD t);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* object_vshure );

	HRESULT FrameMove(IDirect3DDevice9* device);

	int handle(char* type, char* ev);
protected:
    ID3DXFont*                   m_pFont;

    // Scene
    LPDIRECT3DVERTEXBUFFER9      m_pVB;
    LPDIRECT3DINDEXBUFFER9       m_pIB;
    DWORD                        m_dwNumVertices;
    DWORD                        m_dwNumIndices;
    LPDIRECT3DVERTEXSHADER9      m_pVertexShader;
    LPD3DXCONSTANTTABLE          m_pConstantTable;
    LPDIRECT3DVERTEXDECLARATION9 m_pVertexDeclaration;
	D3DXHANDLE m_handle;
    DWORD                        m_dwSize;
    BOOL                         m_bShowHelp;

     // Navigation
    CModelViewerCamera           m_Camera;
};
#endif 
