
#include <hush/source.h>
#include <hush/query.h>
#include "menu-dots.h"

// sub scenes

//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
#include "lectures/lecture-eca.h"
#include "lectures/lecture-imm.h"
#include "lectures/lecture-vip.h"
#include "lectures/lecture-effects.h"
//#include "odyssee/scene-test.h"
#include "objects/background-scene.h"
#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"
#include "extra/object-dolphin.h"
#include "extra/object-spectrum.h"
#include "extra/object-grab.h"
#include "scene/video.h"
#include "extra/object-water.h"
#include "extra/object-flag.h"


#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 2;
static int enable = 0;

static int testmode = 0;
static msg_array msg;

menu_dots::menu_dots() 
{

_msg = &msg;

_selection = preset;
_enabled = enable;

_stack = 1;
set_mode(1);

clear(&msg);

//debug("dots 1",1);

//msg[1][1] = "odyssee";
msg[1][2] = "...";
//msg[1][2] = "???";
//msg[1][3] = "codecs and standards";
//msg[1][4] = "information retrieval";

_states = 5;
state = 1;

_display = "the (next) logical step";

_exclusive = 1;
//count =  states + 2;
if (!_tk) {
	_tk =  new query("kit=pl");
}

char* _test = "sim";
if ( _tk) {

char args[]="kit=pl src=file:/vip/scripts/scene.pl";
   // char args[]="kit=pl src=go.pl";
   _tk->source("file:/vip/scripts/scene.pl");
    //query* q = new query(args);
	//q->source("d:/hush/library/pl/hush.pl");
//	cout << "start:1" << endl;
    //q->bind("xerr", new cerr_handler(q));
	//cout << "start:2" << endl;
	//q->evaluate("cerr(hello))");
   //debug("dots 2",1);
	
	//AE/sebas
	
   /*
   _tk->eval("X:title(X)");
	char* p = _tk->result();
	_display = p;
*/

	//debug("dots 3",1);
	/*
	_test = _tk->strvalue("X:package(X)");
	_tk->load(_test);
	_test = _tk->strvalue("X:scene(X)");
	*/
	//debug("dots tk",1);
	_tk->load("x");
	_tk->load("donuts");
	_tk->load("shader");
	_tk->load("anim");
	_tk->load("dossier");

	//debug("dots test",1);
	_test = "vip/morph"; //"vip/morph";
	//_test = "anim/try"; //"vip/morph";
	
	
	//_tk->load("sim");
	//_tk->load("text");
}
//debug("dots 4",3);
scenes[1] = 0; //new lecture_effects();
//scenes[2] = new lecture_imm();
//scenes[3] = new lecture_eca();
//scenes[1] = new scene_odyssee();
//scenes[2] =  new video( new object_grab());
//scenes[2] =  new object_grab();
//scenes[2] = (dxscene*) dvscene::lookup("object/dolphin");
scenes[2] = 0; //(dxscene*) dvscene::lookup(_test);
//scenes[2] = sc("dossier/morph")->create("text=text/casus");
scenes[2] = sc("dossier/sample");
//scenes[2] = sc("party/sebas");
//debug("dots 5",3);

//scenes[3] =  new object_water();
scenes[3] = (dxscene*) dvscene::lookup("x");
scenes[4] = (dxscene*) dvscene::lookup("vip/morph");
scenes[5] = (dxscene*) dvscene::lookup("vip/flag");
//scenes[4] = new object_flag();
//scenes[4] = sc("dossier/morph")->create("text=text/casus");
//scenes[4] = sc("dossier/game"); //->create("text=text/casus");

scenes[10] = new object_dolphin();
//debug("dots dolph",3);

_exclude[10] = 1;

//_shader = "nil";

//if (!_main()->is("application","donuts")) {


/*
scene* s = new scene();
s->count = 4;
s->scenes[1] = sc("vip/trio");
s->scenes[2] = sc("anim/trio");
scenes[11] = s; //sc("vip/trio");
//scenes[11] = sc("anim/trio");
_exclude[11] = 1;//0;
//}
*/
_stack = 1;


//debug("dots end",3);

}

menu_dots::~menu_dots()
{
//delete scenes[];
}


HRESULT menu_dots::compose(IDirect3DDevice9* device, DWORD t){
	HRESULT hr = S_OK;
	//count = 12;
	_exclude[10] = 0;
	scenes[10]->state = 1;
	_exclude[11] = 0;
	if (_enabled) _exclude[11] = 1;
	//_exclude[11] = 0;
	_project(_active());
	_effect = 0;
	fx("walk",(ieffect*)_main());


	return hr;
}
/*
HRESULT 
menu_dots::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

	//restore(device);

    for (int i = 1; i < count; i++) _exclude[i] = 1;
	//_handler = _menu;
	//_menu->exclude(0);

    if (!_enabled || _selection == 0) {
		_handler = _menu;
		_exclude[count-1] = 0;
		_menu->state = state;
		//_menu->exclude(0);
	} else if (_enabled && _selection > 0) {
		//scenes[_selection]->exclude(0);
		_handler = scenes[_selection];
		_exclude[_selection] = 0;
		_exclude[count-1] = 1;
		//_menu->exclude(1);
	}

	render_begin(device);


	hr = scene::render(device,texture); // calls restore, compose, render
   

	if (!_selection) display(_display);
	render_end(device);

 
    return hr;
}

*/