#include <hush/source.h>
#include "menu-scenes.h"

// sub scenes

//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
#include "lectures/lecture-eca.h"
#include "lectures/lecture-imm.h"
#include "lectures/lecture-vip.h"
#include "lectures/lecture-effects.h"
//#include "lectures/scene-test.h"
#include "objects/background-scene.h"
#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"

#include "odyssee/scene-0.h"
#include "odyssee/scene-1.h"
#include "odyssee/scene-2.h"
#include "odyssee/scene-3x.h"

#include "extra/object-vsh.h"
#include "extra/object-dolphin.h"
#include "extra/object-spectrum.h"

#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 1;
static int enable = 0;

static int testmode = 0;
static msg_array msg;

menu_scenes::menu_scenes() 
{


_msg = &msg;

_selection = preset;
_enabled = enable;
_exclusive = 1;

clear(&msg);



msg[1][1] = "1";
msg[1][2] = "2";
msg[1][3] = "3";
//msg[1][4] = "2";
//msg[1][5] = "3";

//msg[1][3] = "codecs and standards";
//msg[1][4] = "information retrieval";

_states = 9;
state = 1;

_display = "scenes";

//count =  states + 2;


//scenes[1] = new lecture_scenes();
//scenes[2] = new scene_0();
scenes[1] = new scene_1();
scenes[2] = new scene_2();
scenes[3] = new scene_3x();

scenes[1]->end(20);
scenes[2]->end(20);
scenes[3]->end(20);
//scenes[5]->end(20);

scenes[1]->loop = 1;
scenes[2]->loop = 1;
scenes[3]->loop = 1;
//scenes[5]->loop = 1;

//scenes[2] = new lecture_imm();
//scenes[3] = new lecture_eca();
//scenes[4] = new scene_odyssee();


}

menu_scenes::~menu_scenes()
{
//delete scenes[];
}

/*
HRESULT 
menu_scenes::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

	//restore(device);

    for (int i = 1; i < count; i++) _exclude[i] = 1;
	//_handler = _menu;
	//_menu->exclude(0);

    if (!_enabled || _selection == 0) {
		_handler = _menu;
		_exclude[count-1] = 0;
		_menu->state = 1;
		//_menu->exclude(0);
	} else if (_enabled && _selection > 0) {
		//scenes[_selection]->exclude(0);
		_handler = scenes[_selection];
		_exclude[_selection] = 0;
		_exclude[count-1] = 1;
		//_menu->exclude(1);
	}

	render_begin(device);


	hr = scene::render(device,texture); // calls restore, compose, render
   

	if (!_selection) display(_display);
	render_end(device);

 
    return hr;
}

*/
