//------------------------------------------------------------------------------
// File: Planesub_scene.cpp
//
// Desc: DirectShow sample code - implementation of the sub_scene class
//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//------------------------------------------------------------------------------


#include "sub-scene.h"

// sub scenes

#include "objects/cylinder-scene.h"
#include "objects/plane-scene.h"
#include "objects/background-scene.h"
#include "objects/image-scene.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


sub_scene::sub_scene() 
{

count = 2; //

//scenes[0] = new cylinder_scene();
scenes[0] = new cylinder_scene();
//scenes[1] = new cylinder_scene(2);
scenes[1] = new plane_scene();
//scenes[2] = new background_scene(_T("C:/AE/media/soutine.jpg"));
//scenes[2] = new background_scene();
//scenes[2] = new image_scene();

scale(0.5f,0.5f,0.5f);
//translation(10.0f,-10.0f,0.0f);

//scenes[3] = new image_scene(_T("C:/AE/media/soutine.jpg"));
scenes[4] = new image_scene();
//scenes[3]->scale(100.0f,100.0f,100.0f);
//scenes[3]->translation(0.0f,0.0f,-2.0f);

}

sub_scene::~sub_scene()
{
//delete scenes[];
}






HRESULT 
sub_scene::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

    rotation(0,0,0.5f, fraction() * 3.14f);


	render_begin(device);

    // begin the sub_scene


	hr = scene::render(device,texture); // calls restore, compose, render


  
	render_end(device);

  

    return hr;
}

