#include <hush/source.h>
#include "scene.h"
#include "scene/text.h"
#include "direct/transform.h"
#include <hush/event.h>
#include <hush/dictionary.h>
#include <hush/list.h>

#include <dshow.h>

//int* __cdecl _errno(void) { return 0; }

//#include "video/dshowtextures.h"
#include "scene/video.h"
#include <atlbase.h>


#ifndef _UNICODE
//#define _UNICODE
#endif
#ifndef _MBCS
//#define _MBCS
#endif

/*
class  scene_entry  {
public:
scene_entry( scene* raw, char* k, int i= -1);
scene* operator=( scene* v ); 
operator scene*(); 
private:
int _i;
char* _k;
scene* _raw;
};
*/

#include <atlbase.h>
#include <comutil.h>
#include "common90/d3d-util.h"
//static CCritSec _cs;
//#define __FILTER__

#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>

//#include <wxutil.h>
#include <tchar.h>
#undef text
#include <hush/sim/simulation.h>
#include <hush/sim/generator.h>
#undef text
#define text dxtext


// export these !!!

int scene::ready() { return _initialized; } 
int scene::supervise(int s) { return 1; } 

int scene::_load() { return init(_device); } 
int scene::_render() { return (int) render(_device,_texture); }
int scene::_restore() { return (int) restore(_device); }
int scene::_compose() { return (int) compose(_device,0); }


	int scene::random() { return rand(); }
	int scene::random(int u) { return (random() % (u)); } 
	int scene::random(int d,int u) { int tmp = random(u-d); return d+tmp; }
	int scene::random(char* k) { float x[2]; fval(k,2,x); int d = (int) x[0]; int u = (int) x[1]; return random(d,u); }


static int instr(char c, char* s) {
	while ( *s && *s++ != c );
	return (int) *s;
	}

static void getfv(char* str, int _max, float* x) {
	char buf[512];
	strcpy(buf,str);
    char* p = buf; char* q = buf;
	p += 1; q=p+1;
	int i = 0; 
	while (i < _max && q && *q && p && *p) {
		//cerr << "p: " << p << endl;
		//char b[64];
		int incr = 0;
		while (*q && !instr(*q,"[,;:(<>)]")) {
			q++;
			
		    }
		if (q && instr(*q,"[,;:(<>)]")) incr = 1;
			//*q != '(' &&  *q != ')' && *q != ',') { q++; }
		*q = '\0';
		//strcpy(b,p);
		//cerr << "p: " << p << "---" << endl;
		sscanf(p,"%f",x+i);
		*q = ' ';
		p = q+incr; 
		if (instr(*p,"[,;:(<>)]")) *p = ' ';
		q=p+1;
		i++;
	}
}

char* scene::fval(char* k, int m, float* x) {
	char* v = opt(k);   
	if (v) getfv(v,m,x);
	return v;
}


void scene::f2val(char* k, float* x, float* y) {
    char* v = opt(k);   
	float xx[2]; getfv(v,2,(float*)xx);
	*x = xx[0]; *y = xx[1];
}

void scene::f3val(char* k, float* x, float* y, float* z) {
    char* v = opt(k);   
	float xx[3]; getfv(v,3,(float*)xx);
	*x = xx[0]; *y = xx[1]; *z = xx[2];
}

void scene::f4val(char* k, float* x, float* y, float* z, float* a) {
    char* v = opt(k);   
	float xx[4]; getfv(v,4,(float*)xx);
	*x = xx[0]; *y = xx[1]; *z = xx[2];
}

char* scene::opt(char* k, char* v) {
	char* tmp = option(k); if (v) option(k,v); return tmp;
}
int scene::iopt(char* k, int v){
	int tmp = ioption(k); if (v) ioption(k,v); return tmp;
}
float scene::fopt(char* k, float v){
	float tmp = foption(k); if (v) foption(k,v); return tmp;
}
void* scene::popt(char* k, void* v){
	void* tmp = poption(k); if (v) poption(k,v); return tmp;
}
scene* scene::scopt(char* k, scene* v){
	scene* tmp = (scene*) poption(k); if (v) poption(k,v); return tmp;
}

void* scene::xopt(char* k, void* v){
	void* tmp = poption(k); if (v) poption(k,v); return tmp;
}

scene* scene::scr(char* k, scene* v) {
	scene* tmp = 0;
	//tmp	= scopt(k);
	if (!tmp) 
		tmp = (scene*) scene::lookup(k); 
	if (v) scene::declare(k,v);
	return tmp;
}

scene* scene::sc(char* k, scene* v) {
	scene* tmp = 0;
	tmp	= scopt(k);
	if (!tmp)
		tmp = lst(k);
	if (!tmp) 
		tmp = (scene*) scr(k); 
	if (v) {
		scopt(k,v);
		if (iopt("import")) lst(k,v);
		if (iopt("export") && (!scr(k) || iopt("override"))) scr(k,v);
	}
	return tmp;
}

scene* scene::sc(int i, scene* v) {
	scene* tmp = 0;
	tmp	= scenes[i];
	if (v) {
		scenes[i] = v;
	}
	return tmp;
}

void* scene::ptr(char* pre, char* k, void* v) {
	scene* _sc = scene::_main();
	char buf[512];
	sprintf(buf,"%s:%s",pre,k);
	void* tmp = _sc?_sc->popt(buf,v):0;
	return (tmp==_sc)?0:tmp;
}

void* scene::ptr(char* pre, int k, void* v) { // int encoded
    char buf[64];
	sprintf(buf,"%d",k);
	return scene::ptr(pre,buf,v);
}

char* scene::sptr(char* pre, char* k, char* v) {
	scene* _sc = scene::_main();
	char buf[512];
	sprintf(buf,"%s:%s",pre,k);
	char* tmp = _sc?_sc->opt(buf,v):0;
	if (!tmp) return "nil";
	return (strcmp(tmp,"nil")?tmp:"nil");
}

char* scene::sptr(char* pre, int k, char* v) { // int encoded
    char buf[64];
	sprintf(buf,"%d",k);
	return scene::sptr(pre,buf,v);
}

char* scene::lsptr(char* pre, char* k, char* v) {
	scene* _sc = this; //scene::_main();
	char buf[512];
	sprintf(buf,"%s:%s",pre,k);
	char*  tmp = _sc?_sc->opt(buf,v):0;
	if (!v && tmp && !strcmp(k,"eq")) {
	    return eq(tmp);
	}
	if (!tmp) return k;
	return (strcmp(tmp,"nil")?tmp:k);
}

char* scene::lsptr(char* pre, int k, char* v) { // int encoded
    char buf[64];
	sprintf(buf,"%d",k);
	return scene::lsptr(pre,buf,v);
}

int scene::iptr(char* pre, char* k, int v) {
	scene* _sc = scene::_main();
	char buf[512];
	sprintf(buf,"%s:%s",pre,k);
	int tmp = 0;
	tmp = _sc?_sc->iopt(buf):0;
	if (v != -1) {
		char bufx[64]; sprintf(bufx,"%d",v);
		if (_sc) _sc->opt(buf,bufx);
	}
	return tmp;
}

int scene::iptr(char* pre, int k, int v) { // int encoded
    char buf[64];
	sprintf(buf,"%d",k);
	return scene::iptr(pre,buf,v);
}

void* scene::xp(char* k, void* v) { return (void*) scene::ptr("fx",k,v); }
void* scene::xp(int k, void* v) { return (void*) scene::ptr("fx",k,v); }

ieffect* scene::fx(char* k, ieffect* v) { return (ieffect*) scene::ptr("fx",k,v); }
ieffect* scene::fx(int k, ieffect* v) { return (ieffect*) scene::ptr("fx",k,v); }

itexture* scene::tx(char* k, itexture* v) { return (itexture*) scene::ptr("tx",k,v); }
itexture* scene::tx(int k, itexture* v) { return (itexture*) scene::ptr("tx",k,v); }

itexture* scene::cp(char* k, itexture* v) { return (itexture*) scene::ptr("cp",k,v); }
itexture* scene::cp(int k, itexture* v) { return (itexture*) scene::ptr("cp",k,v); }

int scene::ds(char* k, int v) { return (int) scene::iptr("ds",k,v); }
int scene::ds(int k, int v) { return (int) scene::iptr("ds",k,v); }

char* scene::cm(char* k, char* v) { return (char*) scene::sptr("cm",k,v); }
char* scene::cm(int k, char* v) { return (char*) scene::sptr("cm",k,v); }

char* scene::eq(char* k, char* v) { return (char*) scene::lsptr("eq",k,v); }
char* scene::eq(int k, char* v) { return (char*) scene::lsptr("eq",k,v); }

char* scene::cmd(char* k, char* v) { return (char*) scene::lsptr("cm",k,v); }
char* scene::cmd(int k, char* v) { return (char*) scene::lsptr("cm",k,v); }


float scene::speed(float x) { float tmp = _speed; if (x >= 0) _speed = x; return tmp; }
	
float scene::rx(float x) { return 0; }
float scene::ry(float y){ return 0; }
float scene::rz(float z){ return 0; }


static int _entrycnt = 0;
static scene_entry* _entry[10] = { 0, 0,0,0,0,0,0,0,0,0 };

scene_entry& scene::operator[](const char* k) { return *(new scene_entry(this,(char*)k)); }
scene_entry& scene::operator[](const int k) { return *(new scene_entry(this,(char*) 0,(int)k)); }

scene_entry::scene_entry( scene* raw, char* k, int i) : _i(i), _k(k), _raw(raw) {
_entry[_entrycnt++] = this;
if (_entrycnt >= 10) _entrycnt = 0;

}

scene* scene_entry::operator=( scene* v ) {
	if (!_k) return _raw->sc(_i,v);
	return _raw->sc(_k,v);
	//return (scene*) v;
	}
scene_entry::operator scene*() {
	if (!_k) return _raw->sc(_i);
	return _raw->sc(_k);
	}




#define sclst ((dictionary<scene>*)_sclst)
#define fxlst ((dictionary<ieffect>*)_fxlst)

scene* scene::lst(char* k, scene* v) {
	scene* tmp = 0;
	chlst();
	tmp = (*sclst)[k];
	if (v) { // check for 0
		(*sclst)[k] = v;
	}
	return tmp;
}

scene* scene::unlst(char* k, scene* v) {
	scene* tmp = 0;
	if (!sclst) return tmp;
	chlst();
	tmp = (*sclst)[k];
	if (1) { // don t check for 0
		(*sclst)[k] = v;
	}
	return tmp;
}


// global static (pre opt time)

int scene::fullscreen = 0;

//int scene::width = 1440;
//int scene::height = 900;

//int scene::width = 1280;

int scene::__width = 1024;
int scene::__height = 768;

int scene::width(int x) { int tmp = __width; if (x >= 0) __width = x; return tmp; }
int scene::height(int x) { int tmp = __height; if (x >= 0) __height = x; return tmp; }

//int scene::width = 800;
//int scene::height = 600;

//int scene::width = 640;
//int scene::height = 480;


int scene::__cx = 0;
int scene::__cy = 0;

scene* scene::__video = 0;

//kit* scene::tk = 0;


int scene::_embedded = 0;
int scene::rendering = 0;
float scene::_felapsed = 0;
int scene::_frames = 0;
float scene::_fps = 0;

scene* scene::__handler = 0;
char scene::__key[128] = "none";
char* scene::_key(char* x) {
	char* tmp = __key; if (x) strcpy(__key,x); return tmp; 
}


char scene::__drive[256] = "d:";
char* scene::_drive(char* x) {
	char* tmp = __drive; if (x) strcpy(__drive,x); return tmp; 
}

char* scene::loc(char* x) {
	return fm("%s%s",_drive(),x);
}
	
/*

int scene::fullscreen = 0;

//int scene::width = 1280;

int scene::width = 1024;
int scene::height = 768;

//int scene::width = 800;
//int scene::height = 600;

//int scene::width = 640;
//int scene::height = 480;

  */

int scene::__hall = 0;
int scene::__movies = 0;
int scene::__game = 0;



scene* scene::__main = 0;
scene* scene::_main(scene* x) { scene* tmp = __main; if (x) __main = x; return tmp; }

scene* scene::__plain = 0;
scene* scene::__large = 0;
scene* scene::__small = 0;
scene* scene::__ultra = 0;

scene* scene::_plain(scene* x) { scene* tmp = __plain; if (x) __plain = x; return tmp; }
scene* scene::_large(scene* x) { scene* tmp = __large; if (x) __large = x; return tmp; }
scene* scene::_small(scene* x) { scene* tmp = __small; if (x) __small = x; return tmp; }
scene* scene::_ultra(scene* x) { scene* tmp = __ultra; if (x) __ultra = x; return tmp; }

int scene::_cx(int x) { int tmp = __cx; if (x >= 0) __cx = x; return tmp; }
int scene::_cy(int x) { int tmp = __cy; if (x >= 0) __cy = x; return tmp; }

//int scene::_source = 0;

scene* scene::__master = 0;

scene* scene::_master(scene* x) { scene* tmp = __master; if (x) __master = x; return tmp; }
scene* scene::_handler(scene* x) { scene* tmp = __handler; if (x) __handler = x; return tmp; }

//int scene::interactive = 1;
//int scene::machine = 0;


int scene::__ctrl = 0;
int scene::__shift = 0;

int scene::_ctrl(int x) { int tmp = __ctrl; if (x >= 0) __ctrl = x; return (tmp + ds("control")); }
int scene::_shift(int x) { int tmp = __shift; if (x >= 0) __shift = x; return (tmp + ds("shift")); }



    int scene::__interactive = 1;
	int scene::_interactive(int x) { int tmp = __interactive; if (x >= 0) __interactive = x; return tmp; }
	
	char* scene::__name;
	char* scene::__names[12] = { 0,0,0,0,0,0,0,0,0,0,0,0 };

	void* scene::__source = 0;
	void* scene::_source(void* x) { void* tmp = __source; if (x) __source = x; return tmp; }

	void* scene::__sources[12] = { 0,0,0,0,0,0,0,0,0,0,0,0 };


	int scene::__running[12] = { 0,0,0,0,0,0,0,0,0,0,0,0 };
	int scene::__active = 0;
	int scene::_active(int x) { int tmp = __active; if (x >= 0) __active = x; return tmp; }

	
	int scene::__total = 0; 
	int scene::_total(int x) { int tmp = __total; if (x >= 0) __total = x; return tmp; }

	IDirect3DTexture9* scene::__captures[256] = { 0,0,0,0,0,0,0,0,0,0,0,0 };
	//IDirect3DTexture9* scene::_capture = 0;

	//IDirect3DTexture9* scene::_texture = 0;
	IDirect3DTexture9* scene::__textures[256];

	IDirect3DTexture9* scene::_textures(int i, IDirect3DTexture9* x) {
		IDirect3DTexture9* tmp = __textures[i];
		if (x) __textures[i] = x;
		return tmp;
	}

	
	IDirect3DTexture9* scene::_captures(int i, IDirect3DTexture9* x) {
		IDirect3DTexture9* tmp = __captures[i];
		if (x) __captures[i] = x;
		return tmp;
	}


	int scene::__project = 0;
	int scene::__select = 0;
	int scene::__backdrop = 0;

    int scene::_project(int x) { int tmp = __project; if (x >= 0) __project = x; return tmp; }
	int scene::_select(int x) { int tmp = __select; if (x >= 0) __select = x; return tmp; }
	int scene::_backdrop(int x) { int tmp = __backdrop; if (x >= 0) __backdrop = x; return tmp; }

	int scene::embedded() { return _embedded; }

static double _hold = 0;



 parser* scene::__flt = 0;
 parser* scene::flt(parser* x) { parser* tmp = __flt; if (x) __flt = x; return tmp; }

 query* scene::__tk = 0;
 query* scene::tk(query* x) { query* tmp = __tk; if (x) __tk = x; return tmp; }

  generator* scene::__gn = 0;
 generator* scene::gn(generator* x) { generator* tmp = __gn; if (x) __gn = x; return tmp; }

simulation* scene::__sim = 0;
simulation* scene::sim(simulation* x) { simulation* tmp = __sim; if (x) __sim = x; return tmp; }


D3DXMATRIX* scene::_world(D3DXMATRIX* x) { D3DXMATRIX* tmp = __world; if (x) __world = x; return tmp; }
D3DXMATRIX* scene::_view(D3DXMATRIX* x) { D3DXMATRIX* tmp = __view; if (x) __view = x; return tmp; }
D3DXMATRIX* scene::_projection(D3DXMATRIX* x) { D3DXMATRIX* tmp = __projection; if (x) __projection = x; return tmp; }
D3DXMATRIX* scene::_wvp(D3DXMATRIX* x) { D3DXMATRIX* tmp = __wvp; if (x) __wvp = x; 
if (!__wvp && !x) { __wvp = new D3DXMATRIX(); }
*__wvp = (*_world()) * (*_view()) * (*_projection());  
return __wvp;
//return tmp; 
}

void scene::handle_event(char* type, char* ev) {
	if (__handler) __handler->handle(type,ev);
}

int scene::event() {
	int x = _event;  _event = 0;  return x;
}

int scene::condition() {
	return _condition;
}



char* scene::fm(char* szFormat, ...)
{
	static int tot = 10;
	static int idx = 0;
	if (idx > tot-1) idx = 0;
	static char szBuffer[10][1024];  // Large buffer for long filenames or URLs
    const size_t NUMCHARS = sizeof(szBuffer[0]) / sizeof(szBuffer[0][0]);
    const int LASTCHAR = NUMCHARS - 1;

    // Format the input string
    va_list pArgs;
    va_start(pArgs, szFormat);

    // Use a bounded buffer size to prevent buffer overruns.  Limit count to
    // character size minus one to allow for a NULL terminating character.
    _vsntprintf(szBuffer[idx], NUMCHARS - 1, szFormat, pArgs);
    va_end(pArgs);

    // Ensure that the formatted string is NULL-terminated
    szBuffer[idx][LASTCHAR] = '\0'; // TEXT('\0');

	return (char*) szBuffer[idx++];
    
}

scene* scene::type(char* x) { return (dxscene*) dvscene::lookup(x); }

scene* scene::create(char* opts) {
	//debug("empty create",1);
	//process(opts);
	return this;
}

int scene::instring(char c, char* s) {
	while ( *s && *s != c ) s++;
	return (int) *s;
	}

int scene::debug(char* x, int k) {
HRESULT mb = IDNO;
	if (_debug || k)   mb = MessageBox(0,x,_display,MB_YESNO | MB_ICONQUESTION );
				 if (mb == IDNO) return 0;
				 else return 1;
}

void scene::propagate(char* opts, int d) { 
	process(opts);
	if (d = -1) d = 100;
	 if (_scene && d > 0) { _scene->propagate(opts,d-1);  }
	if (d > 0) for (int i=0; i < count; i++) {
            if (scenes[i]) { 
				scenes[i]->propagate(opts,d-1);
			}
	}

}


void scene::options(char* opts) { 

    static char buf[512];
	strcpy(buf, "no new x");
	string_converter x((char*)opts);
	for (int i = 1; i <= x.argc(); i++ ) {
	attribute p(x[i]);
	option((char*)p.key(),(char*)p.value());
	if (p.matches("debug")) { _debug = ioption(p.key()); }
	else if (p.matches("display")) { _display = p.value(); }
	else if (p.matches("speed")) { _speed = fopt((char*)p.key()); }
	//_display = "match x";
	//if (!strcmp(p.key(),"display")) { _display = p.value(); }
	}
    //_display = (char*) buf; //"new x";

}


int scene::handle(char* type, char* ev) {

	//char buf[256];
	//sprintf(buf,"%s: %s",type,ev);
	//MessageBox(0,buf,"media",MB_OK);
	if (check(type,ev,"button","down")) {
		if (state == 0 && _condition == WAIT) _condition = START;
		else if (_condition == WAIT) _condition = RUNNING;
		else (_condition = WAIT);
	} else if (check(type,ev,"arrow","down")) {
		if (_text) _text->next();
		else if (_menu) _menu->next();

		//else if (_slides) _slides->next();
	} else if (check(type,ev,"arrow","up")) {
		if (_text) _text->next(-1);
		else if (_menu) _menu->next(-1);
		//else if (_slides) _slides->next(-1);
	} else if (!strcmp(ev,"escape")) {
		exit(1);
	} else if (check(type,ev,"key","back")) {
		if (_slides) _slides->next(-1);
	} else if (check(type,ev,"key","tab")) {
		if (_slides) {
			int x = _slides->exclude();
			if (x == 0) x = 1; else x = 0;
			_slides->exclude(x);
		} else _condition = END;
	} else if (check(type,ev,"key","space")) {
		_condition = START;
    } else if (check(type,ev,"arrow","right")) {
		if (_menu) {
			_enabled = 1;
			//_exclusive = 0;
		} else
			if (state == 0 && _condition == WAIT) _condition = START;
	} else if (	check(type,ev,"key","return")) {
		if (_menu ) {
		_enabled = 1;
		//_exclusive = 1;
		} else
		//scene::_handler = _parent;
		_condition = START;
	} else if ((_ctrl() && check(type,ev,"key","c"))
		       || check(type,ev,"arrow","left")) {
		if (_ctrl()) state = END;
		__handler = _parent;
		//if (_handler->_menu) _handler = _handler->_menu;
		// (1 || !_handler) _handler = scene::_main->_scene;
		__handler->_enabled = 0;
	}
	sprintf(__key,"%s: %s", type, ev);
    return _event = _condition;
}
	


DWORD scene::argb(int a, int r, int g, int b) {
	return D3DCOLOR_ARGB(a,r,g,b);
}
DWORD scene::rgb( int r, int g, int b) {
	return argb(_a,r,g,b);
}




float scene::fps() { return scene::_fps; }


static double get_seconds() {
double tFactor = 0.001f;
return ((double)timeGetTime()) * tFactor;
}

scene::scene() 
{

scenes[0] = 0;
count = 0;
__init();
}

scene::scene(scene* x)
{
scenes[0] = 0;
count = 0;

__init();
_scene = x;
}

scene::scene(char* opts)
{
scenes[0] = 0;
count = 0;
__init();
if (opts) process(opts);
}



void scene::check_cs() {
	if (!_cs) _cs = new CCritSec();
}

void scene::chlst() {
	if (!_sclst) _sclst = new dictionary<scene>();
}

void scene::chfx() {
	if (!_fxlst) _fxlst = new dictionary<LPD3DXEFFECT>();
}

void scene::__init() {
	option("key","scene");
	_speed = 1;
	_lst = 0;
	_sclst = 0;
	_fxlst = 0;
	///D3DXMATRIX* _world;
	__world = new D3DXMATRIX();
	__view = new D3DXMATRIX();
	__projection = new D3DXMATRIX();
	__wvp = 0;
	_effect = 0;
	_shader = 0;
	_transform = 0;
	_tk = scene::tk();
    _sim = scene::sim();
	_flt = scene::flt();
	_gn = scene::gn();
	_blend = 0;
	_lights = 0;
	_drops = 0;
	_factor = 1.0;
 _cs = 0;
	_width = 320;
	_height = 240;
	_pitch = 0;
_once = 0;

//_tk = scene::tk;

_initialized = 0;
_lazy = 1; //AE
_title = _T("scene");

_exclusive = 0;	

_selection = 0;
_enabled = 0;
_menu = 0;
_absolute = 0;
    _texture = 0;
	_capture = 0;
	_index = 0;
	//IDirect3DTexture9* _texture;
	//IDirect3DTexture9* _textures[];
	
	
_display =_T("");
_text = 0;
_txt = 0;
//_color = 0xff0ffffff;
_color = argb(255,255,255,255);
_alt = argb(255,255,150,150);
_menu = 0;
_debug = 0;
_show = 0;
_slides = 0;
_scene = 0;
_parent = 0;
_bg = 0;
_x = 0;
_y = 0;
_lx = 0;
_ly = 0;
_rx = 0;
_ry = 0;
_a = 256;
_r = 256;
_g = 256;
_b = 256;
m_fTU = 1.0f;
m_fTV = 1.0f;
_tu = 1.0f;
_tv = 1.0f;
_mode = 1;
_font = 0;
excl = 0;
_size = 24;
_letterset = "Times New Roman";
sprintf(_type, "scene");
_event = 0;
_condition = 0;
_inc = 30;
_stack = 0;

	for (int i=0; i < MAX_SCENE; i++) {
            scenes[i] = 0; _exclude[i] = 0;
	}	

state = 0;
_fraction = 0.0f;
_begin = 0; //get_seconds();
_holdtime = 0;
_end = 0;
_time = 0;
_last = 0;
loop = 0;

_rate = 0;
_elapsed = 0;
_max = 0;
_idx = 0;


sprintf(__key,"none");

//_handler = this; // set event handler
_condition = WAIT;

if (width() >= 1400) {
	_tab = 50;
	_lx = 20; _ly = height() - 70; 
	_rx = width() - 350; _ry = height() - 70;
	_size = 20; _tab = 20;
	_x = __cx + 30 + width() / 3; _y = __cy + height() / 3; 

} else if (width() >= 1200) {
	_tab = 50;
	_lx = 20; _ly = height() - 70; 
	_rx = width() - 350; _ry = height() - 70;
	_size = 20; _tab = 20;
	_x = __cx + 30 + width() / 3; _y = __cy + height() / 3; 

} else if (width() == 1024) {
	_tab = 50;
	_lx = 20; _ly = height() - 70; 
	_rx = width() - 350; _ry = height() - 70;
	_size = 20; _tab = 20;
	_x = __cx + -20 + width() / 3; _y = __cy + height() / 3; 
} else if (width() == 800) {
	_tab = 50;
	_lx = 20; _ly = height() - 50; 
	_rx = width() - 350; _ry = height() - 50;
	_size = 18; _tab = 20;
	_x = __cx - 20 + width() / 3; _y = __cy + height() / 3;
} else if (width() == 640) { 
	_tab = 50;
	_lx = 20; _ly = height() - 50; 
	_rx = width() - 350; _ry = height() - 50; 
	_size = 16; _tab = 20;
	_x = __cx - 20 + width() / 3; _y = __cx + height() / 3;
 }


}

scene::scene(int top) 
{

	if (top == 1) {
		//scenes[0] = new main_scene();
        //count = 1;
	}
__init();
}

int scene::check(char* type, char* ev, char* xt, char* xe) {
	return !strcmp(type,xt) && !strcmp(ev,xe);
}

int scene::is(char* s) { return !strcmp(_type,s); }

void scene::interval(double tb, double te) {
begin(tb); end(te);
}

double scene::now() { return get_seconds(); }

double scene::current() { 
	double t; t = get_seconds();
	_time = (t - _begin) * _speed;
	double dtime = (t - _holdtime) * _speed;//dxtime();


	if (dtime >= _end) {
		if (loop) {
			_holdtime = t;
		    //DWORD xtime = (DWORD) _time * 1000;
			//DWORD xend = (DWORD) _end * 1000;
			dtime = 0; //((double)(xtime % xend)) * 0.001;
		}
	}
return dtime;
}

int scene::inbetween(float tb, float te) {
double xt = current();
return (xt >= tb && xt < te)?1:0;
}

int scene::inbetween(char* iv) { return in(iv); }

int scene::in(char* iv) {
float xv[2] = { 0, 0 };
char* r = fval(iv,2,xv);
debug(fm("%s=%s",iv,r),0);
if (r) return inbetween(xv[0],xv[1]);
else return 0;
}



int scene::in(float b, float e) { return inbetween(b,e); }
int scene::in(int s) { return state == s; } // == state

int scene::is(char* k, char* v) { char* p = opt(k); if (p) return (!strcmp(p,v)); else return 0; }


void scene::begin(double t) { _holdtime = _begin = (t>0.001)?t:get_seconds(); }
void scene::end(double t) { _end = (t>0.001)?t:get_seconds(); }
double scene::dxtime() {
	
	double t; t = get_seconds();
	_time = (t - _begin) * _speed;
	return _time;
	//return entity::time();
}

double scene::delta() {
    return _time - _last;
}



float scene::fraction() {
    double dtime;
	if (_end == -1) return 0;

	double t; t = get_seconds();
	_time = (t - _begin) * _speed;
	dtime = (t - _holdtime) * _speed;//dxtime();

	if (dtime >= _end) {
		if (loop) {
			_holdtime = t;
			//DW/ORD xtime = (DWORD) _time * 1000;
			//DWORD xend = (DWORD) _end * 1000;
			dtime = 0; //((double)(xtime % xend)) * 0.001;
		}
		else return 1;
	}

    _fraction =  (float)( dtime / _end );
	return _fraction;
}

scene::~scene()
{
	for (int i=0; i < count; i++) {
            if (scenes[i]) delete scenes[i];
	}
        if (_scene) delete _scene;
}


//HRESULT DrawTextScaled( FLOAT x, FLOAT y, FLOAT z, 
  //                          FLOAT fXScale, FLOAT fYScale, DWORD dwColor, 
    //                        const TCHAR* strText, DWORD dwFlags=0L );


void scene::message(int x,int y, DWORD color, const char* m) {
char* ts = (char*)m;
if (!ds("text:off") && _font) _font->DrawText(x, y, color, ts);
//_font->DrawTextScaled(x,y,10,1,1,color,m);
}


int scene::exclude() { return excl; }
void scene::exclude(int t) { excl = t; }


int scene::get_mode() { return _mode; }
void scene::set_mode(int t) { _mode = t; }

int scene::index() { 
	return _slides?_slides->index():
	       (_text?_text->index():
	       _idx); }
void scene::index(int t) {
     if (_slides) _slides->index(t);
	 else if (_text) _text->_text->index(t);
	 else if (_menu) _menu->_menu->index(t);
	 else { _idx = t; _selection = t; }
 }

int scene::next(int t) { 
    if (_slides) return _slides->next(t);
	//else if (_text) return _text->next(t);
	int x = (t==0)?1:t;
	_idx +=x;
	if (_idx > _max) _idx = 0;
	return _idx;
 }
int scene::maxs() { return (_slides!=0)?_slides->maxs():_max; }

double scene::rate() { return _slides?_slides->rate():_rate; }
void scene::rate(double t) { if (_slides) _slides->rate(t); else _rate = t;  }

//void scene::select_state(int t) { state = t; }

void scene::display(char* m) {
	//DWORD clr = 0xff1ff1ff0;
	DWORD clr = 0xff1ff1ff0;
	char* x = m?m:_display;
	char buf[256];

	if (!ds("display:off")) {

	sprintf(buf,"%3.1f [%d:%d] %3.1f - %1.2f (%0.2f) : %2.1f",_sim->realtime(), _condition, state,
		(float)dxtime(), _speed, 
		fraction(), fps());// ,_idx+1,_slides->maxs());
	//LPSTR* lp = buf;
	__small->message(_lx,_ly + 5,clr * 0.7,(char*)buf);

	if (m) {
	__small->message(width()-_x-140,_ly+10,argb(150,133,197,235),m);
	}
	//message(_lx,_ly,D3DCOLOR_ARGB(180,133,197,235),buf);
	//D3DCOLOR_ARGB(180,133,197,235)
	if (_slides) {
	int lshow = 0;
	if (_slides->exclude()) lshow = 0; else lshow = 1;
	if (_show && lshow) {
	   wsprintf(buf,"(%d/%d)",_slides->index()+1,_slides->maxs());
        __small->message(width()-80,_ly,clr,(char*)buf);
	}
	}

	//wsprintf(buf,"(C) %s","AEliens");
	wsprintf(buf,"(C) %s","AE");
	int dim = 20;
	int c = 180 - dim;
	if (1) __small->message(width()-_x+110,_ly+15,argb(c,c,c,c),(char*)buf);

	int _xpos = machine::_x; //ds("mouse:x");
	int _ypos = machine::_y; //ds("mouse:y")
	
	DWORD cx = argb(c,c,c,c);
	float mx = 1.0f * _xpos/width();
	float my = 1.0f * _ypos/height();
	char* cmm = cm("meta:m"); if (!strcmp(cmm,"nil")) cmm = "-";
	char* cmc = cm("meta:c"); if (!strcmp(cmc,"nil")) cmc = ":";
	char* cmo = cm("meta:o"); if (!strcmp(cmo,"nil")) cmo = "-";
	sprintf(buf,"%s (%d) [%s%s%s]: %s [%d:%d] (%d,%d) (%1.2f,%1.2f)",__handler->_type, 
		state,cmm,cmc,cmo,__key,_selection,_enabled,_xpos,_ypos,mx,my);
	if (1 || _debug) __small->message(_lx,_ly+30,cx,(char*)buf);
	}
}

void scene::clear(msg_array* m) {
for (int i = 0; i < 12; i++)
		for (int j = 0; j < 12; j++) (*m)[i][j] = 0;
}




HRESULT 
scene::initialize(IDirect3DDevice9* device)
{
	HRESULT hr = S_OK;
	if (!_initialized) {
		_lazy = 0;
		init(device);
	} else return hr;
	return hr;
}

HRESULT 
scene::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    _device = device;

	if (_initialized) { rectangle(_tu,_tv); return hr; }

	
    
	if (!_font) {
	_font = new CD3DFont((char*)_letterset, (DWORD)_size, (DWORD) 0);
	_font->InitDeviceObjects( device );
	_font->RestoreDeviceObjects();
	}

	if (!scene::__plain) {
		scene::__plain = new text(24); scene::__plain->init(device);
		scene::__small = new text(16); scene::__small->init(device);
		scene::__large = new text(32); scene::__large->init(device);
		scene::__ultra = new text(40); scene::__ultra->init(device);

	}

    if (_shader) this->load_effect(_shader);


	if (!_lazy) {

	
    if (_scene) { _scene->_device = device; _scene->_load(); /*init(device);*/ _scene->_parent = this; }
	for (int i=0; i < count; i++) {
            if (scenes[i]) { 
				scenes[i]->_device = device;
				hr = scenes[i]->_load(); //init(device);
				scenes[i]->_parent = this;
			}
	}
	if (sclst) {
		    iter<string>& it = *sclst;
			scene* s = 0;
			string* p = 0;
			while (p = it()) {
				s = (*sclst)[p];
				if (s) {
					   s->_device = device;
					   s->_load(); //
				       s->init(device);
				       if (!s->_parent) s->_parent = this;
				}
			}
	}
	_initialized = 1;
	}
	return hr;

}



HRESULT 
scene::restore(IDirect3DDevice9* device)
{
  
    HRESULT hr = S_OK;
	
    return hr;

   
}


HRESULT 
scene::compose(IDirect3DDevice9* device,DWORD t)
{
    HRESULT hr = S_OK;
   
	return hr;

}

int scene::update_effect() {
	HRESULT hr = S_OK;

	//_effect->SetTechnique("render");
		//if (_technique) _effect->SetTechnique( _technique );
		
    D3DXCOLOR colorMtrlDiffuse(1.0f, 1.0f, 1.0f, 1.0f);
    D3DXCOLOR colorMtrlAmbient(0.35f, 0.35f, 0.35f, 0);
    _effect->SetVector("g_MaterialAmbientColor", (D3DXVECTOR4*)&colorMtrlAmbient);
    _effect->SetVector("g_MaterialDiffuseColor", (D3DXVECTOR4*)&colorMtrlDiffuse);
	_effect->SetVector("ambient", (D3DXVECTOR4*)&colorMtrlAmbient);
    _effect->SetVector("diffuse", (D3DXVECTOR4*)&colorMtrlDiffuse);

	_effect->SetMatrix( "g_mWorldViewProjection", _wvp()); //  &mWorldViewProjection );
        _effect->SetMatrix( "g_mWorld", _world()); //&mWorld );
        _effect->SetFloat( "g_fTime",dxtime() );
		_effect->SetTexture("g_MeshTexture",_texture);
		
		//D3DXMATRIX wvp = (*g_world) * (*g_view) * (*g_proj); 
		D3DXMATRIX vp =  (*_view()) * (*_projection()); 
		
		_effect->SetMatrix( "wvp", _wvp()); //  &mWorldViewProjection );
        _effect->SetMatrix( "world", _world()); //&mWorld );
		_effect->SetMatrix( "view", _view()); //&mWorld );
		_effect->SetMatrix( "vp", &vp );
        _effect->SetFloat( "time",dxtime() );
		float xfac = _factor;
		_effect->SetFloat( "xfac",xfac );
		_effect->SetFloat( "yfac",1.0-xfac);
		_effect->SetFloat( "zfac",1.0-xfac);
		if (tx(opt("tx"))) _texture = tx(opt("tx"));
		_effect->SetTexture("tex",_texture);
		if (scene::cm("overlay")) _texture = scene::tx(scene::cm("overlay"));
		if (iopt("verlay")) _effect->SetTexture("overlay",tx(cm("overlay")));
		else _effect->SetTexture("overlay",_texture);
		_effect->SetTexture("tex0",_texture);
		_effect->SetTexture("tex1",tx("1"));
		_effect->SetTexture("tex2",tx("2"));
		_effect->SetTexture("tex3",tx("3"));
		_effect->SetTexture("tex4",tx("4"));
		_effect->SetTexture("tex5",tx("5"));
		_effect->SetTexture("tex6",tx("6"));
		_effect->SetTexture("tex7",tx("7"));
		_effect->SetTexture("tex8",tx("8"));
		_effect->SetTexture("tex9",tx("9"));
		_effect->SetTexture("tex0",tx("0"));
		_effect->SetTexture("slides",tx(cm("slides")));

		_effect->SetFloat( "factor",_factor );
		_effect->SetTexture("bump",_texture);

return hr;
}

int
scene::load_effect(char* tp, char* nm)
{
    HRESULT hr = S_OK;
	//process(opts);

    chfx();
	if ((*fxlst)[tp]) return S_OK;

	// Define DEBUG_VS and/or DEBUG_PS to debug vertex and/or pixel shaderxs with the shaderx debugger.  
    // Debugging vertex shaderxs requires either REF or software vertex processing, and debugging 
    // pixel shaderxs requires REF.  The D3DXSHADER_FORCE_*_SOFTWARE_NOOPT flag improves the debug 
    // experience in the shaderx debugger.  It enables source level debugging, prevents instruction 
    // reordering, prevents dead code elimination, and forces the compiler to compile against the next 
    // higher available software target, which ensures that the unoptimized shaderxs do not exceed 
    // the shaderx model limitations.  Setting these flags will cause slower rendering since the shaderxs 
    // will be unoptimized and forced into software.  See the DirectX documentation for more information 
    // about using the shaderx debugger.
	if (1) { 
    DWORD dwShaderFlags = 0;
    #ifdef DEBUG_VS
        dwShaderFlags |= D3DXSHADER_FORCE_VS_SOFTWARE_NOOPT;
    #endif
    #ifdef DEBUG_PS
        dwShaderFlags |= D3DXSHADER_FORCE_PS_SOFTWARE_NOOPT;
    #endif

    // Read the D3DX effect file
		// loc("\\vip\\effects\\BasicHSL.fx")
    //TCHAR str[MAX_PATH];
	//char* shadfx = "BasicHLSL";
	//if (opt("fx")) option("shaderx",opt("fx"));
	//char* shadfx = opt("shaderx"); // = "material";
    string s = fm("%s",tp);
	//if (opt("shaders")) s = fm("%s:%s",opt("shaders"),tp);
	//	else 
	//s = fm("%s",tp);

	//string s = fm("%s",tp);
    s.split(":");
    string* p = 0;
    iter<string>& it = s;
    //loader l;
    while ( (p = it()) ) {
         //l.load(*p);
         //}
	char xb[1024];
	wsprintf(xb,"d:\\vip\\effects\\%s.fx",(char*)*p);
	
	//hr = D3DXCreateEffectFromFile(_device, xb, NULL, NULL, dwShaderFlags, NULL, &m_pEffect, NULL );
	hr = D3DXCreateEffectFromFile(_device, xb, NULL, NULL, dwShaderFlags, NULL, &_effect, NULL );
    chfx();
	if (nm)  (*fxlst)[nm] = _effect; 
	(*fxlst)[(char*)*p] = _effect; 

	scene::fx((char*)*p,_effect);
    // If this fails, there should be debug output as to 
    // they the .fx file failed to compile
	}
	if( FAILED( hr ) );
        //return DXTRACE_ERR( TEXT("D3DXCreateEffectFromFile"), hr );
	}

	//hr = scene::_load(); // loops through scenes

	//_stack = 1;

    return hr;
}

ieffect* scene::effect(char* s, ieffect* fx) {
	ieffect* tmp = _effect;
	if (fx) _effect = fx;
	if (fx && s) { _effect = fx; chfx(); (*fxlst)[s] = _effect; }
	else if (s) _effect = (*fxlst)[s];
	//if (s) opt("fx",s);
	if (_effect) return _effect;
	else return tmp;
}


HRESULT 
scene::render_begin( IDirect3DDevice9* device) 
{
HRESULT hr = S_OK;
if (!device) device = _device;


set(device,_mode);
//_hold =
_time = dxtime();

if (scene::rendering == 0) {
    _time = dxtime();
	float d = delta();
	scene::_frames++;
	scene::_felapsed += d;
    if (scene::_felapsed >= 1.0f) {
		scene::_fps = scene::_frames / scene::_felapsed;
		scene::_frames = 0;
		scene::_felapsed = 0;
	}
	if (_sim) {
   
	_sim->run2(0.1,0,false);
	
	}

	if (0 && _rate > 0) {
			_elapsed += delta();
			if (_elapsed > _rate) {
				_elapsed = 0;
				_event = 1;
			}
	}
    if (!_embedded) {
	device->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER,
                      D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );
                      //D3DCOLOR_XRGB(255,255,255), 1.0f, 0 );
	device->BeginScene();
	}
}
scene::rendering++;
return hr;
}

HRESULT 
scene::render_end( IDirect3DDevice9* device) 
{
HRESULT hr = S_OK;
if (!device) device = _device;

scene::rendering--;
if (scene::rendering == 0) {
	if (!_embedded) {
	device->EndScene();
    }

}

_last = _time;

return hr;
}

HRESULT scene::load_captures(IDirect3DTexture9* texture) {
//	texture = _video->_texture;
		_capture = texture;
		if (scene::_embedded) {	
			for (int i = __total; i<12; i++)
				__captures[i] = _capture;
		} else {
			for (int i=0; i<12; i++)
				__captures[i] = _capture;
		}
		//_texture = _captures[_select];
		//_texture = _capture;
		return S_OK;
}

HRESULT 
scene::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;
    initialize(device);

	if (texture) _texture = texture;
	if (opt("tx")) _texture = tx(opt("tx"));
	texture = _texture;
	//_capture = texture;
    
	
	if (scene::rendering == 0) {

		//get_buffer();
		
		//if (scene::_video && _embedded)
		//	texture = _video->_texture;
		if (texture) _capture = texture;
		else if (_texture) _capture = _texture; 
		if (scene::_embedded) {	
			//debug(fm("total: %d",__total),1);
			for (int i = __total; i<12; i++)
				__captures[i] = _capture;
		} else {
			for (int i=0; i<12; i++)
				__captures[i] = _capture;
		}
		//_texture = _captures[_select];
		//_texture = _capture;
		int xz = ds("z");
		int xa = ds("a");
		//if (xz==0) xz = 1;
		xz = _active() - xz;
		if (xz <= 0) xz += _total(); // + _active() - xz;
		xa = _active() + xa;
		if (xa > _total()) xa -= _total(); // + _active() - xz;
		//xz = 0; //_active() - 1;
		//if (xz < 0) xz = 7 + xz;
		tx("z",__captures[xz]); //scene::tx(xz));
		tx("last",__captures[xz]); //scene::tx(xz));
		tx("active",__captures[xa]);
		tx("a",__captures[xa]);
	}
	_texture = __captures[_select()];
	if (__captures[0]) _capture = __captures[0];
    
	if (_begin == 0) { _holdtime = _begin = get_seconds(); }
    _time = dxtime();
	_fraction = fraction(); 
	previous = state;
	get(device, __world);
	if (_stack) {
	device->GetTransform( D3DTS_VIEW, __view );
	device->GetTransform( D3DTS_PROJECTION, __projection );
	}
	if (opt("fx") && !iopt("nofx") && !iopt("noshader")) _effect = scene::fx(opt("fx"));
	//if (!_effect) { //0 && !_shader) {
	if (!_shader || iopt("nofx") || iopt("noshader")) {
	     draw(device,texture);
	} else if (_effect && !iopt("nofx")) {
		update_effect();



         UINT iPass, cPasses;
		 hr = _effect->Begin(&cPasses, 0);
		
        
        for (iPass = 0; iPass < cPasses; iPass++)
        {
          hr = _effect->BeginPass(iPass);
           
		   if (1) draw(device,texture);
		   _effect->EndPass();
		
        
	    } 
		_effect->End();

	}
		 /*
    if (_scene) {
		_scene->_device = device; 
		//hr = _scene->_compose(); //(device,_time);
       hr = _scene->_restore(); //(device);
	   hr = _scene->_compose(); //(device,_time);
	   if (!_scene->_texture) _scene->_texture = texture; 
       hr = _scene->_render(); //render(device,_capture);
	   if (_scene != __video) _scene->_texture = 0;
    }
    for (int i=0; i < count; i++) {
		if (scenes[i] && !_exclude[i] 
                    && !scenes[i]->exclude()) {
        scenes[i]->_device = device;
		//hr = scenes[i]->_compose(); //(device, _time); //
	    hr = scenes[i]->_restore(); //(device);
		hr = scenes[i]->_compose(); //(device, _time); //
		if (!scenes[i]->_texture) scenes[i]->_texture = texture;
		if (supervise(i))
        hr = scenes[i]->_render(); //render(device,_texture);
		scenes[i]->_texture = 0;
		}
	if (_lst && sclst) {
            iter<string>& it = *sclst;
			scene* s = 0;
			string* p = 0;
			while (p = it()) {
				s = (*sclst)[p];
				if (s && !s->exclude()) {
					s->_device = device;
					//hr = s->_compose(); //device, _time); //
	                hr = s->_restore(); //(device);
					hr = s->_compose(); //device, _time); //
					if (!s->_texture) s->_texture = texture;
                    hr = s->_render(); //render(device,texture);
				    s->_texture = 0;
				}
			}
	}
	*/
	set(device, __world);
	if (_stack) {
		//HRESULT mb =   MessageBox(0,"stack","restore",MB_YESNO | MB_ICONQUESTION );
	device->SetTransform( D3DTS_VIEW, __view );
	device->SetTransform( D3DTS_PROJECTION, __projection );
	}
	
    //_last = _time;
    return hr;

   

}

// as a short hand, (_time is not used, yet)

HRESULT scene::draw(IDirect3DDevice9* device, IDirect3DTexture9* texture ) {
HRESULT hr = S_OK; 

itexture* _tx = 0;
if (opt("tx")) _tx = tx(opt("tx"));
if (_tx) texture = _tx;
if (_scene) {
		_scene->_device = device; 
		//hr = _scene->_compose(); //(device,_time);
       hr = _scene->_restore(); //(device);
	   hr = _scene->_compose(); //(device,_time);
	   if (!_scene->_texture) _scene->_texture = texture; 
       hr = _scene->_render(); //render(device,_capture);
	   if (_scene != __video) _scene->_texture = 0;
	   set(device, __world);
    }
   for (int i=0; i < count; i++) {
		if (scenes[i] && !_exclude[i] 
                    && !scenes[i]->exclude()) {
        scenes[i]->_device = device;
		//hr = scenes[i]->_compose(); //(device, _time); //
	    hr = scenes[i]->_restore(); //(device);
		hr = scenes[i]->_compose(); //(device, _time); //
		if (!scenes[i]->_texture) scenes[i]->_texture = texture;
		if (supervise(i))
        hr = scenes[i]->_render(); //render(device,_texture);
		scenes[i]->_texture = 0;
		}
	set(device, __world);
    }
	if (_lst && sclst) {
            iter<string>& it = *sclst;
			scene* s = 0;
			string* p = 0;
			while (p = it()) {
				s = (*sclst)[p];
				if (s && !s->exclude()) {
					s->_device = device;
					//hr = s->_compose(); //device, _time); //
	                hr = s->_restore(); //(device);
					hr = s->_compose(); //device, _time); //
					if (!s->_texture) s->_texture = texture;
                    hr = s->_render(); //render(device,texture);
				    s->_texture = 0;
					set(device, __world);
					//device->SetTransform( D3DTS_VIEW, __view );
	                //device->SetTransform( D3DTS_PROJECTION, __projection );
				}
			}
	}
    return hr;
}


void
scene::rectangle( float fTU, float fTV )
{
	_tu = m_fTU = fTU;
	_tv = m_fTV = fTV;
    if (_scene) _scene->rectangle( fTU,  fTV );
	for (int i=0; i < count; i++) {
           if (scenes[i]) scenes[i]->rectangle( fTU,  fTV );
	}
	if (sclst) {
		    iter<string>& it = *sclst;
			scene* s = 0;
			string* p = 0;
			while (p = it()) {
				s = (*sclst)[p];
				if (s) {
				       s->rectangle( fTU,  fTV );
				}
			}
	}
}


void scene::SetColor( D3DCOLOR color ) {}
IDirect3DDevice9 * scene::GetDevice() { return 0; }

HRESULT scene::SetMediaFormat( GUID subtype) { return S_OK; }
HRESULT scene::CreateTexture( UINT Width, UINT Height, D3DFORMAT format) { 
	
  HRESULT hr = S_OK;
    D3DSURFACE_DESC ddsd;

	// hr = m_pCP->CreateTexture( m_lVidWidth, m_lVidHeight, D3DFMT_A8R8G8B8);

    try
    {
        hr = _device->CreateTexture( Width, Height, 1, 0, format, 
                                          D3DPOOL_MANAGED, &_texture, NULL);
        if( FAILED(hr))
        {
            //Msg(TEXT("Failed to create IDirect3DTexture9."), hr);
            return hr;
        }

        hr = _texture->GetLevelDesc( 0, &ddsd );
        if( FAILED(hr))
        {
            //Msg(TEXT("Failed to get level description of IDirect3DTexture9."), hr);
            return hr;
        }

        if (ddsd.Format != D3DFMT_A8R8G8B8 &&
            ddsd.Format != D3DFMT_A1R5G5B5) 
        {
           // Msg(TEXT("Texture has a format we can't handle. Format = 0x%x"), ddsd.Format);
            return VFW_E_TYPE_NOT_ACCEPTED;
        }

        _format = ddsd.Format;
        _width = ddsd.Width;
        _height = ddsd.Height;
        //m_HAR = (FLOAT)Width  / (FLOAT)ddsd.Width;
        //m_VAR = (FLOAT)Height / (FLOAT)ddsd.Height;
		//rectangle(m_HAR,m_VAR);
    }
    catch(...)
    {
        //Msg(TEXT("Application excountered unexpected error when trying to allocate IDirect3DTexture9."), 
        //    E_UNEXPECTED);
        hr = E_UNEXPECTED;
    }
    return hr;
	
}

  HRESULT scene::BltToTexture(IDirect3DSurface9 *lpSurf, UINT Width, UINT Height){ return S_OK; }


  HRESULT scene::get_buffer() {
	HRESULT hr = S_OK;
	_buffer = 0;
	
	//check_cs();
    //CAutoLock lock(_cs);

	static BYTE*  buffer = new BYTE[800*600*4];
	_buffer = (void*) buffer;
	BYTE* pbuf = buffer;
	BYTE* tbuf = NULL;

	/*
    BYTE * pSampleBuffer = _buffer;
    BYTE * pTextureBuffer = NULL;


    BYTE * pbS = NULL;

    DWORD * pdwS = NULL;
    DWORD * pdwD = NULL;
*/
    int row;
    int col;

	D3DSURFACE_DESC ddsd;
    D3DLOCKED_RECT d3dlr;
    LONG  lpitch;     // Pitch of texture

	if( !_texture )
        return 0; //E_UNEXPECTED;

    try
    {
       
		
		_texture->GetLevelDesc(0,&ddsd);
		_format = ddsd.Format;

		//return 22;

	     // Lock the Texture
        hr = _texture->LockRect( 0, &d3dlr, 0, 0); //D3DLOCK_NOOVERWRITE);
        if( FAILED(hr))
        {
            return 0;
        }

		//debug("lock",1);
        // Get the texture buffer & pitch
        tbuf = static_cast<byte *>(d3dlr.pBits);
        lpitch = d3dlr.Pitch;

		_buffer = 0;
        if(0 && _format == D3DFMT_A1R5G5B5 )
        {
	        _buffer = (void*) buffer;
			//pTextureBuffer += (_height-1) * lTexturePitch;
            for(row = 0; row < _height; row++ ) 
			//for(row = _height-1; row >= 0; row-- ) 
            {

                BYTE *told = tbuf;
                BYTE *pold = pbuf;   
				//pTextureBuffer += lTexturePitch;

                for (col = 0; col < _width; col++) 
                {
                    unsigned char a = *(tbuf++);
                    unsigned char r = *(tbuf++);
		            unsigned char g = *(tbuf++);
		            unsigned char b = *(tbuf++);
					*(pbuf++) = a;
		            *(pbuf++) = b;
		            *(pbuf++) = g;
		            *(pbuf++) = r;
				}

                //pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                tbuf = tbuf + lpitch;
            }
        }
		else
        if( _format == D3DFMT_A8R8G8B8 )
        {
			_buffer = (void*) buffer;
         //pTextureBuffer += (_height-1) * lTexturePitch;
            for(row = 0; row < _height; row++ ) 
			//for(row = _height-1; row >= 0; row-- ) 
            {

                BYTE *told = tbuf;
                BYTE *pold = pbuf;   
				//pTextureBuffer += lTexturePitch;

                for (col = 0; col < _width; col++) 
                {
                    unsigned char a = *(tbuf++);
                    unsigned char r = *(tbuf++);
		            unsigned char g = *(tbuf++);
		            unsigned char b = *(tbuf++);
					*(pbuf++) = a;
		            *(pbuf++) = r; //r;
		            *(pbuf++) = g; //g;
		            *(pbuf++) = b; //b;
					*(tbuf-4) = (long) 0;
				}

                //pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                tbuf = told + lpitch;
            }  

        }
		else if(_format == D3DFMT_X8R8G8B8 )
        {
			_buffer = (void*) buffer;
         //pTextureBuffer += (_height-1) * lTexturePitch;
            for(row = 0; row < _height; row++ ) 
			//for(row = _height-1; row >= 0; row-- ) 
            {

                BYTE *told = tbuf;
                BYTE *pold = pbuf;   
				//pTextureBuffer += lTexturePitch;

                for (col = 0; col < _width; col++) 
                {
                    unsigned char a = *(tbuf++);
                    unsigned char r = *(tbuf++);
		            unsigned char g = *(tbuf++);
		            unsigned char b = *(tbuf++);
					*(pbuf++) = a;
		            *(pbuf++) = r; //r;
		            *(pbuf++) = g; //g;
		            *(pbuf++) = b; //b;
					*(tbuf-2) = (long) 0;
				}

                //pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                tbuf = told + lpitch;
            }  

        }

        hr = _texture->UnlockRect(0);
        return 1;
    }
    catch(...)
    {
        hr = _texture->UnlockRect(0);
       // assert(0);
    }
    return  hr;

  }


  HRESULT scene::CopyMediaSample( IMediaSample *pSample, LONG lSamplePitch ){ 

	HRESULT hr = S_OK;
	check_cs();
    CAutoLock lock(_cs);

    BYTE * pSampleBuffer = NULL;
    BYTE * pTextureBuffer = NULL;
    BYTE * pbS = NULL;

    DWORD * pdwS = NULL;
    DWORD * pdwD = NULL;

    int row;
    int col;

    D3DLOCKED_RECT d3dlr;
    LONG  lTexturePitch;     // Pitch of texture

    if( !pSample )
        return E_POINTER;

    if( !_texture )
        return E_UNEXPECTED;

    try
    {
        // Get the video bitmap buffer
        hr = pSample->GetPointer( &pSampleBuffer );
        if( FAILED(hr))
        {
            return hr;
        }

        // Lock the Texture
        hr = _texture->LockRect( 0, &d3dlr, 0, 0 );
        if( FAILED(hr))
        {
            return E_FAIL;
        }

        // Get the texture buffer & pitch
        pTextureBuffer = static_cast<byte *>(d3dlr.pBits);
        lTexturePitch = d3dlr.Pitch;

        if( _format == D3DFMT_A1R5G5B5 )
        {
			pTextureBuffer += (_height-1) * lTexturePitch;
            for(row = 0; row < _height; row++ ) 
			//for(row = _height-1; row >= 0; row-- ) 
            {
                BYTE *pBmpBufferOld = pTextureBuffer;
                BYTE *pTxtBufferOld = pSampleBuffer;   
				//pTextureBuffer += lTexturePitch;

                for (col = 0; col < _width; col++) 
                {
                    *(WORD *)pTextureBuffer = (WORD)
                        (0x8000 +
                        ((pSampleBuffer[2] & 0xF8) << 7) +
                        ((pSampleBuffer[1] & 0xF8) << 2) +
                        (pSampleBuffer[0] >> 3));

                    pTextureBuffer += 2;
                    pSampleBuffer += 3;
                }
                pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                pTextureBuffer = pTxtBufferOld - lTexturePitch;
            }
        }
        if( _format == D3DFMT_A8R8G8B8 )
        {
            pTextureBuffer += (_height-1) * lTexturePitch;
            for(row = 0; row < _height; row++ ) 
            {
                BYTE *pBmpBufferOld = pSampleBuffer;
                BYTE *pTxtBufferOld = pTextureBuffer;  
				//pTextureBuffer += lTexturePitch;
				//assert(1!=1);

                for (col = 0; col < _width; col++) 
                {
                    pTextureBuffer[0] = pSampleBuffer[0];
                    pTextureBuffer[1] = pSampleBuffer[1];
                    pTextureBuffer[2] = pSampleBuffer[2];
                    pTextureBuffer[3] = 0xFF;//(BYTE)(0xFF * y / (m_lVidHeight-1));

                    //pTextureBuffer += 4;
					pTextureBuffer += 4;
                    pSampleBuffer  += 3;
                }

                pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                pTextureBuffer = pTxtBufferOld - lTexturePitch;
            }

        }

        hr = _texture->UnlockRect(0);

    }
    catch(...)
    {
        hr = _texture->UnlockRect(0);
        assert(0);
    }
    return hr;
	  
	 
  }

#define check_transform if (!_transform) _transform = new transform;

  void scene::translation(float x, float y, float z) {
	  check_transform; 
	  if (_transform) _transform->translation(x,y,z);
  }

	void scene::scale(float x, float y, float z){
	  check_transform; 
	  if (_transform) _transform->scale(x,y,z);
  }
	void scene::rotation(float x, float y, float z, float r){
	  check_transform; 
	  if (_transform) _transform->rotation(x,y,z,r);
  }
	//float[3] translation();
	//float[3] scale();
	//float[4] rotation();
	void scene::set(IDirect3DDevice9* device,int t){
	  check_transform; 
	  if (_transform) _transform->set(device,t);
  }

	void  scene::get(IDirect3DDevice9* device, D3DXMATRIX* mat){
	  check_transform; 
	  if (_transform) _transform->get(device,mat);
  }
	void  scene::set(IDirect3DDevice9* device, D3DXMATRIX* mat){
	  check_transform; 
	  if (_transform) _transform->set(device,mat);
  }
    
	void  scene::get(D3DXMATRIX* mat) {
	  check_transform; 
	  if (_transform) _transform->get(mat);
  }