#include <hush/source.h>
#include "text.h"
//#include <atlbase.h>

int text::handle(char* type, char* ev) {

	if (_enabled && (
		check(type,ev,"key","return")
		|| check(type,ev,"arrow","right"))) {
		_selection = index()-1;
		_parent->_selection = _selection;
		_parent->_enabled = 1;
		//scene::_handler = _parent;
	} else if ( _parent && check(type,ev,"arrow","left")) {
		_parent->_enabled = 0;
		
		if (_parent->_parent) { 
			__handler = _parent->_parent;
			__handler->_enabled = 0;
		}
		if (__handler->_menu) {
			__handler->_enabled = 0;
			__handler->_exclusive = 1;
			__handler = __handler->_menu;
		
		} else __handler = scene::_main()->_scene;
		//if (_handler == scene::_main) _handler = _parent;
	} else if (check(type,ev,"arrow","down")) {
		next();
	} else if (check(type,ev,"arrow","up")) {
		next(-1);
	} else return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



text::text(int size) 
{
_size = size;
wsprintf(_type,"text");

}

text::text(msg_array* m, int sz, char* type, TCHAR* title) {
	_max = 12;
	wsprintf(_type,type);
	_title = title;
	//msg = (char *[12][12]) m;
	//_msg = m;
	//void* x = (void*) m;
	//msg = (char* [][12])

	if  (width() == 1440)  { _y = 175; _inc = 50; _size = 32; }
	else if (width() == 1024 || width() == 1280) { _y = 150;  _inc = 40; }
	else if (width() == 800) { _y = 100; _inc = 30; }
	else if (width() == 640) { _y = 75; _inc = 25; _size = 20; }

	if (sz) _size = sz;
	
	_msg = m;

	if (is("menu"))  {
    _title = title?title:_T("select:");
    _enabled = 1;
    
	//if (is("menu")) { index(_selection+1); }

    int c = 130;
    _color = argb(c,c,c+30,c);
    if (!sz) _size = 20+8;

    state = 1;
	}
  
  }


text::~text()
{
//delete scenes[];
}

HRESULT 
text::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    
	if (is("menu")) { index(_selection+1); }
	//if (is("menu")) { index(_selection); }
	
	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
text::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
text::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;



	render_begin(device);

    
    _cmi = state;//state+1;
    

	if(_idx >= _max) _idx = 0;
	

	hr = scene::render(device,texture); // calls compose, restore,  render


    
    //_selection = 0;

	for (int i=1; i <= 12; i++) { 
		if ((*_msg)[_cmi][i-1]) {
			if (i == _idx) {
				message(_x,_y + (i-1)*_inc,_alt,(*_msg)[_cmi][i-1]);
				if (_enabled) _selection = i-1;
			}
			else 
				message(_x,_y + (i-1)*_inc,_color,(*_msg)[_cmi][i-1]);
		}

	}

	if (is("menu")) {

    _plain()->message(_x-20,_y-100,argb(180,133,197,235),_title);

	_parent->_selection = index()-1;
	}
	
    
	render_end(device);

 

    return hr;
}

