#include <hush/source.h>

#include "tam.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
//#include <scene/character.h>
//#include "mesh.h"
#include "scene/character.h"


//#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>
#include <scene/slides.h>
#include <scene/video.h>

//#include <ch/extern/embedch.h>
//#include "sampclass.h"

//static CCharacter* _tiny = 0;






static char* _help = "tamtam";
//static char* _help = "abramovic";

static scene* dolphin;

void vip_tam::toggle_ds(char* k) {
	char* s = eq(k);
	int v = scene::ds(s);
	scene::ds(s,v?0:1);
}

void vip_tam::toggle_lst(char* k) {
	char* s = eq(k);
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) lst(s)->exclude(0);
	else lst(s)->exclude(1);
	}
}




int vip_tam::exec(char* sx) {
int status = 0;
if (sx)  {
int x = iopt("exec");
iopt("exec",x+1);
//_inexec++;
char* cx = eq(sx);
//char *cmx; if (cmx = cm(cx)) cx = cmx;
char* p = cx;
char c = '\0';
if (p) while ((c = *p++) && (c != '\0')) {
	char b[2];
	b[0] = c; b[1] = '\0';
	handle("key",b);
    }
//_inexec--;
if (!x) opt("exec","0");
else iopt("exec",x-1);
}
return status;
}

int vip_tam::ch(char* x) {
int status = 0;
if (!x) {
eq("e:w","wall");

eq("start","nranblcwnf2nvanttnc");

eq("b:a","alternate");
eq("b:w","wall");
eq("b:f","floor");
eq("b:l","frame");
eq("b:m","movie");
eq("b:c","character");
eq("b:p","");

eq("c:s","nranf0nblwnxtrnttnc");
eq("c:x","nranbclwnf0nvanc");
eq("c:0","nranf0nvanc");
eq("c:r","nranc");


//eq("c:0","nranbwlnc");
eq("c:1","nranbclwnxunc");
eq("c:2","nranbcnxrbunc");
eq("c:3","nranx13tni1n513hnbmcnc");
eq("c:4","nranx13ni1n513hnbmcnc");
eq("c:5","nranf5nx23n523nc");
eq("c:6","nranx3n513hnbmcnc");
eq("c:7","nranxtnc");
eq("c:8","nranxu32n23n5hnc");
eq("c:9","nranxunc");

eq("t:h","help");
eq("t:t","text");


eq("v:1","1");
eq("v:2","2");
eq("v:0","0");
eq("v:3","3");
eq("v:4","4");
eq("v:5","5");
eq("v:6","6");
eq("v:7","7");
eq("v:8","8");
eq("v:9","9");

eq("v:b","back");
eq("v:u","under");
eq("v:v","video");

eq("x:0","scene:0");
eq("x:1","scene:1");
eq("x:2","scene:2");
eq("x:3","scene:3");
eq("x:4","scene:4");
eq("x:5","scene:5");
eq("x:6","scene:6");
eq("x:7","scene:7");
eq("x:8","scene:8");
eq("x:9","scene:9");




eq("x:b","back");
eq("x:f","flag");
eq("x:k","knot");
eq("x:m","morph");
eq("x:s","spectrum");
eq("x:t","trio");
eq("x:r","running");
eq("x:u","under");
eq("x:v","video");
eq("x:w","water");
eq("x:x","x");
eq("x:z","text");


//eq("s:x","x");
//cm("x","r67aut");
} else return exec(x); 
return status;
}

#define sclst ((dictionary<scene>*)_sclst)

int vip_tam::handle(char* type, char* ev) {
    
	if (!strcmp(type,"key") && !iopt("exec")) {
		_command[_pcm++] = _lastc = ev[0];
		_command[_pcm] = '\0';
	}

    int newmode = 1;
	if (check(type,ev,"key","space")) {
		_cmode = 'n';
	} else
	if (newmode && !strcmp(type,"key") ) {
		char buf[64];
		char c = ev[0];
        if (c == 'n') _cmode = c;
		else if (_cmode == 'n') switch(c) {
			case 'b':
				_cmode = c; break;;
			default: _cmode = c;  break;;
		} else if (_cmode == 'b') switch (c) {
			case 'w': toggle_ds("b:w"); break;;
			default: sprintf(buf,"b:%c",c); toggle_ds(buf); break;;
		} else if (_cmode == 'c') switch (c) {
			//case 's': exec("start"); break;;
			default: sprintf(buf,"c:%c",c); exec(buf); break;;
		} else if (_cmode == 'f') switch (c) {
			//case 's': exec("start"); break;;
			default:
				if (instring(c,"0123456789")) {
				sprintf(buf,"%c",c);int i; sscanf(buf,"%d",&i);
				scene::ds("flip",1);
				scene::ds("focus",i); 
				} break;;
		} else if (_cmode == 'i') switch (c) {
	
			default: if (instring(c,"0123456789")) {
				sprintf(buf,"scene:%c",c);
				int i; sscanf(buf,"%d",&i);
				if (lst(buf)) lst(buf)->interval(now(),10);
				} break;;
		} else if (_cmode == 't') switch (c) {
			default: sprintf(buf,"t:%c",c); toggle_lst(buf); break;;
		} else if (_cmode == 'v') switch (c) {
			case 'a': 
				scene::ds("flip",1);
			    //scene::ds("focus",0);
				break;;
			case 'p':
				scene::ds("flip",1);
			    scene::ds("focus",4);
				break;;
			//case 'w': toggle_ds("b:w"); break;;
			default: sprintf(buf,"v:%c",c); toggle_ds(buf); 
					 sprintf(buf,"shift:%c",c); toggle_ds(buf);
				     break;;

			//toggle_ds("1");
		    //toggle_ds("shift:1");
		} else if (_cmode == 'x') switch (c) {
			case 'v': sc("slides")->interval(now(),5); toggle_lst("x:v"); break;;
			case 'w': toggle_lst("x:w"); break;;
			default: sprintf(buf,"x:%c",c); toggle_lst(buf); break;;
		} else if (instring(_cmode,"0123456789")) switch (c) {
			case '0': 
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9': {
				char buf[64];
				sprintf(buf,"scene:%c",c);
				scene* sx = lst(buf);
				if (sx) sx->opt("tx",fm("%c",_cmode));
				} break;;
			case 'b': scene::cm("floor",fm("%c",_cmode)); break;;
			case 'h': scene::cm("hall",fm("%c",_cmode)); break;;

			case 's':
			case 'v': sc("slides")->opt("tx",fm("%c",_cmode)); break;;
			case 'f': lst("flag")->opt("tx",fm("%c",_cmode)); break;;
			case 'w': lst("water")->opt("tx",fm("%c",_cmode)); break;;
			default: sprintf(buf,"x:%c",c); toggle_lst(buf); break;;
		} else if (_cmode == 'r') switch (c) {
			case 'a': { 
        int s = 0;
		if (!iopt("exec")) {
		cm("last",_command);
		_pcm = 0; _command[_pcm] = '\0';
		}
		char* ds[] = { "character","hall","floor","wall","movie","frame", 0 };
		
		for (int i = 0; i <= 10; i++) _exclude[i] = 1;	
		iter<string>& it = *sclst;
			scene* sc = 0;
			string* p = 0;
			while (p = it()) {
				sc = (*sclst)[p];
				sc->exclude(1);
			}
		
		char* pds = 0; int k = 0;
		scene::ds("alternate",0);
		while (pds = ds[k]) {
			scene::ds(pds,1);
			k++;
		} };
		break;;
	    } else 	return scene::handle(type,ev);

	} else 
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
			
		}
		

	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			if (scene::ds("alternate")) scene::ds("alternate",0);
			else ds("alternate",1);
		} else {
			scene::ds("flip",1);
			scene::ds("focus",0);
		}
	} else if (check(type,ev,"key","p")) {
		if (0) {
			if (scene::ds("alternate")) scene::ds("alternate",0);
			else ds("alternate",1);
		} else {
			scene::ds("flip",1);
			scene::ds("focus",4);
		}
	} else if (check(type,ev,"key","r")) {
		int s = 0;
		if (!iopt("exec")) {
		cm("last",_command);
		_pcm = 0; _command[_pcm] = '\0';
		}
		char* ds[] = { "character","hall","floor","wall","movie","frame", 0 };
		if (_ctrl()) state = s; else {
		for (int i = 0; i <= 10; i++) _exclude[i] = 1;	
		iter<string>& it = *sclst;
			scene* s = 0;
			string* p = 0;
			while (p = it()) {
				s = (*sclst)[p];
				s->exclude(1);
			}
		}
		char* pds = 0; int k = 0;
		while (pds = ds[k]) {
			scene::ds(pds,1);
			k++;
		}
	} else if (check(type,ev,"key","c")) {
		int s = 0;
		if (_ctrl()) state = s; else {
			int k = scene::ds("character");
			scene::ds("character",k?0:1);
		}
	} else if (check(type,ev,"key","h")) {
		int s = 0; char* k = "hall";
		if (_ctrl()) state = s; else {
			int v = scene::ds(k);
			scene::ds(k,v?0:1);
		}
	} else if (check(type,ev,"key","f")) {
		int s = 0; char* k = "floor";
		if (_ctrl()) state = s; else {
			int v = scene::ds(k);
			scene::ds(k,v?0:1);
		}
	} else if (check(type,ev,"key","w")) {
		toggle_ds("e:w");
		/*
		int s = 0; char* k = eq("e:w"); //"wall";
		if (_ctrl()) state = s; else {
			int v = scene::ds(k);
			scene::ds(k,v?0:1);
		}*/
	} else if (check(type,ev,"key","i")) {
		int s = 0; char* k = "movie";
		if (_ctrl()) state = s; else {
			int v = scene::ds(k);
			scene::ds(k,v?0:1);
		}
	} else if (check(type,ev,"key","l")) {
		int s = 0; char* k = eq("frame");
		if (_ctrl()) state = s; else {
			int v = scene::ds(k);
			scene::ds(k,v?0:1);
		}
	} else if (check(type,ev,"key","h")) {
		int s = 0; char* k = "hall";
		if (_ctrl()) state = s; else {
			int v = scene::ds(k);
			scene::ds(k,v?0:1);
		}
	
	} else if (check(type,ev,"key","q")) {
		char* s = "help";
		char* t = "text";
		int x = lst(s)->exclude();
		if (x) { lst(t)->exclude(1); lst(s)->exclude(0); }
		else { lst(s)->exclude(1); }
	} else if (check(type,ev,"key","t")) {
		char* s = "text";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","m")) {
		char* s = "morph";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","w")) {
		char* s = "water";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","s")) {
		//ch("r67aut");
		ch("s:x");
		/*
		char* s = "spectrum";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
		*/
	} else if (check(type,ev,"key","k")) {
		char* s = "knot";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","f")) {
		char* s = "flag";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","x")) {
		char* s = "x";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","d")) {
		char* s = "dolphin";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","v")) {
		char* s = "video";
		int x = lst(s)->exclude();
		if (x) { lst(s)->exclude(0); sc("slides")->interval(now(),5); }
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","u")) {
		char* s = "under";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","b")) {
		char* s = "back";
		int x = lst(s)->exclude();
		if (x) lst(s)->exclude(0);
		else lst(s)->exclude(1);
	} else if (check(type,ev,"key","0")) {
		int s = 10;
		if (_ctrl()) state = s; else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
				//_handler(scenes[s]);
				//scenes[s]->_parent = this;
			}}
	} else if (check(type,ev,"key","1")) {
		toggle_ds("1");
		toggle_ds("shift:1");
		
	} else if (check(type,ev,"key","2")) {
		toggle_ds("2"); 

		toggle_ds("shift:2");
        /*
		int s = 2;
		if (_ctrl()) state = 2;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}} */
	} else if (check(type,ev,"key","3")) {
		toggle_ds("3");
		toggle_ds("shift:3");
		/*
		int s = 3;
		if (_ctrl()) state = 3;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}} */
	} else if (check(type,ev,"key","4")) {
		toggle_ds("4");
		toggle_ds("shift:4");
		int s = 4;
		if (_ctrl()) state = 4;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}}
	} else if (check(type,ev,"key","5")) {
		int s = 5;
		if (_ctrl()) state = 5;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}}
	} else if (check(type,ev,"key","6")) {
		int s = 6;
		if (_ctrl()) state = 6;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}}
	} else if (check(type,ev,"key","7")) {
		int s = 7;
		if (_ctrl()) state = 7;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}}
	} else if (check(type,ev,"key","8")) {
		int s = 8;
		if (_ctrl()) state = 8;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}}
	} else if (check(type,ev,"key","9")) {
		int s = 9;
		if (_ctrl()) state = 9;  else {
			int x = _exclude[s];
			if (!x) {
				_exclude[s] = 1;
			} else {
				_exclude[s] = 0;
			}}

	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_tam::operator()()
{
  

//state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_tam::vip_tam(char* opts) 
{
	alternate = 0;
	txdur = 15;
	count = 12;
	_inexec = 0;
	_cmode = 'n';
	_lastc = 'n';
	//state = 2;

	_pcm = 0;
	_command[_pcm]='\0';

	ch();

_size = 20; //size;
wsprintf(_type,"scene");
_display = "toneelgroep amsterdam";

_sim->passivate(this);
_sim -> schedule(this,0.0);


end(20);
loop = 1;

//_tiny = new CCharacter();



//scenes[1] = new satelite();
//scenes[0] = new shader(new background(),"fx=back");
//scenes[0]->opt("shaders","material");



scene* scx = new mesh("knot");
//sc->_shader = "red";
//scenes[1] = sc;
//scenes[1] = new shader(sc,"fx=red"); 
scenes[1] = new shader(scx,"fx=red"); 
scene::declare("vip/knot",scenes[1]);

//scenes[1]->rotation(0.1,-0.1,0,1.0);
scenes[1]->translation(-3,-2,0);
scenes[1]->scale(5,5,5);

scenes[2] = new mesh("yt");
scenes[2] = new shader(new mesh("raven"),"fx=blue");
//scenes[2] = new shader(new mesh("poser-ae"),"fx=blue");
scenes[2]->translation(2.5,-2,-2);
scenes[2]->rotation(0,-2.57,0.2,1);
scenes[2]->scale(0.9,0.9,0.9);


//scenes[3] = new mesh("nana");
scenes[3] = new mesh("nana");
//scenes[3] = new vip_mesh();
scenes[3]->translation(2,-2,0);
scenes[3]->scale(1.5,1.5,1.5);
scenes[3]->rotation(0.0,1,0,0.5 * 3.14);

scenes[4] = sc("vip/morph"); //->create("text=text/tam");
scenes[5] = sc("lecture/tam");

scenes[11] = 0;

lst("text",sc("text/tam")->create());
_sim->schedule(lst("text"),0);



_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1;
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 1;
_exclude[7] = 1;
_exclude[8] = 1;
_exclude[9] = 1;
_exclude[10] = 1;



//scenes[2]->scale(0.3,0.3,0.3);




//scale(0.8,0.8,0.8);



 

 
  
}




vip_tam::~vip_tam()
{
//delete scenes[];
}

int 
vip_tam::_load()
{
    int hr = S_OK;
    //scenes[0] = sc("lecture/tam");
	scenes[6] = sc("vip/trio");
	scenes[7] = sc("anim/trio");
    scenes[8] = sc("effect/spectrum");
	scenes[8]->_blend = 1;
    scenes[10] = sc("vip/water");
	scenes[9] = sc("vip/flag");

	iopt("start",1);

	/*
	scene* x;
    x = new object_flag();
//x->rotation(0,1,0,0.5 * 3.14);
    x->scale(2.3,0.9,0.5);
    x->translation(0,-16.2,10); // no op
    x->_lights = 1;
    */

	scene* s = lst("text")->sc("slides");
	popt("slides",s);
	//scene* v = new video(s);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("video",s);
	s->iopt("tx",5);

    scene* x = sc("lecture/wave");//->create();
	x->iopt("tx",5);
	//v = new video(x);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("under",x);

	x = sc("scene/3")->create();
	//v = new video(x);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("back",x);
	x->iopt("tx",5);

	lst("trio", sc("vip/trio"));
	lst("running", sc("anim/trio"));

	lst("help",sc("text/help"));
	lst("knot",sc("vip/knot"));
	lst("flag",sc("vip/flag"));
	lst("morph",sc("vip/morph"));
	lst("water",sc("vip/water"));
	lst("spectrum",sc("effect/spectrum"));
	lst("spectrum")->_blend = 1;
	lst("x",sc("x/seafloor"));
	lst("dolphin",sc("vip/dolphin"));

	lst("scene:0",sc("scene/0"));
	lst("scene:1",sc("scene/1"));
	lst("scene:2",sc("scene/2"));
	lst("scene:3",sc("scene/3"));
	lst("scene:4",sc("scene/3x"));
	lst("scene:5",sc("scene/2")->create());

    lst("morph")->exclude(1);
	lst("morph")->exclude(1);
	lst("flag")->exclude(1);
	lst("water")->exclude(1);
	lst("spectrum")->exclude(1);
	lst("knot")->exclude(1);
	lst("x")->exclude(1);
	//lst("dolphin")->exclude(1);
	_lst = 1;
	//lst("morph")->exclude(1);
    
	dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];
	lst("dolphin",dolphin);
	//handle("key","n");
	//handle("key","r");
	//handle("key","a");
	//handle("key","n");

    //lst("slides")->exclude(0);
    //_cmode = 'n';
	exec("nran");

	hr = scene::init(_device); // loops through scenes

	//exec("nran");

	
    return hr;
}

int
vip_tam::_restore()
{
    HRESULT hr = S_OK;
    float txtime = txdur;
	if (ds("alternate")) {
	static float tm = dxtime();
	if ((dxtime() - tm) > txtime) { tm = dxtime(); scene::ds("flip",1); } //_main()->iopt("flip",2);  }
	}

	if (iopt("start")) { opt("start","0"); exec("start"); }

	if (0 && scenes[0]) {
		_handler(scenes[0]);
	} else {
		//_handler(this);
    }
	


    return hr;
}


int
vip_tam::_render( ) 
{
HRESULT hr = S_OK;
   
   
    dolphin->state = 1;
	
	//_tiny->Compose((DWORD) 1000 * fraction());
	scenes[1]->rotation(sin(dxtime()),sin(dxtime()),cos(dxtime()),1);
   

	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
  
	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		message(100,_y-200,argb(255,255,120,120),fm("%s [%d] (%c) ",_help,state,_cmode)); //,_command));
	} 
	
	

	display(_display);
    //dolphin->state = hold;
	render_end(_device);

 

    return hr;
}

