#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "tam.h"


int text_tam::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_tam::create(char* opts) { return new text_tam(opts); }

text_tam::text_tam(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("display","tam tam");
	opt("text(title)","  tam tam ");
	opt("text(sub)","    toneelgroep                        amsterdam");
	opt("space","vip/morph");

	//opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","d:\\vip\\media\tamtam.jpg");

	opt("logo(3d)","...");
	opt("logo(3ds)","tamtam");
	opt("logo(vip)","tamtam");

	sc("slides",new slides("..\\present\\tam","img0",1,3,"jpg"));

	// --------------------------------------------------------

	msg[5][11] = "http://www.toneelgroepamsterdam.nl";

   	msg[0][1] = "tamtam";
	msg[0][3] = "                     tamtam";
	msg[0][5] = "tamtam";
	msg[0][7] = "tamtam";
	msg[0][9] = "                     tamtam";
	msg[0][11] = "                     tamtam";
	


	msg[2][0] = "tam tam tam tam tam tam";
	msg[2][1] = " tam";
	msg[2][2] = "tam tam tam tam tam";
	msg[2][3] = " tam tam ";
	msg[2][4] = "tam tam tam tam ";
	msg[2][5] = " tam tam tam";
	msg[2][6] = "tam tam tam ";
	msg[2][7] = " tam tam tam tam";
	msg[2][8] = "tam tam";
	msg[2][9] = " tam tam tam tam tam";
	msg[2][10] = "tam";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "                                                 tam ";
	msg[3][3] = "                                        tam  ";
	msg[3][4] = "                               tam ";
	msg[3][7] = "                      tam ";
	msg[3][8] = "            tam ";
	msg[3][9] = "tam ";
	msg[3][11] = "                                                 tam  ";

	
	msg[4][1] = "      toneelgroep amsterdam";
	msg[4][4] = "      ism ...";	
	msg[4][9] = "      (c) vrije universiteit";
	//msg[4][9] = "                    (C) AE      ";



}

text_tam::~text_tam()
{
//delete scenes[];
}

int 
text_tam::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_tam::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_tam::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

