
#ifndef vip_x_h
#define vip_x_h

#include <hush/export.h>
#include "scene/scene.h"
#include <tchar.h>

#include "common90/d3d-util.h"

class vip_x : public scene  
{
public:

    vip_x(int size=16);

	int operator()();
	//vip_x(msg_array* m, int sz = 0, char* type ="vip_x", TCHAR* title = _T("select:"));
    virtual ~vip_x();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );

	scene* dolphin;
	struct D3DVERTEX
{
    D3DXVECTOR3 p;
    D3DXVECTOR3 n;
    FLOAT       tu, tv;

    static const DWORD FVF;
};

	    LPDIRECT3DVERTEXBUFFER9 m_ptorusVB;
    LPDIRECT3DINDEXBUFFER9  m_ptorusIB;
    DWORD                   m_dwNumtorusVertices;
    DWORD                   m_dwNumtorusFaces;
    LPDIRECT3DVERTEXDECLARATION9        m_ptorusVertexDeclaration;

	//int handle(char* type, char* ev);
protected:
int _cmi; // current message index
msg_array* _msg;
int g_ev;


  LPD3DXMESH          m_pMeshSysMem;      // system memory version of mesh, lives through resize's
    LPD3DXMESH          m_pMeshEnhanced;    // vid mem version of mesh that is enhanced
    UINT                m_dwNumSegs;        // number of segments per edge (tesselation level)
    D3DXMATERIAL*       m_pMaterials;       // pointer to material info in m_pbufMaterials
    LPDIRECT3DTEXTURE9* m_ppTextures;       // array of textures, entries are NULL if no texture specified
    DWORD               m_dwNumMaterials;   // number of materials

    BOOL                m_bShowHelp;
    CD3DFont*           m_pFont;
    CModelViewerCamera  m_Camera;          // mouse rotation utility
    D3DXVECTOR3         m_vObjectCenter;    // Center of bounding sphere of object
    FLOAT               m_fObjectRadius;    // Radius of bounding sphere of object

    LPD3DXBUFFER        m_pbufMaterials;    // contains both the materials data and the filename strings
    LPD3DXBUFFER        m_pbufAdjacency;    // Contains the adjacency info loaded with the mesh

    BOOL                m_bUseHWNPatches; 
    BOOL                m_bWireframe;


};
#endif 
