
#ifndef vip_mesh_h
#define vip_mesh_h

#include <hush/export.h>
#include "scene/scene.h"

#include <util/direct3d.h>


class vip_mesh : public scene  
{
public:

    vip_mesh(char* opts = 0);

	int operator()();
    virtual ~vip_mesh();
    virtual int _load();
	virtual int _restore();
    virtual int _render();

	int ch(char* x=0);

	int handle(char* type, char* ev);

	// Mesh collection and frame hierarchy
D3DXMESHCONTAINER_EX *g_Mesh;//  = NULL;
D3DXFRAME_EX         *g_Frame;// = NULL;

// Bounding radius of mesh
float g_MeshRadius;// = 0.0f;


};
#endif 
