#include <hush/dv/gl/glx/gl.h>
#include <hush/dv/gl/glx/glwin.h>
#include <hush/dv/gl/ogl/GL.h>
#include <hush/kit.h>
#include <hush/session.h>
#include <hush/handler.h>
#include <iostream.h>

#include <hush/gl/glob.h>
#include <hush/dv/gl/ogl/image.h>
#include <hush/dv/gl/ogl/handler.h>

extern "C" {

int load_gl() {
	//js_kit::initialize();
	GL::initialize();
	kit* tk = kit::lookup("tk");
	if (tk)
		init_gl(tk);
	else 
		cerr << "error loading gl" << endl;
	dv_glwin::initialize();
	glob* x = new dv_image();
	tk->_register(x);
	glob::_default = x;
	handler* h = new glob_handler();
	tk->_register(h);
	handler::declare("glob",h);
	//if (session::_trace)
		cerr << "Loading (dv)gl -- OpenGL " << endl;
	return 1;
	}

};

