//@ server.c -- adapted from Orbacus -- Hello World

#include <hush/dv/query/server.h>
#include <hush/corba/srv/query.h>

#include <hush/string.h>
#include <stdio.h>

//@ main -- offer services

server_query::server_query() {
	}

int server_query::operator()() {
	prepare();
	return OK;
	}


int server_query::prepare() {
    query_broker::prepare();
    try {
        hush_query* p = new query_srv(_kit,this); 
      
        char* base = option("base")?option("base"):"";
        char* ref = option("ref")?option("ref"):"query.out";

        _broker->refout(string(base) + ref, p);

        (*_broker)(); /// run
    }
    catch(corba::exception& ex)
    {
	_broker->print(ex);
	return 1;
    }

    return 0;
}


#ifndef NOMAIN
int main(int argc, char* argv[]) {
server* _server = new server();
_server->init(argc,argv);
(*_server)();
}
#endif

//</>
