HUSH = $Z
CFG  = $(HUSH)/cfg
  
include $(CFG)/install.mk
include $(CFG)/component.mk
			     
name = `$(HUSH)/bin/name`
objects = `$(HUSH)/bin/objects`
classes = `$(HUSH)/bin/classes`
			     
SLUSH = /home/eliens/hush/src/distribution/hush-4.0
DELTA = hush-hush-4.0
			     
version = -4.0
			     
category  = tk
kind      = component
type      = src 				
index      = -index -notitle
                               
document = /home/eliens/hush/online/hush/sources/hush/dv/tk/$(name)
destination = /home/eliens/hush/lib/hush/4.0/tk/$(name)
			     
extents      = Makefile makefile mkfile README TODO index COPYRIGHT *.txt *.mx *.l *.y *.tcl *.sh *.pl *.dlp *.tp *.th *.cl *.clips *.bx *.vr *.world *.in *.mk *.cfg *.js *.css *.py *.mod *.lr *.ami *.idl *.sc *.c *.cc *.cpp *.java *.h *.i *.ly \*.txt \*.mx \*.l \*.y \*.tcl \*.sh \*.pl \*.dlp \*.tp \*.th \*.cl \*.clips \*.bx \*.vr \*.world \*.in \*.mk \*.cfg \*.js \*.css \*.py \*.mod \*.lr \*.ami \*.idl \*.sc \*.c \*.cc \*.cpp \*.java \*.h \*.i \*.ly 
			     
config-cp = cp
install-cp = cp
doc-cp = cp
			     
config    = component
install   = component
clean     = component
doc       = cc generic
slush     = component
delta     = component
			     
no-config = false
no-install = false
no-clean = false
no-doc = false
no-slush = false
no-delta = false
			     
no-recursive-config = false
no-recursive-install = false
no-recursive-clean = false
no-recursive-doc = false
no-recursive-slush = true
no-recursive-delta = true
			     
package   = hush.dv.tk.$(name)
library   = libtk
script   = hush/dv/tk/$(name)
header   = hush/dv/tk/$(name)
                               
idl       = $(name)
                               
depth     = ../
			     
location  = hush/dv/tk/$(name)/
prefix    = dv-$(name)-
level     = ../../../../../../
server    = seabreeze/dv/tk/$(name)
			     
htflags   = 
			     
source    = hush/dv/tk/$(name)
			     
library = dummy

all: config it

CFLAGS += \
	-DTCL_LIBRARY="\"$(TCL_LIBRARY)\"" \
	-DTK_LIBRARY="\"$(TK_LIBRARY)\"" \
	-DHUSH_LIBRARY="\"$(HUSH_LIBRARY)\"" 

it:
	$(make) install
	cd ../share; $(make) install
