//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  VrmlNodeTexture.h

#ifndef  _VRMLNODETEXTURE_
#define  _VRMLNODETEXTURE_

#include "VrmlNode.h"


class VrmlNodeTexture : public VrmlNode {

public:

  // Define the fields of Texture nodes
  static VrmlNodeType *defineType(VrmlNodeType *t);

  VrmlNodeTexture(VrmlScene *s);
  virtual ~VrmlNodeTexture();

  virtual bool isTextureNode() const;

  virtual int nComponents() = 0;
  virtual int width() = 0;
  virtual int height() = 0;
  virtual int nFrames() = 0;
  virtual unsigned char* pixels() = 0;
};

#endif // _VRMLNODETEXTURE_

