#ifndef _CONFIG_H_
#define _CONFIG_H_
//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  config.h
//

#ifdef _WIN32

# define _ALGO_H_ <algorithm>
# define _FSTREAM_H_ <fstream>
# define _IOSTREAM_H_ <iostream>
# define _LIST_H_ <list>
# define _MAP_H_ <map>
# define _MULTIMAP_H_ <map>
# define _VECTOR_H_ <vector>

# define NAMESPACE using namespace std

# define M_PI 3.14168
# define M_PI_2 (M_PI/2.0)

// Disable warning messages about truncation from const double to float
# pragma warning( disable : 4305 )  
// Disable warning messages about truncating names in debug info
# pragma warning( disable : 4786 )  

#else

# define _ALGO_H_ <algo.h>
# define _FSTREAM_H_ <fstream.h>
# define _IOSTREAM_H_ <iostream.h>
# define _LIST_H_ <list.h>
# define _MAP_H_ <map.h>
# define _MULTIMAP_H_ <multimap.h>
# define _VECTOR_H_ <vector.h>

# define NAMESPACE

#endif
#endif

