#include <hush/source.h>

#include <hush/hush.h>
#include <hush/dv/vrml/kit.h>
#include <hush/agent/event.h>

#include <stdio.h>


static char result_buf[1084];

extern "C" {
char* vrml_js_call_hush(const char* s) {

cerr << "Going native with " << s << endl;
if (vrml_kit::_handlers) {
	handler* h = (*vrml_kit::_handlers)[(char*)s];
	if (!h) h = (*vrml_kit::_handlers)["hush"];
	if (h) {
		query_event* e = new query_event(0,"vrml","script",s);
		h->dispatch(e);
		if (e->_tell) {
			sprintf(result_buf,"%s",e->_tell);
			}
		delete e;
		}
} else {
	cerr << "vrml::hush " << s << endl; 
	sprintf(result_buf,"*hush*%s",s);
	}

return (char*) result_buf;
}
}
