#include <hush/dv/objects/event.h>
#include <hush/vm.h>
#include <stdlib.h>

int event_object::operator()() {
	//cerr << category() << "::operator()" << endl;
	event* e = _event;

	vm<event> self(e); 
	string method = e->_method();

	if (method == "arg" && e->argc() > 1) {
		char* res = self->arg( atoi(e->arg(1)) );
		e->result( res );
	} else if (method == "ask") {
		char* res = self->ask();
		e->result( res );
	} else {
		return handler_object::operator()();
	}

	return 0;
	}
