#include <hush/dv/objects/handler.h>
#include <hush/event.h>
#include <hush/vm.h>

int handler_object::operator()() {
	//cerr << category() << "::operator() " << _event->ask() << endl;
	event* e = _event;

	vm<event> self(e); 
	string method = e->_method();
	int argc = e->argc();
	//cerr << "handler_object::" << (char*) method << endl; 

	if (method == "handler") {
		;//cerr << "new: " << e->arg(1) << " " << e->arg(2) << endl;
	} else if (method == "option" && argc == 2) {
		result( self->option(e->arg(1)) );
	} else if (method == "option" && argc == 3) {
		self->option(e->arg(1),e->arg(2));
	} else {
		return obscure_object::operator()();
	}

	return 0;
	}
