#include <hush/source.h>
#include <hush/dv/objects/load.h>
#include <hush/dv/objects/objects.h>
#include <hush/session.h>
#include <hush/api/io.h>

extern "C" {

static int _loaded = 0;

int HUSH_API load_objects() {
	if (!_loaded) {
		_loaded = 1;
		kit* tk = kit::lookup("loading");
		init_objects(tk);
		cerr << "Loading (dv) objects " << endl;
	} else
		;//cerr << "Already loaded: (dv) objects " << endl;
	return 1;
   }

};

