#include <hush/dv/pl/swi.h>

static char *countnames[] =
{ "zero",
  "one",
  "two",
  "three",
  "four",
  "five",
  "six",
  "seven",
  "eight",
  "nine",
  "ten"
};


foreign_t swi_count(term_t hello, control_t h)
{ int n;
  term_t a = PL_new_term_ref();

  switch( PL_foreign_control(h) )
  { case PL_FIRST_CALL:
      n = 1;
      break;
    case PL_REDO:
      n = PL_foreign_context(h);
      break;
    case PL_CUTTED:
      return TRUE;
  }

  PL_put_atom_chars(a, countnames[n]);
  PL_unify(a, hello);

  if ( n <= 9 )
    PL_retry(n+1);

  return TRUE;
}

/*
install_t
install()
{ PL_register_foreign("count", 1, swi_count, PL_FA_NONDETERMINISTIC);
}
*/

