#include <hush/dv/scene/kit.h>
#include <hush/query.h>
#include <hush/agent.h>

#include <string.h>
#include <stdlib.h>

scene_kit::scene_kit() {
	_query = new query("kit=pl");
	agent::_default->lookin(LIBRARY);
	//_query->eval(":use(library(scene:[scene,lily,music,process]))");
	_register(_query);
	}

int scene_kit::source(const char* f) {
	return _query->source(f);
	}


long scene_kit::eval(const char* cmd) {
	return _query->eval(cmd);
	}

char* scene_kit::result(long id) {
	return _query->result(id);
	}

