#include <hush/source.h>
#include <hush/session.h>
#include <hush/dv/scene/kit.h>
#include <hush/scene.h>
//#include <dx/main/menu-media.h>
//#include <dx/main/menu-present.h>
//#include <dx/main/menu-dots.h>
//#include <dx/main/menu-vip.h>
//#include <dx/extra/object-flag.h>
//#include <dx/extra/object-dolphin.h>
#include <dx/scene/background.h>

#include <hush/io.h>
#include <hush/filters/nl.h>

//int IO::silent = 0;

extern "C" {

int HUSH_API load_scene() {
	kit* x = new scene_kit();
	scene* sc;

	scanner* l = new nl_lex();
	parser::declare("nl",l);
	scene::_log("nl created");
	//scene* sc = new object_flag();
	//scene::declare("flag",sc);
	/*
	sc = new menu_media();
	scene::declare("menu/media",sc);
	sc = new menu_present();
	scene::declare("menu/present",sc);
	sc = new menu_dots();
	scene::declare("menu/dots",sc);
	sc = new menu_vip();
	scene::declare("menu/vip",sc);
	//sc = new object_dolphin();
    //scene::declare("object/dolphin",sc);
	*/
	//sc = new background();
    //scene::declare("background",sc);
	if (session::get_default())
		session::get_default()->_register(x);
	kit::declare("scene",x);
	//if (session::_trace)
		cerr << "Loading (dv) scene " << endl;
	return 1;
	}

};
