%{
//@auto=0
//@class html-export
%}
%class lex
%p 10000
%e 1500
%{
#include <hush/grammar/lex.h>
int pr = 1;
char endline[1024];
int dp = 0;
%}
omit (include|ifndef|ifdef|define|endif)
%%@ rules
"section{"[ \t]* { if (pr) cout << "section{"; }
"chapter{"[ \t]* { if (pr) cout << "chapter{"; }
"part{"[ \t]* { if (pr) cout << "part{"; }
"paragraph{"[ \t]* { if (pr) cout << "paragraph{"; }
"<script"[^\>]*">" { pr = 0; }
"</script>"  { pr=1; }
\n { if (pr) cout << "\n"; }
\n(" "\n)+ { if (pr) cout << "\n" << endl; }
\t { if (pr) cout << "        "; }
. { if (pr) cout << yytext[0]; }
%%
//@ main
int main() {
lex l; l();
return 0;
}

char firstchar(char* s) {
while ( *s != 0 && ( *s == ' ' || *s == '\t' || *s == '\n' ) ) s++;
return *s;
}
//</>
