%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;
static int nol = 0;

#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <hush/iostream.h>

%}
%%@ rules
^"#@require " { cout << "#@extern "; }
^"#@require-".* { cout << yytext; }
"@vr-proto-"[a-zA-Z0-9\-\_]*".wrl" {
	char* p = yytext;
	while (*p != '\0') {
		if (*p == '-') *p = '/';
	p++;
	}
	cout << yytext;
	}
"@vr-extern-"[a-zA-Z0-9\-\_]*".wrl" {
	char* p = yytext;
	while (*p != '\0') {
		if (*p == '-') *p = '/';
	p++;
	}
	cout << yytext;
	}
\n { ECHO; }
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
//align = "BEGIN";
int _argc = 0;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
	argc--; argv++;
	}

l.paths(_argc, _argv);
pr = 1;
if ( argc == 1 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
cout << endl;
return 0;
}
//</>
