%{
//@auto=0
//@class mx-t
%}
%class lex
%p 10000
%e 1500
%{
#include <hush/hush.h>
#include <hush/grammar/lex.h>
int pr = 1;
char endline[1024];
int title = 0;
int in_tag = 0;
int in_slide = 0;
int in_heading = 0;
int slideno = 0;
%}
symbols ("&#34;")
%%@ rules
"<BODY bgcolor=\"#FFFFFF\" text=\"#000000\" vlink=\"#871F78\" link=\"#6666ff\">" {
	cout <<  "<body bgcolor=black text=silver link=lightgreen vlink=silver>";
	}
"Eliens" { cout << "Eli&euml;ns"; }
"&#34;" { cout << "\""; }
"&#60;"[\/a-zA-Z]+ {
	cout << "<" << yytext+5;
	in_tag = 1;
	}
"&#60;" { cout << "<"; }
"&#62;" {
	//if (in_tag)
	cout << ">";
	in_tag=0;
	}

"<h2>".* {
	yytext[yyleng-5]='\0';
	cout << "@+ " << yytext+4;
	}
^" <pre>" {
	 cout << "<slide color=green id=MXHUSHNAME-" << ++slideno
                     << " caption=\"Figure " << slideno << "\"><program>" << endl;

	 }
"</pre>" { cout << "</program></slide>"; }
^"<center><h1><font size=\"+3\"><p>" {
	if (!title) {
	 	cout << "<center>" << endl <<
                 "@* <font size=\"+3\"><p>" <<
		 "<a href=@talk-MXHUSHNAME.html target=_top>";
		title++;
		}
	else cout << yytext;
	} 
"<p></font></h2></center>" {
	if (title==1) {
		cout << "</a></p></font>" << endl << "</center>" << endl; 
		}
	}

"<hr size=1 noshade><table width=\"100%\"><tr><td align=right valign=top><font size=\"-1\"><i>" { 
	if (!in_slide && !in_heading) {
	        in_heading = 1;
		in_slide = 1;
	        cout << "<slide color=yellow id=MXHUSHNAME-" << ++slideno 
		     << " caption=\"Figure " << slideno << "\">" << endl;
	        cout << "<program>" << endl;
		cout << "     ///" ;
		} 
	else cout << yytext;
	}

[ \t\n]*"</i></font></td></tr></table>" {
	if (in_slide && in_heading) {
		cout << endl;
		in_heading = 0;
		}
	else cout << yytext;
	}

"<pre><font size=\"-1\" color=\"#505050\">" {
	if (in_slide) {
		//cout << "<display>"  << endl;
		}
	else cout << yytext;
	}

"<font color=\"8FBC8F\" size=\"-2\">" {
	cout << "<silver>";
	}

"xx%"[A-Za-z] {
	}

"</font></pre>" {
	if (in_slide) {
		in_slide=0;
		cout << "</program>" << "</slide>" << endl;
		}
	else cout << yytext;
	}
\n { in_tag=0; cout << endl; }
. { if (pr) cout << yytext[0]; }
%%
//@ main
int main() {
lex l; l();
return 0;
}

char firstchar(char* s) {
while ( *s != 0 && ( *s == ' ' || *s == '\t' || *s == '\n' ) ) s++;
return *s;
}
//</>
