#include <hush/source.h>
#include <hush/sys/io.h>
#include <hush/session.h>
#include <stdio.h>

int IO::_silent = 0;
IO* IO::_default = 0;

int IO::initialized = 0;

int IO::ok(){ return !_silent; }

int IO::initialize() {
	if (!IO::initialized) {
		IO* x = IO::_default = new IO;
		session::_default->_register(x);
		IO::initialized = 1;
		}
	return IO::initialized;
	}

static void doprint(const char* s) { fprintf(stderr,s); }

IO::IO() {
	_print = doprint;
	}

void IO::flush() { }
void IO::print(const char* s ) { 
	if (_print) _print(s); 
	}

void IO::print(ostream& fun(ostream&)) {
        print("\n");
	}
void IO::print(int n ) { 
	char buf[512];
	sprintf(buf,"%d",n);
	print(buf);
	}

void IO::print(void* x) { 
	char buf[512];
	sprintf(buf,"%x",(void*)x);
	print(buf);
	}

