#include <hush/source.h>

// light.c -- to clean it all up

#include "hush/sys/light.h"

#include <hush/hush.h>
#include <hush/garbage.h>

#include <hush/iter.h>
#include <hush/string.h>
#include <hush/dictionary.h>

#ifndef NOLIST
#include <hush/list.h>
#endif

#include <hush/sys/cell.h>

#include "hush/sys/local.i"
#include "hush/sys/macros.i"

light_garbage::light_garbage() {
ogarb = 0; tgarb = 0; agarb = 0; hgarb=0; sgarb=0; 
}

light_garbage::~light_garbage() {
  HUSHADELETE(agarb,char);
  HUSHDELETE(ogarb,obscure);
  HUSHDELETE(tgarb,term);
  HUSHDELETE(hgarb,handler);
  HUSHDELETE(sgarb,string);
  }

void light_garbage::_register(const obscure* h) { REGISTER(ogarb,h); }
void light_garbage::_register(const handler* h) { REGISTER(hgarb,h); }
void light_garbage::_register(const term* t) { REGISTER(tgarb,t); }
void light_garbage::_register(const char* a) { REGISTER(agarb,a); }
void light_garbage::_register(const string* s) { REGISTER(sgarb,s); } 
