#include <widgets/source.h>

#include <hush/widgets/browser.h>

char* browser::type() const { return "browser"; }

#define TYPE browser
#define ANCESTOR frame
#define OPTS "*"
#include "hush/widgets/create.i"


void browser::plugin(MIME* type, handler* v) {
	if (_exists()) _this()->plugin(type,v);
	else _error("plugin");
	}

void browser::plugin(char* type, handler* v) {
	if (_exists()) _this()->plugin(type,v);
	else _error("plugin");
	}

void browser::home(const char* url) {
	if (_exists()) _this()->home(url);
	else _error("home");
	}

void browser::load(const char* url) {
	if (_exists()) _this()->load(url);
	else _error("load");
	}


void browser::resize(int x, int y) {
	if (_exists()) _this()->geometry(x,y);
	else _error("geometry");
	}

void browser::geometry(int x, int y) {
	if (_exists()) _this()->geometry(x,y);
	else _error("geometry");
	}

handler* browser::urlhandler() {
	if (_exists()) return _this()->urlhandler();
	else return (handler*) _error("urlhandler");
	}
