#include <widgets/source.h>

#include <hush/widgets/radio.h>

char* radiobutton::type() const { return "radiobutton"; }

#define TYPE radiobutton
#define ANCESTOR button
#define OPTS "*"
#include "hush/widgets/create.i"


void radiobutton::variable(const char* name) {
	if (_exists()) _this()->variable(name);
	else _error("variable");
	}

char* radiobutton::value() const {
	if (_exists()) return _this()->value();
	else return (char*) _error("value");
	}


void radiobutton::toggle() {
	if (_exists()) _this()->toggle();
	else _error("toggle");
	}

void radiobutton::select() {
	if (_exists()) _this()->select();
	else _error("select");
	}

void radiobutton::deselect() {
	if (_exists()) _this()->deselect();
	else _error("deselect");
	}

/*
void radiobutton::init(const char* options) {
	if (_exists()) _this()->init();
	else _error("init");
	}
*/
