#include <hush/java.h>
#include <hush/kit.h>
#include <hush/session.h>

#include <hush/dv/pl/kit.h>
#include <hush/query.h>

#include <hush/io.h>

#undef string

#include <native/hush_dv_pl_kit.h>

#define method(X) Java_hush_dv_pl_kit_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj)
{
  if (env && obj); // Wall
  jint result = (jint) kit::lookup("pl"); // (jint) new kit();
  if (!result) {
	kit* x = kit::_default;
	if (!x) x = new kit();
	x->load("pl");
	x = kit::lookup("pl");
        if (!x) {
		//x = new pl_kit();
		cerr << "Error: no kit for (pl)" << endl;
		exit(1);
		}
	kit* y = new query("kit=pl");
	x->_register(y);
	if (y) (*y)();
	result = (jint) y;
	}
  return result;
}

