#include <hush/source.h>
#include <hush/widgets/tk/toplevel.h>


#define TYPE toplevel
#define CLASS tk_toplevel
#define OPTS 0
#include <hush/widgets/tk/create.i>

#include <stdio.h>



void CLASS::transient(const char* w) {
	sprintf(buf,"wm transient %s %s",path(),w);
	tk->eval( buf );
	}

void CLASS::position(int x, int y) { // also works for negative x,y
        sprintf(buf,"wm geometry %s %+d%+d",path(), x, y);
        tk->eval(buf);
        }

void CLASS::resize(int w, int h) {
        sprintf(buf,"wm geometry %s %dx%d",path(), w, h);
        tk->eval(buf);
}




void CLASS::init(const char* options) {
	widget::init(options);
	position();
	}
