include resource.mk

component = widgets

platform = `hush-platform`
destination = ../lib/$(platform)

x-test:
	echo SHARE=$(SHARE) 
	echo hush-share=`hush-share`

##ext = .o
##ext = .obj
CC = hush-cc - -v 
LD = hush-ld - -v dll=$(component) install=$(destination)

packages = 
objects = `objects $(component)-*.cpp` $(packages)
library = $(component)

purge = 

component-cflags = +hush +widgets
component-ldflags = +hush +widgets

make = $(MAKE) -f $(component).mk

##

all: purge compile link install

CFLAGS = $(component-cflags) 
LDFLAGS = $(component-ldflags) 

purge:

compile:; $(make) $(objects)

link:; $(LD) dll=$(library) $(objects) $(LDFLAGS)

static:; $(AR) $(library).a $(objects)

install:
	##cp $(library).so `hush-lib-platform`
	##cp $(library).so `hush-share`/lib


clean:; rm -f $(library).* $(component)*.o
