#!/bin/sh
##@ ciao-cql

. @BIN/ciao-env

##@ variables

mode=CC
cmd=
kind=""
output=

##@ options

while [ $# -ge 1 ]; do case $1 in
	-c)    mode=cc;;
	-cc)   mode=CC;;
	-I*)   cargs="$cargs $1";;
	-html) mode=html;;
	-url)  url=$2; shift;;
	-mode) mode=$2; shift;;
	-kind) kind="-k $2"; shift;;
	-cmd) cmd=$2; shift;;
	-db)     output=db;;
	-text)   output=text;;
	-graph)  output=graph;;
	-output) output=$2; shift;;
	-gif)  gif=gif;;
	-ps)  gif=ps;;
	*) break;;
	esac;
	shift;
done;

##@ process

CIAOLANG=$mode
CIAOTYPE=$mode

args=$*

$SHELL -c "$BIN/cql $cmd $mode $output $args" > @tmp-$$;
if [ "$gif" != "false" ]; then
	cat @tmp-$$ | $dot -T$gif
else
	cat @tmp-$$
fi;
##</>
