#!/bin/sh
##@ ciao-query

. @BIN/ciao-env

##@ variables

mode=CC
query=rset
kind=""
db=""

##@ options

while [ $# -ge 1 ]; do case $1 in
	-c)    mode=cc;;
	-cc)   mode=CC;;
	-I*)   cargs="$cargs $1";;
	-f)    db="-f $2"; shift;;
	-html) mode=html;;
	-url)  url=$2; shift;;
	-mode) mode=$2; shift;;
	-kind) kind="-k $2"; shift;;
	-query) query=$2; shift;;
	-text)   output=text;;
	-graph)  output=graph;;
	-output) output=$2; shift;;
	-gif)  gif=gif;;
	-ps)  gif=ps;;
	*) break;;
	esac;
	shift;
done;

##@ process

CIAOLANG=$mode
CIAOTYPE=$mode

args=$*

##echo $SHELL -c "$BIN/ciao_query_$mode $output $db $kind $query $args"
$SHELL -c "$BIN/ciao_query_$mode $db $kind $output $query $args" > @tmp-$$;
if [ "$gif" != "false" ]; then
	cat @tmp-$$ | $dot -T$gif
else
	cat @tmp-$$
fi;
##</>
