#!/bin/sh

##@ exec-pl

#base=`dirname $0`
#base= .
pl=pl

cmd=nl
src=
out=
err=
par=
echo=
halt=nl
program=

#echo "exec-pl: $*"

while [ $# -ge 1 ]; do case $1 in
	-echo) echo=echo;;
	-src|-f) src="$src load_files(['$2'],[silent(true)]),"; shift;;
	-program) program="load_files(['$2'],[silent(true)]),"; shift;;
	-cmd|-g*) if [ "-$2" != "-" ]; then
			cmd="$2";
		  fi; shift;;
	-cout|-out|-file) out=" > $2 "; shift;;
	-err|-cerr) err=" 2> $2 "; shift;;
	-par) par=" & ";shift;;
	-halt) if [ "-$2" != "-" ]; then
			halt="$2";
	       fi; shift;;
	-pl) pl=$2; shift;;
	*) ;;
	esac;
	shift;
done;

pld=@HUSH/library/pl
inith=$pld/hush.pl
cout="load_files(['$pld/cout.pl'],[silent(true)]),"

ldpath="assert(library_directory('@HUSH/library/pl'))"


#echo $pl -f $inith -g "$cout $ldpath,$src $program $cmd, $halt" -- $*  $out $err $par
$echo $pl -f $inith -g "$cout $ldpath,$src $program $cmd, $halt" -- $*
#
