#!/bin/sh

##@ exec-tcl

#base=`dirname $0`
#base= .
tcl=@SHARE/bin/tclsh8.0

cmd=
src=
out=
err=
par=
echo=
halt=
program=


while [ $# -ge 1 ]; do case $1 in
	-echo) echo=echo;;
	-src|-f) src="$src $2"; shift;;
	-program|-x) program="$program $2"; shift;;
	-c*|-g*) cmd="$cmd $2;"; shift;;
	-out|-file) out=" > $2 "; shift;;
	-err) err=" 2> $2 "; shift;;
	-par) par=" & ";shift;;
	-halt|halt) halt="";shift;;
	-tcl) tcl=$2; shift;;
	*) ;;
	esac;
	shift;
done;

tmp="@tmp-exec-tcl-$$"

echo " " > $tmp;

if [ "-$src" != "-" ]; then
	for i in $src; do
		echo "source $i" >> $tmp;
	done
fi;
if [ "-$program" != "-" ]; then
	for i in $program; do
		echo "source $i" >> $tmp;
	done
fi;
if [ "-$cmd" != "-" ]; then
		echo "$cmd" >> $tmp;
fi;
echo "exit;" >> $tmp;
$tcl $tmp;
##</>
