%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;

#include <hush/sys/unistd.h>
#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <iostream.h>

#define out if (pr) cout

static char name[64];
static int slino = 0;

void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	cout << "## DEPRECATED " << s << endl; 
	}

static int nl = 0;
%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@
%%@ rules
[ \t] { out << yytext; if (nl>100) { out << endl; nl=0; } }
"#".* { ECHO; }
"//".* { ECHO; }
\n { out << endl; }
. { ECHO; nl++; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
//align = "BEGIN";
strcpy(name,"temp");
int _argc = 0;
cerr << "ARGC " << argc << endl;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N' ) {
	strcpy(name,argv[0]+2);
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
        cerr << "ARGC " << argc << endl;
	argc--; argv++;
	}

cerr << "ARGC " << argc << endl;
l.paths(_argc, _argv);
pr = 1;
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
return 0;
}
//</>
