%{
//@auto=0
//@class ht-vr
%}
%class lex
%p 10000
%e 1500
%{
#include <hush/grammar/lex.h>
#define out if (pr) cout
int pr = 1;
char endline[1024];
int dp = 0;
%}
%%@ rules
^"<!--<control>--><hr><center><a".* { out << "</slide>"; }
"<c-nonum>" {}
"</c-nonum>" {}
"<math>" {}
"</math>" {}
"<!--" {}
"-->" {}
"<!--%" {}
"%-->" {}

^"<a name=".* {}
^"<hr><a name=".* {}

^"<p align=right><font color=red> <control><b></control> <!--\\fbox{-->" {
	out << "<box align=right>";
	}
"<control></b></control> <!--}--> </font></p><br>" {
	out << "</box>" << endl;
	}

"<html>" { pr = 0; } 
"</html>" { pr = 1; } 

"</body></document>" { out << "</world>"; }

"<display><pre>" { out << "<text mode=display>"; }
"</pre></display>" { out << "</text>"; }


"<em>"|"</em>"|"<center>"|"</center>"|"<p>" {}
. { out << yytext[0]; }
%%
//@ main
int main() {
lex l; l();
return 0;
}

char firstchar(char* s) {
while ( *s != 0 && ( *s == ' ' || *s == '\t' || *s == '\n' ) ) s++;
return *s;
}
//</>
