%{
//@auto=0
//@class html-txt
%}
%class lex
%p 10000
%e 1500
%{
#include <hush/grammar/lex.h>
int pr = 1;
char endline[1024];
int dp = 0;
%}
omit (include|ifndef|ifdef|define|endif)
%%@ rules
\n { if (pr) cout << "\n"; }
"<!--" { pr = 0; }
"-->" { pr = 1; }
"<ref>" { if (pr) cout << "See "; }
"<h1>"  { if (pr) cout << "Section: "; }
"<h2>"  { if (pr) cout << "Subsection: "; }
^\%\%.*\n { }
"&euml;" { if (pr) cout << "e"; }
"&aelig;" { if (pr) cout << "ae"; }
"&lt;" { if (pr) cout << "<"; }
"&gt;" { if (pr) cout << ">"; }
"&nbsp;" { }
"#"{omit}.*\n { };
"<hr>" { if (pr) cout << "\n-------------------------------------" << endl; }
"<"[a-zA-Z]+[^\>]*">" { }
"</"[a-zA-Z]+[^\>]*">" { }
\n(" "\n)+ { if (pr) cout << "\n" << endl; }
\n\n* { if (pr) cout << "\n" << endl; }
\t { if (pr) cout << "        "; }
. { if (pr) cout << yytext[0]; }
%%
//@ main
int main() {
lex l; l();
return 0;
}

char firstchar(char* s) {
while ( *s != 0 && ( *s == ' ' || *s == '\t' || *s == '\n' ) ) s++;
return *s;
}
//</>
