%{
//@auto=0
//@class txt-t
%}
%class lex
%p 10000
%e 1500
%{
#include <hush/shell.h>
#include <hush/grammar/lex.h>
int pr = 1;
char endline[1024];
int dp = 0;
%}
%%@ rules
"\$"[A-Za-z\-]+ { if (pr) cout << "<b>" << yytext << "</b>"; }
"\$("[A-Za-z\-]+")" { yytext[yyleng-1]='\0'; 
	if (pr) cout << "<b>" << yytext+2 << "</b>"; }
"<a href="[^>]+">" { if (pr) cout << yytext; }
\n { if (pr) cout << "\n"; }
\n\n { 
     if (!dp && pr) cout << "<p>" << endl; 
     else if (dp && pr) cout << "\n" << endl;
     }
\n\n\n {
	if (!dp) dp=1; else dp=0;
	if (dp && pr) cout << "\n<display>\n" << endl;
	else if (!dp && pr) cout << "\n</display>\n" << endl;
	}
\t { if (pr) cout << "        "; }
. { if (pr) cout << yytext[0]; }
%%
//@ main
int main() {
cout << "<document>";
lex l; l();
cout << "</document>" << endl;
return 0;
}

char firstchar(char* s) {
while ( *s != 0 && ( *s == ' ' || *s == '\t' || *s == '\n' ) ) s++;
return *s;
}
//</>
